/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 50 "conf/gen_parser.m4" /* yacc.c:339  */

#line 9 "conf/confbase.Y"
/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/bfd.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

#define cf_assert(cond, ...) do { if (!(cond)) cf_error(__VA_ARGS__); } while (0)
static inline void cf_assert_symbol(const struct symbol *sym, uint class) {
  switch (class) {
    case SYM_PROTO: cf_assert(sym->class == SYM_PROTO, "Protocol name required"); break;
    case SYM_TEMPLATE: cf_assert(sym->class == SYM_TEMPLATE, "Protocol template name required"); break;
    case SYM_FUNCTION: cf_assert(sym->class == SYM_FUNCTION, "Function name required"); break;
    case SYM_FILTER: cf_assert(sym->class == SYM_FILTER, "Filter name required"); break;
    case SYM_TABLE: cf_assert(sym->class == SYM_TABLE, "Table name required"); break;
    case SYM_ATTRIBUTE: cf_assert(sym->class == SYM_ATTRIBUTE, "Custom attribute name required"); break;
    case SYM_VARIABLE: cf_assert((sym->class & ~0xff) == SYM_VARIABLE, "Variable name required"); break;
    case SYM_CONSTANT: cf_assert((sym->class & ~0xff) == SYM_CONSTANT, "Constant name required"); break;
    default: bug("This shall not happen");
  }
}

#line 9 "conf/flowspec.Y"
/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


#line 11 "filter/config.Y"
/* Headers from filter/config.Y */

#include "filter/f-inst.h"
#include "filter/data.h"

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }

#define f_generate_complex(fi_code, da, arg) \
  f_new_inst(FI_EA_SET, f_new_inst(fi_code, f_new_inst(FI_EA_GET, da), arg), da)

/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_val empty;

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      empty = f_const_empty_path;
      break;
    case EAF_TYPE_INT_SET:
      empty = f_const_empty_clist;
      break;
    case EAF_TYPE_EC_SET:
      empty = f_const_empty_eclist;
      break;
    case EAF_TYPE_LC_SET:
      empty = f_const_empty_lclist;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  return f_new_inst(FI_EA_SET, f_new_inst(FI_CONSTANT, empty), dyn);
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  return f_new_inst(FI_ASSERT, expr,
    (end >= start) ?
      assert_copy_expr(start, end - start + 1)
    : "???");
}

static struct f_inst *
assert_assign(struct f_lval *lval, struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *setter, *getter, *checker;
  switch (lval->type) {
    case F_LVAL_VARIABLE:
      setter = f_new_inst(FI_VAR_SET, expr, lval->sym);
      getter = f_new_inst(FI_VAR_GET, lval->sym);
      break;
    case F_LVAL_PREFERENCE:
      setter = f_new_inst(FI_PREF_SET, expr);
      getter = f_new_inst(FI_PREF_GET);
      break;
    case F_LVAL_SA:
      setter = f_new_inst(FI_RTA_SET, expr, lval->sa);
      getter = f_new_inst(FI_RTA_GET, lval->sa);
      break;
    case F_LVAL_EA:
      setter = f_new_inst(FI_EA_SET, expr, lval->da);
      getter = f_new_inst(FI_EA_GET, lval->da);
      break;
    default:
      bug("Unknown lval type");
  }

  checker = f_new_inst(FI_EQ, expr, getter);
  setter->next = checker;
  
  return assert_done(setter, start, end);
}

#line 10 "nest/config.Y"
/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct rtable_config *this_table;
static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct bfd_options *this_bfd_opts;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}

static inline void
init_password_list(void)
{
   if (!this_p_list) {
      this_p_list = cfg_allocz(sizeof(list));
      init_list(this_p_list);
      password_id = 1;
   }
}

static inline void
init_password(const void *key, uint length, uint id)
{
   this_p_item = cfg_allocz(sizeof (struct password_item));
   this_p_item->password = key;
   this_p_item->length = length;
   this_p_item->genfrom = 0;
   this_p_item->gento = TIME_INFINITY;
   this_p_item->accfrom = 0;
   this_p_item->accto = TIME_INFINITY;
   this_p_item->id = id;
   this_p_item->alg = ALG_UNDEFINED;
   add_tail(this_p_list, &this_p_item->n);
}

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static inline void
init_bfd_opts(struct bfd_options **opts)
{
  cf_check_bfd(1);

  if (! *opts)
    *opts = bfd_new_options();
}

static inline void
open_bfd_opts(struct bfd_options **opts)
{
  init_bfd_opts(opts);
  this_bfd_opts = *opts;
}

static inline void
close_bfd_opts(void)
{
  this_bfd_opts = NULL;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

#line 8 "proto/bfd/config.Y"
/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

#line 13 "proto/babel/config.Y"
/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

#line 9 "proto/bgp/config.Y"
/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

#line 10 "proto/mrt/config.Y"
/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

#line 9 "proto/ospf/config.Y"
/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (! proto_cf_main_channel(this_proto))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


#line 9 "proto/perf/config.Y"
/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

#line 9 "proto/pipe/config.Y"
/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

#line 10 "proto/radv/config.Y"
/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


#line 12 "proto/rip/config.Y"
/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


#line 9 "proto/rpki/config.Y"
/* Headers from proto/rpki/config.Y */

#include "proto/rpki/rpki.h"

/* Defines from proto/rpki/config.Y */

#define RPKI_CFG ((struct rpki_config *) this_proto)
#define RPKI_TR_SSH_CFG ((struct rpki_tr_ssh_config *) RPKI_CFG->tr_config.spec)

static void
rpki_check_unused_hostname(void)
{
  if (RPKI_CFG->hostname != NULL)
    cf_error("Only one cache server per protocol allowed");
}

static void
rpki_check_unused_transport(void)
{
  if (RPKI_CFG->tr_config.spec != NULL)
    cf_error("At the most one transport per protocol allowed");
}

#line 9 "proto/static/config.Y"
/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst *this_srt_cmds, *this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");

  this_srt->cmds = f_linearize(this_srt_cmds);
}

#line 9 "sysdep/linux/netlink.Y"
/* Headers from sysdep/linux/netlink.Y */

#line 9 "sysdep/unix/config.Y"
/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;

#line 9 "sysdep/unix/krt.Y"
/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}

#line 50 "conf/gen_parser.m4"

#line 889 "obj/conf/cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    IP4 = 272,
    IP6 = 273,
    VPN_RD = 274,
    CF_SYM_KNOWN = 275,
    CF_SYM_UNDEFINED = 276,
    TEXT = 277,
    BYTESTRING = 278,
    PREFIX_DUMMY = 279,
    NMA = 280,
    DEFINE = 281,
    ON = 282,
    OFF = 283,
    YES = 284,
    NO = 285,
    S = 286,
    MS = 287,
    US = 288,
    PORT = 289,
    VPN = 290,
    MPLS = 291,
    FROM = 292,
    FLOW4 = 293,
    FLOW6 = 294,
    DST = 295,
    SRC = 296,
    PROTO = 297,
    NEXT = 298,
    HEADER = 299,
    DPORT = 300,
    SPORT = 301,
    ICMP = 302,
    TYPE = 303,
    CODE = 304,
    TCP = 305,
    FLAGS = 306,
    LENGTH = 307,
    DSCP = 308,
    DONT_FRAGMENT = 309,
    IS_FRAGMENT = 310,
    FIRST_FRAGMENT = 311,
    LAST_FRAGMENT = 312,
    FRAGMENT = 313,
    LABEL = 314,
    OFFSET = 315,
    QUIT = 316,
    EXIT = 317,
    HELP = 318,
    FUNCTION = 319,
    PRINT = 320,
    PRINTN = 321,
    UNSET = 322,
    RETURN = 323,
    ACCEPT = 324,
    REJECT = 325,
    ERROR = 326,
    INT = 327,
    BOOL = 328,
    IP = 329,
    PREFIX = 330,
    RD = 331,
    PAIR = 332,
    QUAD = 333,
    EC = 334,
    LC = 335,
    SET = 336,
    STRING = 337,
    BGPMASK = 338,
    BGPPATH = 339,
    CLIST = 340,
    ECLIST = 341,
    LCLIST = 342,
    IF = 343,
    THEN = 344,
    ELSE = 345,
    CASE = 346,
    TRUE = 347,
    FALSE = 348,
    RT = 349,
    RO = 350,
    UNKNOWN = 351,
    GENERIC = 352,
    GW = 353,
    NET = 354,
    MASK = 355,
    SOURCE = 356,
    SCOPE = 357,
    DEST = 358,
    IFNAME = 359,
    IFINDEX = 360,
    WEIGHT = 361,
    GW_MPLS = 362,
    PREFERENCE = 363,
    ROA_CHECK = 364,
    ASN = 365,
    IS_V4 = 366,
    IS_V6 = 367,
    LEN = 368,
    MAXLEN = 369,
    DATA = 370,
    DATA1 = 371,
    DATA2 = 372,
    DEFINED = 373,
    ADD = 374,
    DELETE = 375,
    CONTAINS = 376,
    RESET = 377,
    PREPEND = 378,
    FIRST = 379,
    LAST = 380,
    LAST_NONAGGREGATED = 381,
    MATCH = 382,
    MIN = 383,
    MAX = 384,
    EMPTY = 385,
    FILTER = 386,
    WHERE = 387,
    EVAL = 388,
    ATTRIBUTE = 389,
    BT_ASSERT = 390,
    BT_TEST_SUITE = 391,
    BT_CHECK_ASSIGN = 392,
    BT_TEST_SAME = 393,
    FORMAT = 394,
    ROUTER = 395,
    ID = 396,
    HOSTNAME = 397,
    PROTOCOL = 398,
    TEMPLATE = 399,
    DISABLED = 400,
    DEBUG = 401,
    ALL = 402,
    DIRECT = 403,
    INTERFACE = 404,
    IMPORT = 405,
    EXPORT = 406,
    NONE = 407,
    VRF = 408,
    DEFAULT = 409,
    TABLE = 410,
    STATES = 411,
    ROUTES = 412,
    FILTERS = 413,
    IPV4 = 414,
    IPV6 = 415,
    VPN4 = 416,
    VPN6 = 417,
    ROA4 = 418,
    ROA6 = 419,
    SADR = 420,
    RECEIVE = 421,
    LIMIT = 422,
    ACTION = 423,
    WARN = 424,
    BLOCK = 425,
    RESTART = 426,
    DISABLE = 427,
    KEEP = 428,
    FILTERED = 429,
    RPKI = 430,
    PASSWORD = 431,
    KEY = 432,
    PASSIVE = 433,
    TO = 434,
    EVENTS = 435,
    PACKETS = 436,
    PROTOCOLS = 437,
    CHANNELS = 438,
    INTERFACES = 439,
    ALGORITHM = 440,
    KEYED = 441,
    HMAC = 442,
    MD5 = 443,
    SHA1 = 444,
    SHA256 = 445,
    SHA384 = 446,
    SHA512 = 447,
    BLAKE2S128 = 448,
    BLAKE2S256 = 449,
    BLAKE2B256 = 450,
    BLAKE2B512 = 451,
    PRIMARY = 452,
    STATS = 453,
    COUNT = 454,
    BY = 455,
    FOR = 456,
    IN = 457,
    COMMANDS = 458,
    PREEXPORT = 459,
    NOEXPORT = 460,
    EXPORTED = 461,
    GENERATE = 462,
    BGP = 463,
    PASSWORDS = 464,
    DESCRIPTION = 465,
    RELOAD = 466,
    OUT = 467,
    MRTDUMP = 468,
    MESSAGES = 469,
    RESTRICT = 470,
    MEMORY = 471,
    IGP_METRIC = 472,
    CLASS = 473,
    TIMEFORMAT = 474,
    ISO = 475,
    SHORT = 476,
    LONG = 477,
    ROUTE = 478,
    BASE = 479,
    LOG = 480,
    GRACEFUL = 481,
    WAIT = 482,
    FLUSH = 483,
    AS = 484,
    IDLE = 485,
    RX = 486,
    TX = 487,
    INTERVAL = 488,
    MULTIPLIER = 489,
    CHECK = 490,
    LINK = 491,
    SORTED = 492,
    TRIE = 493,
    SETTLE = 494,
    TIME = 495,
    IPV4_MC = 496,
    IPV4_MPLS = 497,
    IPV6_MC = 498,
    IPV6_MPLS = 499,
    IPV6_SADR = 500,
    VPN4_MC = 501,
    VPN4_MPLS = 502,
    VPN6_MC = 503,
    VPN6_MPLS = 504,
    PRI = 505,
    SEC = 506,
    SHOW = 507,
    STATUS = 508,
    SUMMARY = 509,
    SYMBOLS = 510,
    DUMP = 511,
    RESOURCES = 512,
    SOCKETS = 513,
    NEIGHBORS = 514,
    ATTRIBUTES = 515,
    ECHO = 516,
    ENABLE = 517,
    BFD = 518,
    MULTIHOP = 519,
    NEIGHBOR = 520,
    DEV = 521,
    LOCAL = 522,
    AUTHENTICATION = 523,
    SIMPLE = 524,
    METICULOUS = 525,
    SESSIONS = 526,
    BABEL = 527,
    METRIC = 528,
    RXCOST = 529,
    HELLO = 530,
    UPDATE = 531,
    WIRED = 532,
    WIRELESS = 533,
    BUFFER = 534,
    PRIORITY = 535,
    HOP = 536,
    BABEL_METRIC = 537,
    ENTRIES = 538,
    RANDOMIZE = 539,
    MAC = 540,
    PERMISSIVE = 541,
    HOLD = 542,
    CONNECT = 543,
    RETRY = 544,
    KEEPALIVE = 545,
    STARTUP = 546,
    VIA = 547,
    SELF = 548,
    PATH = 549,
    START = 550,
    DELAY = 551,
    FORGET = 552,
    AFTER = 553,
    BGP_PATH = 554,
    BGP_LOCAL_PREF = 555,
    BGP_MED = 556,
    BGP_ORIGIN = 557,
    BGP_NEXT_HOP = 558,
    BGP_ATOMIC_AGGR = 559,
    BGP_AGGREGATOR = 560,
    BGP_COMMUNITY = 561,
    BGP_EXT_COMMUNITY = 562,
    BGP_LARGE_COMMUNITY = 563,
    ADDRESS = 564,
    RR = 565,
    RS = 566,
    CLIENT = 567,
    CLUSTER = 568,
    AS4 = 569,
    ADVERTISE = 570,
    CAPABILITIES = 571,
    PREFER = 572,
    OLDER = 573,
    MISSING = 574,
    LLADDR = 575,
    DROP = 576,
    IGNORE = 577,
    REFRESH = 578,
    INTERPRET = 579,
    COMMUNITIES = 580,
    BGP_ORIGINATOR_ID = 581,
    BGP_CLUSTER_LIST = 582,
    IGP = 583,
    GATEWAY = 584,
    RECURSIVE = 585,
    MED = 586,
    TTL = 587,
    SECURITY = 588,
    DETERMINISTIC = 589,
    SECONDARY = 590,
    ALLOW = 591,
    PATHS = 592,
    AWARE = 593,
    EXTENDED = 594,
    SETKEY = 595,
    STRICT = 596,
    BIND = 597,
    CONFEDERATION = 598,
    MEMBER = 599,
    MULTICAST = 600,
    LIVED = 601,
    STALE = 602,
    IBGP = 603,
    EBGP = 604,
    MANDATORY = 605,
    INTERNAL = 606,
    EXTERNAL = 607,
    SETS = 608,
    DYNAMIC = 609,
    RANGE = 610,
    NAME = 611,
    DIGITS = 612,
    BGP_AIGP = 613,
    AIGP = 614,
    ORIGINATE = 615,
    COST = 616,
    ENFORCE = 617,
    FREE = 618,
    VALIDATE = 619,
    CEASE = 620,
    HIT = 621,
    ADMINISTRATIVE = 622,
    SHUTDOWN = 623,
    PEER = 624,
    CONFIGURATION = 625,
    CHANGE = 626,
    DECONFIGURED = 627,
    CONNECTION = 628,
    REJECTED = 629,
    COLLISION = 630,
    OF = 631,
    MRT = 632,
    FILENAME = 633,
    PERIOD = 634,
    ALWAYS = 635,
    OSPF = 636,
    V2 = 637,
    V3 = 638,
    OSPF_METRIC1 = 639,
    OSPF_METRIC2 = 640,
    OSPF_TAG = 641,
    OSPF_ROUTER_ID = 642,
    AREA = 643,
    RFC1583COMPAT = 644,
    STUB = 645,
    TICK = 646,
    COST2 = 647,
    RETRANSMIT = 648,
    TRANSMIT = 649,
    DEAD = 650,
    BROADCAST = 651,
    BCAST = 652,
    NONBROADCAST = 653,
    NBMA = 654,
    POINTOPOINT = 655,
    PTP = 656,
    POINTOMULTIPOINT = 657,
    PTMP = 658,
    CRYPTOGRAPHIC = 659,
    ELIGIBLE = 660,
    POLL = 661,
    NETWORKS = 662,
    HIDDEN = 663,
    VIRTUAL = 664,
    ONLY = 665,
    LARGE = 666,
    NORMAL = 667,
    STUBNET = 668,
    TAG = 669,
    LSADB = 670,
    ECMP = 671,
    NSSA = 672,
    TRANSLATOR = 673,
    STABILITY = 674,
    GLOBAL = 675,
    LSID = 676,
    INSTANCE = 677,
    REAL = 678,
    NETMASK = 679,
    MERGE = 680,
    LSA = 681,
    SUPPRESSION = 682,
    RFC5838 = 683,
    PE = 684,
    TOPOLOGY = 685,
    STATE = 686,
    PERF = 687,
    EXP = 688,
    REPEAT = 689,
    THRESHOLD = 690,
    MODE = 691,
    PIPE = 692,
    RADV = 693,
    RA = 694,
    SOLICITED = 695,
    UNICAST = 696,
    MANAGED = 697,
    OTHER = 698,
    CONFIG = 699,
    LINGER = 700,
    MTU = 701,
    REACHABLE = 702,
    RETRANS = 703,
    TIMER = 704,
    CURRENT = 705,
    VALID = 706,
    PREFERRED = 707,
    MULT = 708,
    LIFETIME = 709,
    SKIP = 710,
    ONLINK = 711,
    AUTONOMOUS = 712,
    RDNSS = 713,
    DNSSL = 714,
    NS = 715,
    DOMAIN = 716,
    TRIGGER = 717,
    SENSITIVE = 718,
    LOW = 719,
    MEDIUM = 720,
    HIGH = 721,
    PROPAGATE = 722,
    RA_PREFERENCE = 723,
    RA_LIFETIME = 724,
    RIP = 725,
    NG = 726,
    INFINITY = 727,
    TIMEOUT = 728,
    GARBAGE = 729,
    VERSION = 730,
    SPLIT = 731,
    HORIZON = 732,
    POISON = 733,
    REVERSE = 734,
    ZERO = 735,
    PLAINTEXT = 736,
    DEMAND = 737,
    CIRCUIT = 738,
    RIP_METRIC = 739,
    RIP_TAG = 740,
    REMOTE = 741,
    BIRD = 742,
    PRIVATE = 743,
    PUBLIC = 744,
    SSH = 745,
    TRANSPORT = 746,
    USER = 747,
    EXPIRE = 748,
    STATIC = 749,
    PROHIBIT = 750,
    BLACKHOLE = 751,
    UNREACHABLE = 752,
    KERNEL = 753,
    NETLINK = 754,
    KRT_PREFSRC = 755,
    KRT_REALM = 756,
    KRT_SCOPE = 757,
    KRT_MTU = 758,
    KRT_WINDOW = 759,
    KRT_RTT = 760,
    KRT_RTTVAR = 761,
    KRT_SSTRESH = 762,
    KRT_CWND = 763,
    KRT_ADVMSS = 764,
    KRT_REORDERING = 765,
    KRT_HOPLIMIT = 766,
    KRT_INITCWND = 767,
    KRT_RTO_MIN = 768,
    KRT_INITRWND = 769,
    KRT_QUICKACK = 770,
    KRT_LOCK_MTU = 771,
    KRT_LOCK_WINDOW = 772,
    KRT_LOCK_RTT = 773,
    KRT_LOCK_RTTVAR = 774,
    KRT_LOCK_SSTRESH = 775,
    KRT_LOCK_CWND = 776,
    KRT_LOCK_ADVMSS = 777,
    KRT_LOCK_REORDERING = 778,
    KRT_LOCK_HOPLIMIT = 779,
    KRT_LOCK_RTO_MIN = 780,
    KRT_FEATURE_ECN = 781,
    KRT_FEATURE_ALLFRAG = 782,
    SYSLOG = 783,
    TRACE = 784,
    INFO = 785,
    WARNING = 786,
    AUTH = 787,
    FATAL = 788,
    BUG = 789,
    STDERR = 790,
    SOFT = 791,
    CONFIRM = 792,
    UNDO = 793,
    LATENCY = 794,
    WATCHDOG = 795,
    CONFIGURE = 796,
    DOWN = 797,
    PERSIST = 798,
    SCAN = 799,
    LEARN = 800,
    DEVICE = 801,
    KRT_SOURCE = 802,
    KRT_METRIC = 803
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 54 "conf/confbase.Y" /* yacc.c:355  */

  uint i;
  u32 i32;
  u64 i64;
  ip_addr a;
  ip4_addr ip4;
  ip6_addr ip6;
  net_addr net;
  net_addr *net_ptr;
  struct symbol *s;
  const char *t;
  struct rtable_config *r;
  struct channel_config *cc;
  struct channel *c;
  struct f_inst *x;
  struct {
    struct f_inst *begin, *end;
  } xp;
  enum filter_return fret;
  enum ec_subtype ecs;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct f_lval flv;
  struct f_line *fl;
  const struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct password_item *p;
  struct rt_show_data *ra;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  void *g;
  btime time;
  struct f_prefix px;
  struct proto_spec ps;
  struct channel_limit cl;
  struct timeformat *tf;
  mpls_label_stack *mls;
  struct bytestring *bs;

#line 1522 "obj/conf/cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_OBJ_CONF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1539 "obj/conf/cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  79
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6382

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  570
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  427
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1453
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2669

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   803

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    35,     2,     2,     2,    34,     2,     2,
     561,   562,    32,    30,   563,    31,    36,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   566,   560,
      26,    25,    27,   569,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   567,     2,   568,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   564,     2,   565,    28,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      29,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   136,   136,   137,   140,   142,   145,   150,   153,   161,
     162,   163,   169,   170,   171,   174,   174,   179,   180,   181,
     182,   183,   184,   191,   192,   193,   200,   201,   208,   214,
     224,   237,   256,   262,   268,   276,   284,   290,   290,   291,
     291,   292,   292,   295,   296,   297,   298,   299,   300,   307,
     308,   316,   317,   325,   326,   334,   335,   336,   337,   338,
     348,   356,   357,   366,   374,   375,   382,   383,    37,    38,
      39,    40,    41,    42,    43,    44,    48,    49,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    65,    66,
      67,    70,    71,    75,    79,    83,    84,    88,    92,   101,
     102,   106,   110,   114,   121,   122,   126,   127,   128,   129,
     133,   136,   139,   145,   149,   150,   151,   155,   159,   165,
     166,   167,   170,   172,   175,   177,   181,   188,   189,   191,
     197,   203,   203,     9,     9,    10,    10,    11,    11,   317,
     319,   319,   329,   331,   334,   335,   339,   341,   352,   354,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   405,   407,   414,   415,
     422,   423,   429,   432,   436,   444,   451,   457,   459,   459,
     472,   473,   476,   484,   485,   499,   502,   511,   512,   525,
     526,   527,   528,   529,   533,   541,   542,   543,   544,   548,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     565,   566,   567,   568,   572,   573,   574,   578,   579,   580,
     581,   582,   583,   584,   585,   590,   591,   592,   593,   594,
     598,   599,   600,   601,   602,   606,   607,   611,   612,   616,
     617,   618,   619,   627,   628,   631,   632,   640,   650,   651,
     655,   659,   660,   661,   665,   666,   667,   668,   669,   673,
     674,   675,   676,   677,   678,   679,   680,   685,   686,   690,
     691,   692,   693,   698,   699,   700,   703,   727,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   756,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   778,   779,   780,   782,
     784,   786,   788,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     815,   816,   817,   818,   819,   820,   821,   822,   824,   825,
     827,   831,   835,   836,   837,   840,   841,   842,   851,   854,
     857,   869,   873,   876,   881,   884,   887,   898,   902,   905,
     906,   910,   911,   912,   913,   914,   915,   916,   920,   925,
     926,   927,   928,   159,   162,   163,   167,   168,   169,   170,
     180,   182,   184,   186,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   209,   211,   213,   218,   220,   224,
     225,   230,   231,   234,   236,   239,   241,   247,   250,   251,
     255,   261,   265,   275,   285,   287,   288,   289,   290,   291,
     292,   293,   297,   303,   308,   309,   310,   311,   312,   313,
     314,   315,   320,   321,   324,   326,   329,   331,   335,   342,
     345,   348,   349,   350,   351,   355,   356,   357,   358,   359,
     363,   364,   368,   371,   372,   373,   378,   381,   382,   383,
     384,   388,   389,   390,   391,   392,   393,   394,   395,   399,
     406,   414,   415,   419,   420,   424,   429,   430,   434,   436,
     444,   448,   449,   454,   456,   463,   464,   465,   466,   467,
     471,   479,   485,   486,   487,   491,   492,   496,   497,   498,
     499,   500,   501,   507,   508,   509,   513,   514,   518,   519,
     525,   529,   530,   533,   535,   539,   540,   543,   543,   546,
     547,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   580,   588,   589,   590,   591,   592,
     593,   594,   597,   599,   603,   609,   609,   612,   612,   615,
     615,   618,   618,   622,   623,   626,   626,   629,   629,   633,
     633,   637,   643,   649,   655,   662,   668,   675,   680,   685,
     690,   695,   699,   703,   707,   717,   724,   733,   737,   744,
     748,   749,   750,   751,   755,   759,   763,   777,   778,   779,
     780,   783,   784,   785,   786,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   810,   814,   824,   824,   828,   831,
     832,   833,   834,   835,   836,   841,   841,   843,   843,   845,
     845,   847,   847,   849,   849,   851,   851,   853,   853,   855,
     855,   857,   857,   860,   860,   864,   864,   870,   871,   872,
     876,   877,   883,   883,   885,   885,   887,   887,   889,   889,
     891,   891,   893,   893,   897,   897,   901,   902,   906,   906,
     909,   909,   913,   914,   915,   919,   920,   921,   924,    34,
      36,    46,    47,    48,    49,    50,    53,    55,    59,    63,
      64,    65,    66,    70,    74,    78,    92,   112,   113,   114,
     115,   116,   117,   118,   119,   123,   124,   125,   126,   127,
     128,   131,   133,   136,   138,   142,   145,   150,   151,   152,
     156,   157,   161,   162,   165,   184,   184,    32,    34,    42,
      43,    44,    45,    48,    50,    54,    58,    74,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   152,   154,   157,
     159,   164,   166,   170,   170,   173,   173,   176,   176,   179,
     179,    47,    49,    80,    82,    83,    86,    88,    89,    90,
      91,    96,    97,   101,   102,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   118,   119,   120,   121,   122,   126,
     127,   133,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   198,   198,   199,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   217,   243,   244,   245,   247,   247,   247,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   287,   299,   301,   304,   306,   310,   317,   320,
     322,   324,   326,   328,   330,   332,   334,   336,   338,   340,
     342,   344,    26,    28,    34,    35,    36,    37,    38,    39,
      40,    41,    44,    46,    50,    53,    53,    57,    58,    59,
      60,    61,    62,   211,   214,   215,   216,   219,   235,   236,
     240,   241,   245,   254,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   274,
     289,   292,   294,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   307,   308,   308,   309,   310,   311,   315,
     316,   320,   328,   330,   334,   335,   336,   340,   341,   344,
     346,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   362,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   422,   424,   427,   429,   437,   439,   440,   443,
     445,   449,   450,   453,   463,   485,   487,   491,   491,   494,
     496,   499,   501,   505,   508,   509,   510,   511,   514,   514,
     517,   517,   520,   520,   525,   525,   528,   528,   533,   533,
     536,   536,   540,   540,   549,   552,   553,   554,   555,   556,
     557,   558,   559,    24,    26,    40,    41,    42,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    23,    26,
      25,    40,    41,    42,    43,    44,    46,    58,    59,    60,
      61,    62,    62,    63,    63,    64,    65,    68,    70,    74,
      78,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   116,   120,   121,   122,   123,   124,   125,   125,
     126,   126,   127,   128,   132,   133,   134,   137,   175,   177,
     180,   182,   186,   189,   201,   202,   203,   204,   208,   215,
     223,   225,   228,   230,   234,   238,   248,   253,   254,   255,
     259,   271,   273,   277,   278,   282,   295,   300,   301,   302,
     306,   318,   320,   324,   325,   330,   331,   335,   336,   339,
     340,    46,    49,    50,    53,    67,    68,    69,    70,    71,
      72,    75,    77,    81,    85,   110,   140,   141,   142,   143,
     144,   145,   146,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   173,   174,   175,   176,   179,   181,   184,
     186,   190,   193,   194,   198,   198,   201,   201,    41,    43,
      50,    52,    54,    58,    59,    60,    61,    62,    63,    64,
      70,    76,    82,    86,    87,    90,    93,    97,   108,   109,
     113,   120,   130,   132,   136,   137,   138,   142,    54,    56,
      63,    64,    65,    66,    67,    75,    79,    84,    89,    92,
      95,    99,   105,   106,   109,   121,   122,   126,   131,   132,
     133,   134,   135,   136,   140,   149,   151,   154,   156,   160,
     160,    23,    26,    27,    28,    31,    32,    33,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    62,    63,    31,    33,    35,    42,    43,    46,    48,
      52,    62,    63,    67,    68,    72,    73,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    89,    92,    93,   104,
     107,   108,   109,   110,   118,   118,   121,   121,   128,   128,
     131,   131,   134,   134,   137,   137,   140,   140,   145,   145,
     150,   151,   155,   156,   157,    41,    43,    48,    49,    52,
      53,    57,    58,    59,    60,    64,    71,    72,    83,    85,
      88,    89,    92,    93,    94,   101,   108,   111,   113,   116,
     118,   122,   125,   126
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "IP4", "IP6", "VPN_RD", "CF_SYM_KNOWN", "CF_SYM_UNDEFINED",
  "TEXT", "BYTESTRING", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "NMA",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE", "ON", "OFF",
  "YES", "NO", "S", "MS", "US", "PORT", "VPN", "MPLS", "FROM", "FLOW4",
  "FLOW6", "DST", "SRC", "PROTO", "NEXT", "HEADER", "DPORT", "SPORT",
  "ICMP", "TYPE", "CODE", "TCP", "FLAGS", "LENGTH", "DSCP",
  "DONT_FRAGMENT", "IS_FRAGMENT", "FIRST_FRAGMENT", "LAST_FRAGMENT",
  "FRAGMENT", "LABEL", "OFFSET", "QUIT", "EXIT", "HELP", "FUNCTION",
  "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT", "ERROR", "INT",
  "BOOL", "IP", "PREFIX", "RD", "PAIR", "QUAD", "EC", "LC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "LCLIST", "IF",
  "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN",
  "GENERIC", "GW", "NET", "MASK", "SOURCE", "SCOPE", "DEST", "IFNAME",
  "IFINDEX", "WEIGHT", "GW_MPLS", "PREFERENCE", "ROA_CHECK", "ASN",
  "IS_V4", "IS_V6", "LEN", "MAXLEN", "DATA", "DATA1", "DATA2", "DEFINED",
  "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST",
  "LAST_NONAGGREGATED", "MATCH", "MIN", "MAX", "EMPTY", "FILTER", "WHERE",
  "EVAL", "ATTRIBUTE", "BT_ASSERT", "BT_TEST_SUITE", "BT_CHECK_ASSIGN",
  "BT_TEST_SAME", "FORMAT", "ROUTER", "ID", "HOSTNAME", "PROTOCOL",
  "TEMPLATE", "DISABLED", "DEBUG", "ALL", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "NONE", "VRF", "DEFAULT", "TABLE", "STATES", "ROUTES",
  "FILTERS", "IPV4", "IPV6", "VPN4", "VPN6", "ROA4", "ROA6", "SADR",
  "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE",
  "KEEP", "FILTERED", "RPKI", "PASSWORD", "KEY", "PASSIVE", "TO", "EVENTS",
  "PACKETS", "PROTOCOLS", "CHANNELS", "INTERFACES", "ALGORITHM", "KEYED",
  "HMAC", "MD5", "SHA1", "SHA256", "SHA384", "SHA512", "BLAKE2S128",
  "BLAKE2S256", "BLAKE2B256", "BLAKE2B512", "PRIMARY", "STATS", "COUNT",
  "BY", "FOR", "IN", "COMMANDS", "PREEXPORT", "NOEXPORT", "EXPORTED",
  "GENERATE", "BGP", "PASSWORDS", "DESCRIPTION", "RELOAD", "OUT",
  "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS",
  "TIMEFORMAT", "ISO", "SHORT", "LONG", "ROUTE", "BASE", "LOG", "GRACEFUL",
  "WAIT", "FLUSH", "AS", "IDLE", "RX", "TX", "INTERVAL", "MULTIPLIER",
  "CHECK", "LINK", "SORTED", "TRIE", "SETTLE", "TIME", "IPV4_MC",
  "IPV4_MPLS", "IPV6_MC", "IPV6_MPLS", "IPV6_SADR", "VPN4_MC", "VPN4_MPLS",
  "VPN6_MC", "VPN6_MPLS", "PRI", "SEC", "SHOW", "STATUS", "SUMMARY",
  "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES",
  "ECHO", "ENABLE", "BFD", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "BABEL", "METRIC",
  "RXCOST", "HELLO", "UPDATE", "WIRED", "WIRELESS", "BUFFER", "PRIORITY",
  "HOP", "BABEL_METRIC", "ENTRIES", "RANDOMIZE", "MAC", "PERMISSIVE",
  "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "SELF",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "STRICT", "BIND",
  "CONFEDERATION", "MEMBER", "MULTICAST", "LIVED", "STALE", "IBGP", "EBGP",
  "MANDATORY", "INTERNAL", "EXTERNAL", "SETS", "DYNAMIC", "RANGE", "NAME",
  "DIGITS", "BGP_AIGP", "AIGP", "ORIGINATE", "COST", "ENFORCE", "FREE",
  "VALIDATE", "CEASE", "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER",
  "CONFIGURATION", "CHANGE", "DECONFIGURED", "CONNECTION", "REJECTED",
  "COLLISION", "OF", "MRT", "FILENAME", "PERIOD", "ALWAYS", "OSPF", "V2",
  "V3", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID",
  "AREA", "RFC1583COMPAT", "STUB", "TICK", "COST2", "RETRANSMIT",
  "TRANSMIT", "DEAD", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "CRYPTOGRAPHIC",
  "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "ONLY", "LARGE",
  "NORMAL", "STUBNET", "TAG", "LSADB", "ECMP", "NSSA", "TRANSLATOR",
  "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "MERGE",
  "LSA", "SUPPRESSION", "RFC5838", "PE", "TOPOLOGY", "STATE", "PERF",
  "EXP", "REPEAT", "THRESHOLD", "MODE", "PIPE", "RADV", "RA", "SOLICITED",
  "UNICAST", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT",
  "GARBAGE", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "DEMAND", "CIRCUIT", "RIP_METRIC", "RIP_TAG", "REMOTE",
  "BIRD", "PRIVATE", "PUBLIC", "SSH", "TRANSPORT", "USER", "EXPIRE",
  "STATIC", "PROHIBIT", "BLACKHOLE", "UNREACHABLE", "KERNEL", "NETLINK",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG",
  "TRACE", "INFO", "WARNING", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE", "DOWN", "PERSIST",
  "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC", "';'", "'('",
  "')'", "','", "'{'", "'}'", "':'", "'['", "']'", "'?'", "$accept",
  "config", "conf_entries", "conf", "definition", "expr", "expr_us",
  "symbol", "bool", "ipa", "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_",
  "net_ip6_sadr_", "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_",
  "net_mpls_", "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip6",
  "net_ip", "net_any", "net_or_ipa", "label_stack_start", "label_stack",
  "time", "text", "opttext", "flow_num_op", "flow_logic_op",
  "flow_num_type_", "flow_num_type", "flow_flag_type", "flow_frag_type",
  "flow_srcdst", "flow_num_opts", "flow_num_opt_ext_expr",
  "flow_num_opt_ext", "flow_bmk_opts", "flow_neg", "flow_frag_val",
  "flow_frag_opts", "flow4_item", "flow6_item", "flow4_opts", "flow6_opts",
  "flow_builder_init", "flow_builder_set_ipv4", "flow_builder_set_ipv6",
  "net_flow4_", "net_flow6_", "net_flow_", "cli_cmd", "cmd_QUIT",
  "cmd_EXIT", "cmd_HELP", "filter_def", "$@1", "filter_eval",
  "custom_attr", "bt_test_suite", "bt_test_same", "type", "function_argsn",
  "function_args", "function_vars", "filter_body", "filter",
  "where_filter", "function_body", "function_def", "$@2", "cmds",
  "cmd_prep", "cmds_int", "block", "fipa", "set_atom", "switch_atom",
  "cnum", "pair_item", "ec_kind", "ec_item", "lc_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix", "fprefix_set",
  "switch_body", "bgp_path_expr", "bgp_path", "bgp_path_tail", "constant",
  "constructor", "var_list", "function_call", "symbol_value",
  "static_attr", "term", "break_command", "print_list", "cmd",
  "get_cf_position", "lvalue", "rtrid", "idval", "hostname_override",
  "gr_opts", "net_type", "table", "table_start", "table_sorted",
  "table_opt", "table_opts", "table_opt_list", "proto_start", "proto_name",
  "proto_item", "channel_start", "channel_item_", "channel_item",
  "channel_opts", "channel_opt_list", "channel_end", "proto_channel",
  "rtable", "imexport", "limit_action", "limit_spec", "debug_default",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "proto", "dev_proto_start",
  "dev_proto", "dev_iface_init", "dev_iface_patt", "debug_mask",
  "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_list_body", "password_items",
  "password_item", "pass_key", "password_item_begin",
  "password_item_params", "password_algorithm", "password_item_end",
  "bfd_item", "bfd_items", "bfd_opts", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optproto", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "r_args_for", "r_args_for_val",
  "export_mode", "channel_sym", "channel_arg", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_DUMP_FILTER_ALL",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "debug_args", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "dynamic_attr",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_accept_item", "bfd_accept", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "babel_proto_start", "babel_proto_item",
  "babel_proto_opts", "babel_proto", "babel_iface_start",
  "babel_iface_finish", "babel_iface_item", "babel_iface_opts",
  "babel_iface_opt_list", "babel_iface", "cmd_SHOW_BABEL_INTERFACES",
  "cmd_SHOW_BABEL_NEIGHBORS", "cmd_SHOW_BABEL_ENTRIES",
  "cmd_SHOW_BABEL_ROUTES", "bgp_proto_start", "bgp_loc_opts",
  "bgp_nbr_opts", "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag",
  "bgp_proto", "$@3", "$@4", "bgp_afi", "bgp_channel_start", "bgp_nh",
  "bgp_lladdr", "bgp_channel_item", "bgp_channel_opts",
  "bgp_channel_opt_list", "bgp_channel_end", "bgp_proto_channel",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_variant", "ospf_proto_start",
  "ospf_proto", "ospf_af_mc", "ospf_channel_start", "ospf_channel",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@5", "$@6", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@7", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@8", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@9", "$@10", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@11", "$@12", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS", "rpki_proto_start",
  "rpki_proto", "rpki_proto_opts", "rpki_proto_item", "rpki_keep_interval",
  "rpki_proto_item_port", "rpki_cache_addr", "rpki_transport",
  "rpki_transport_tcp_init", "rpki_transport_ssh_init",
  "rpki_transport_ssh_opts", "rpki_transport_ssh_item",
  "rpki_transport_ssh_check", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_route0", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item", "log_begin",
  "log_config", "syslog_name", "log_limit", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_STATUS", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cmd_GRACEFUL_RESTART", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_proto", "kif_item", "kif_iface_start", "kif_iface_item",
  "kif_iface_opts", "kif_iface_opt_list", "kif_iface", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,    61,    60,    62,   126,   280,
      43,    45,    42,    47,    37,    33,    46,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     794,   795,   796,   797,   798,   799,   800,   801,   802,   803,
      59,    40,    41,    44,   123,   125,    58,    91,    93,    63
};
# endif

#define YYPACT_NINF -2082

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-2082)))

#define YYTABLE_NINF -867

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-867)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     127,  3109,   155,    77,   209,   264,   312,  4434,   616,   705,
     705,  1293,   705,   348,   240,  3399,  2211,    69,   705,   124,
     222,   513, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,   784, -2082, -2082, -2082,   784,   784,  4434,  3336,   -22,
     -15,   411,   635, -2082, -2082,    90, -2082,   395, -2082, -2082,
   -2082, -2082,   510,  1204, -2082,   511,   239, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,   596,
   -2082,   535,  1927, -2082, -2082, -2082,   940,  3715,   940, -2082,
     940, -2082,   940,  5817,   940, -2082,   940,  4337,   940,  1622,
     225,  3935,   940, -2082,   940, -2082,   940, -2082,   940,  3318,
    3404, -2082, -2082, -2082,   940,   940,  1730, -2082, -2082, -2082,
     176, -2082, -2082,   739,   790,  1006,   265, -2082,   693,   189,
    4434,   843, -2082,   298,   350, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,   307,   362,
     389,   424,   435,   443,   469, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  2568,   260,
     804,   893, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  2838, -2082,  1005, -2082, -2082,   150,  1059,   150,
   -2082,  1048,  1048,   705,   705,  1089,   261, -2082,  1092,   745,
     122,  1108, -2082,  1112, -2082,   837,   750,   537,   270,  1128,
     970,  1129,  1171,  1191,  1212,  1225,  1232,  1235,  1238, -2082,
   -2082,   904,  1271,  1048, -2082, -2082,  1240,  1274,  1240,  1304,
    1307,   830, -2082, -2082, -2082,  1309, -2082, -2082,  3122, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,   888,  1325,  1334,   134, -2082, -2082,
     806,   150,   150,   282,   585, -2082,   261,   825, -2082, -2082,
   -2082, -2082,   201,   836,   353,  1137,   282,   282,   784, -2082,
     841, -2082, -2082, -2082, -2082, -2082, -2082,   707, -2082, -2082,
   -2082,   897, -2082, -2082, -2082, -2082, -2082,  1380,  1370,   867,
    1285,   895,   150, -2082,   506,   635,   261,  1194, -2082, -2082,
     903,   889,   906,   914,   932,   938,   945, -2082, -2082,   268,
    1203,   965,  1506,   910,    11,    98,   115,   162,  1231,   635,
     895,  1193,  1387,  1315,   563,   177,    74,   292,   907,  1305,
     383,  1321,  1286,  1318,  1284,  1100,  1276,  1471,   895,  1320,
    1297,  1378,  1386,  1331,  1349,   507,   895,  1360,   133,  1366,
    1586,  1382, -2082,  1163, -2082,  1188,  1195,  1189,  1199,  1311,
    1575,    55,   895,  1607,   282,   895,  1612,  1396,   895, -2082,
    1409, -2082,   889, -2082,  1206,  1205, -2082,  1213,   895,  1752,
     279,  1755,  1190,  1356, -2082,  1216, -2082,  1221, -2082,   282,
    1963,  1154,  1762,  1594,  1562,  1621, -2082,  1229,  1230,  1237,
    1239,  1250,  1252,  1576,  1544,  1633, -2082,  1242,  1244,   992,
    1254,  1635,   282,  1476,  1659,  1598,   895,  1585,   895, -2082,
   -2082, -2082,  1281,  1282,  1280,  1287, -2082,  1602, -2082, -2082,
    1289,    53, -2082,   176,   176,  4434,   649,   176,   176,  1831,
   -2082,  1840, -2082,  1843,   739,  1828, -2082, -2082,  4434,  1836,
     325,  1837,  1844, -2082, -2082, -2082,  1762,  4434,  4434,  4434,
    4434,  4434,  4434, -2082, -2082,  1852, -2082,  1322,   148, -2082,
   -2082,  1828, -2082, -2082,  2227, -2082, -2082,   135, -2082,  1872,
   -2082, -2082, -2082, -2082,   297, -2082,   414,  1868,  1873, -2082,
    4434,  4434,  4434,  4434,  4434,  4434,  4434,  4434,  4434,  4434,
    4434,  4434,  4434,  4434,  4161,  4139, -2082, -2082,  1316, -2082,
   -2082, -2082, -2082,  1886,  1888,  1889,  1894, -2082, -2082, -2082,
     594,  1895, -2082, -2082, -2082,   871,  1896, -2082,  1902, -2082,
    5462, -2082,  2010,  1128,  1128,  1128,  1128,  1128, -2082,  1128,
    1128, -2082,   175,   392,  1909,  1128,  1128,  1911,  1912, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,   332, -2082, -2082,  1913,
    1917,  1090,  1929, -2082,   830, -2082, -2082,   282,  1932,  4434,
    1340, -2082, -2082,  1335,  1375,  1377, -2082, -2082, -2082, -2082,
    4434,  1384, -2082, -2082, -2082, -2082, -2082,  4434, -2082, -2082,
   -2082, -2082, -2082,   282, -2082, -2082,  1385, -2082,   282,  1227,
   -2082,  1580, -2082,   282,   -63,   282,  1111, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,   940, -2082, -2082,  1930, -2082,    55,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082,   895, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,  1686,  1698,   907, -2082,
    1392,   282,   282, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,   -26,  1393,  1395,   285,   314,   895,  1624,   895,  1734,
    1401,  1403,  1406, -2082,  1411, -2082, -2082, -2082,  1247,  1935,
     504,  1935,   169,   282,  1721,  1723,   282,  1725,   895,  1726,
     895,  1826,   895,   895,  1419,   895,   895,   895,   895,   895,
     895,  1616,  1741,   895,  1422,   895,   895,  1424,   180,  1747,
     895, -2082, -2082, -2082, -2082, -2082, -2082,   895,   410, -2082,
   -2082,   895, -2082,  1814,   282,   895, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,  1980,  1981, -2082,   282,   282,
   -2082, -2082, -2082, -2082, -2082,  1979,  4434, -2082, -2082,   226,
    1815, -2082, -2082,   226, -2082, -2082, -2082,   226,   895,  1762,
   -2082, -2082, -2082, -2082, -2082, -2082,   790,  1006, -2082, -2082,
   -2082,   895,  1762, -2082, -2082, -2082,  1017, -2082,   907, -2082,
   -2082, -2082,   777,  1699, -2082,  1444,   895, -2082,   895,   282,
    1715, -2082,   282, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
     282, -2082,  1992, -2082, -2082, -2082,  1160, -2082, -2082,   491,
   -2082, -2082, -2082, -2082,  1960,  1995,   969,  3122, -2082,  1871,
    1983, -2082, -2082, -2082,   975,  1172,   310,   374,   431,   466,
    1243, -2082,  4434, -2082,  4434,  1453,    35,  1454,  1273, -2082,
   -2082,  2003,   662,   649, -2082,  1006, -2082,  1780,  1781,  2542,
    2542,  2542,  3134,  3134,  2542,  2542,  2542,  2542,  2542,  1181,
    1181,  1844,  1844, -2082, -2082, -2082, -2082, -2082,  1463, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,   342, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,   401, -2082, -2082,  2019,
   -2082, -2082, -2082,  1979,  2005, -2082,  1870,  1876,   622, -2082,
   -2082, -2082, -2082,  1068,  1576, -2082, -2082, -2082, -2082, -2082,
    2014, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  2040,  1048,
    1048,  1048,  1048,  1048,  1048,  1416,  1128,  1048,  1128,  1048,
   -2082,  1048,  1048, -2082, -2082,   904, -2082, -2082, -2082, -2082,
    1979,   980,   635, -2082, -2082,  2042, -2082, -2082,   981,  1487,
   -2082,  2546, -2082, -2082, -2082,   635,  2031, -2082,  1492,  1310,
   -2082,  1381, -2082, -2082,  2050,  1522,  1554,   635, -2082,   635,
   -2082, -2082,   904,  1493,  1504, -2082, -2082, -2082,   547, -2082,
   -2082, -2082,  2047, -2082,  1518,  1527,   917, -2082,  1718,  4023,
     282,   282,  1531, -2082,  1538,  1539,   895,   248, -2082, -2082,
    1900,  1833,   282,  1540,  1542,  1547,   895,  1548,   895, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082,   784, -2082,   282,
     282, -2082, -2082, -2082, -2082,   282,   282, -2082,  1559,   282,
     282,  1565,   282,  1577,   282,  1582,    55,  1583,  1584, -2082,
    1588,  1589,  1591,  1593,  1599,  1606,   895,   275,  1608, -2082,
    1609,  1613, -2082,   282,  1614,   895,  1615,  5359, -2082,  2049,
   -2082,   282, -2082, -2082, -2082,   282, -2082, -2082, -2082,  1700,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082,  3122, -2082,  1956,
   -2082,   895, -2082, -2082, -2082,  1617,  3520,  3625,  2557,  1619,
    1620, -2082,  1935,  2043,  2099,   282,   895,   895,   777,  4706,
   -2082, -2082,  1958, -2082,   282, -2082,  1518,  1574, -2082,   176,
   -2082,   176,  2127, -2082, -2082,  4434,  2124,  2129, -2082, -2082,
   -2082,  4434, -2082,  4434,  4434,  4434,  4434, -2082,   724,   228,
    2879,  4434,  3190,  4434, -2082,  1604,  4434, -2082, -2082, -2082,
    2157,  2166,  4434,  1316, -2082,   594, -2082, -2082, -2082, -2082,
    2165,  2165, -2082, -2082,   739,   731,  1595, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,  1005, -2082, -2082,  2183,
    2185,  2186,  2190,  2191,  2193, -2082, -2082,  2189,    55, -2082,
   -2082,    55, -2082,    55,  1048,  2204,  1048,  2205,  2206,  2208,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  3336, -2082,
    5052,   888,  1650,  1651,  1518, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,   694, -2082, -2082,  1966,  1967,
     895,   895, -2082,  1658, -2082,  2197, -2082, -2082,   150, -2082,
   -2082,  1660, -2082, -2082, -2082,   907, -2082, -2082,  1662, -2082,
    2072, -2082, -2082, -2082,  1664,  1665,  1669, -2082, -2082, -2082,
    1670,   753, -2082,  1671,   377,   282,  1672, -2082, -2082, -2082,
    1673, -2082,  1674,  1184,  1676,   728, -2082,   788, -2082, -2082,
     198, -2082, -2082, -2082,  1678,  1679, -2082,  1681, -2082,  1688,
   -2082,  1690, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
    1691, -2082,  1692, -2082, -2082, -2082,  1693, -2082,  1694, -2082,
    1933,  1887,  1825,  1405,  1899,  2089,  2078,  1936,  2095,   -25,
     895,  2209,   895,   591,   282,   895, -2082, -2082,  1706,  1979,
    1339,   635,   282,  2138, -2082, -2082, -2082,  1709, -2082, -2082,
   -2082,   629,   895, -2082,   891, -2082,  2024,  1247, -2082,   470,
   -2082,  1712, -2082,  1845,  1298, -2082, -2082, -2082,  1354, -2082,
   -2082, -2082,  1354,  2111, -2082, -2082, -2082,  1722, -2082,   895,
     282, -2082, -2082, -2082,  1733,   282,  2097,  2159,  2097,  1127,
     -14,  2097, -2082, -2082, -2082,  1740, -2082, -2082, -2082, -2082,
    2099, -2082, -2082,  2269, -2082, -2082, -2082,     3,  4434,  4434,
    1742,  4434, -2082, -2082, -2082,  4434,  4434,  2279,  1753,  1756,
   -2082,  1758,  2295,  4434, -2082,   522, -2082,   282, -2082, -2082,
   -2082, -2082, -2082, -2082,  2288,  3122,  2291, -2082,  1173,  1299,
     819,  1461,  1549,  1578,  1628,  4434, -2082,  4434,  1066,    19,
    3122,  1760,  1069,    45,  1761,  2310,  1273, -2082, -2082,  1675,
   -2082, -2082,  1005, -2082, -2082,  2308,   739,  1828, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  2324, -2082,
    2326, -2082, -2082, -2082,   888,  1773, -2082,  5052, -2082,  1789,
   -2082,  2335, -2082,  2100,  2101, -2082, -2082, -2082,  1308,  1347,
   -2082, -2082, -2082, -2082,  1036, -2082, -2082,  1790, -2082,   136,
   -2082, -2082, -2082, -2082,  2203, -2082,   282, -2082, -2082,  2181,
    1973, -2082,    17,  1988,  1990,  1262,   815, -2082, -2082,  1813,
    1830,  1847, -2082, -2082, -2082,  1431,   895, -2082,  2131,   282,
     282, -2082,  1849, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,   518,   406,   895,   895,
     304,  1762,   895,   748,  1762, -2082, -2082, -2082,  2113, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
    2086, -2082, -2082, -2082,   282,   282,   895, -2082,  1829,   282,
   -2082,  1839,    55, -2082, -2082,  1846,   282, -2082, -2082,   282,
    1848, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  1859, -2082,
   -2082, -2082,   112,    54, -2082,   895, -2082, -2082, -2082,  2233,
   -2082, -2082, -2082, -2082,   282,  2350,   282, -2082, -2082, -2082,
    2379, -2082, -2082, -2082,   282, -2082,  2269,  2416,  4434,  1131,
    1874,  1875,  5705,  2792,  2945,   110,  4434, -2082, -2082, -2082,
    4434,  1877,  4434,  1253, -2082,  -262,  2426,  2402, -2082, -2082,
   -2082, -2082,  2387, -2082, -2082,  1629,  2390, -2082, -2082, -2082,
   -2082, -2082, -2082,   178,  2421,  2421,  1247,  1893, -2082,   178,
    2421,  2421,  1354,  1901,  4434, -2082, -2082, -2082, -2082,  1801,
    1898, -2082,  2427,  4434, -2082,  3501, -2082,  2430,  4434,  2451,
    3812,  4123,  1903, -2082, -2082, -2082, -2082,   872, -2082, -2082,
   -2082,  1904,   282,   282,   739,  1828, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,  1790, -2082, -2082,   784,   635,
    2187,  1905,   895,  1907,  2087,  2195, -2082, -2082, -2082, -2082,
   -2082, -2082,   753, -2082, -2082, -2082, -2082,  2226,  2228, -2082,
    2229, -2082, -2082, -2082,   497,   497,   907, -2082, -2082, -2082,
   -2082, -2082,  2289,  2234, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,   895,   895,  1518,  1922, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  1923, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  1924,   282,
   -2082,   895, -2082, -2082, -2082,  1939, -2082, -2082,  2804,  4434,
   -2082, -2082,  1947, -2082,  4780, -2082,  2913,  4434,  5326,  3006,
   -2082,  3041,  1949,  1950,  1951,  1953,  1954,   907, -2082,  1957,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,  2507,   282,  1685, -2082,  1955, -2082,
      52,   282,  1600,    93, -2082, -2082,  1685,    52,    93,  2445,
   -2082,  2029, -2082, -2082,  1968,  1971,  1136,    39,  1972,  1147,
    1974,  1985,    41,  1986,    47, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  1632, -2082, -2082, -2082,   907,  2244, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,   282,   282,   282, -2082, -2082,
   -2082, -2082, -2082, -2082,   895,   282, -2082, -2082,  1845, -2082,
   -2082,    79,    89,   -40,  1892,   936, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  1976,  5052,
    2453, -2082,    85, -2082,  3122, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  4434,  4434,  4434, -2082,  4434, -2082, -2082,   282,
   -2082, -2082,   282,  1735,   282, -2082,  2421,  2421,  2522, -2082,
   -2082, -2082, -2082, -2082,  2421,  2421,  2541, -2082, -2082, -2082,
   -2082,  2525,  4434, -2082, -2082, -2082,  2526,  4434, -2082,  4434,
    2552, -2082,  4434, -2082, -2082,  1473, -2082, -2082,   895,  1996,
    2318,   282,   282,  1012, -2082, -2082, -2082, -2082,  1156,  1998,
    2006, -2082,   895, -2082,  3069, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  5693, -2082, -2082, -2082,   234, -2082,   895,   282,
     895, -2082,  2016,   282,   128,   282,   282,  2256,   179, -2082,
   -2082,  2017,  2114,  2115,   895,   895,   895, -2082,  2022,  3513,
   -2082,   601,   107,  5461, -2082,   524, -2082,  2027,  4780,  5052,
   -2082, -2082,  2227, -2082, -2082,  2582, -2082, -2082, -2082, -2082,
     418,  2032,  2030,  2280,  2356,  2389,  2418, -2082,  1955,   282,
   -2082,   282,   282,   282,  1600,  1600, -2082,  2033,  2035,  2038,
    2045,  2039,  2044,  2048,  2365,  2367, -2082,  1530,  2368, -2082,
   -2082, -2082,  1525, -2082,  2422, -2082, -2082, -2082,  1374, -2082,
   -2082, -2082,   282,  2321,  1441,   282,  2330,   588,  2380,   231,
     282,  2382,  2394, -2082, -2082,  2085,  1208,   282,  2357,   712,
    2399,  2212,  2088,   895,   289,   282,   282,  2306,  2242,   282,
     895,   282,  2346,   311,   -24,   282,  2537,  2248, -2082, -2082,
    2096, -2082,   282,  2102, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,   282,   282, -2082, -2082,   282,   282,
   -2082, -2082, -2082, -2082,   143,    63,  2210,   -37,    49,  2202,
    2213,   895,  2215,  2410,  2207,  2372,  2401,  2411, -2082,  2108,
     329,   907, -2082,  2132,   329,  2669, -2082,  2133,   282,   895,
    2405,   714,   -64,   895,     8,   282,  2449,   907,  2359,  2450,
    2587,   205,  2454,  2458,   152,  2223,  2222,  2225, -2082, -2082,
    2160,  2217,  2235,   635, -2082,  2164, -2082, -2082, -2082,  2466,
     254,   464,  5052,  2214,  4434,  2216,  2219,  2220,  2224, -2082,
    2692,  2733, -2082, -2082, -2082, -2082, -2082, -2082,  4434, -2082,
    4434, -2082,   282,   282,  2218,  2230,   282, -2082, -2082,  1532,
    2745,   299,   282,  2745,  1348,   455,  2232, -2082,  1570, -2082,
   -2082, -2082,   282,   282,   282,   282,   282, -2082,   895, -2082,
    2471, -2082,   282,   282, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,   308,   282,   282, -2082,   895,  2331,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082,   881,   895, -2082,
   -2082, -2082,   282,   282, -2082,   895,   895, -2082,   282,   895,
   -2082, -2082, -2082, -2082, -2082,  2296,  2296,  2520, -2082,   282,
    2528,  2529,   814,   282,   814,  2524,   282,   282,  2325, -2082,
     895,   282,   282,  2604,   895,   112,   895,    54, -2082,   282,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,   282,   282,   282, -2082,   895,   895, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,   282, -2082,   934,   282,   282, -2082,
   -2082,   282,   282,   895, -2082,   895,   895,   895, -2082,  2599,
    2601, -2082, -2082, -2082, -2082,  4434, -2082, -2082, -2082, -2082,
    2496, -2082, -2082, -2082, -2082,   282,   282,  2231,  2243, -2082,
   -2082, -2082,  1530, -2082, -2082, -2082, -2082,  2238,  2745,  2745,
    2245,  2247,  1443,  1478, -2082, -2082, -2082, -2082,  2249,  2745,
    2745, -2082,   907,   907, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,   895,
      95,  2370, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
     895, -2082, -2082,   282, -2082,   282,   282, -2082, -2082, -2082,
   -2082,  2296, -2082,   282,  2296, -2082,   895, -2082, -2082, -2082,
     282, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  2371, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,   635,   635,  2466,  2251, -2082, -2082, -2082,  4434,
   -2082,  1374,  2267,  2278,  1374,  1374, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,  1374,  2283,  2284, -2082,
   -2082, -2082, -2082, -2082,  2392, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
    2276, -2082,  1374,  1374, -2082, -2082, -2082,  1374,  1374, -2082,
    2285,  4434, -2082, -2082, -2082, -2082, -2082,  2290, -2082
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1420,     0,     3,   133,   135,   137,   555,   557,   559,   561,
     565,   567,   569,   626,   635,   637,   639,   641,   643,   645,
     647,   649,   651,   653,   655,   662,   664,   666,   668,   670,
     672,   674,   678,   680,   735,   773,   775,   777,   779,   945,
    1088,  1090,  1092,  1094,  1096,  1098,  1100,  1102,  1274,  1276,
    1339,  1404,  1406,  1408,  1410,  1412,  1414,  1416,  1418,     1,
       2,     0,   393,   391,   392,     0,     0,     0,     0,     0,
       0,     0,     0,   408,   409,     0,   384,   385,   387,   388,
     389,   390,     0,     0,  1374,     0,     0,     6,     5,     7,
     139,   142,   144,   146,   148,   177,   373,   380,   382,     0,
     394,   397,     0,   452,   456,   407,   410,   414,   410,   689,
     410,   737,   410,   414,   410,   932,   410,   414,   410,   414,
       0,   414,   410,  1135,   410,  1221,   410,  1278,   410,   414,
     414,  1373,  1396,  1399,   410,   410,   414,   134,   136,   138,
     258,   259,   268,   187,   188,   264,   277,   262,     0,     0,
       0,     0,   278,     0,     0,   281,   260,   261,   279,   280,
     282,   283,   284,   285,   286,   287,   288,   309,     0,     0,
       0,     0,     0,     0,     0,   688,   772,   920,   923,   922,
     919,   921,   924,   925,   926,   929,   931,   927,   928,   930,
    1084,  1085,  1086,  1087,  1219,  1220,  1272,  1273,  1345,  1346,
    1347,  1348,  1349,  1350,  1351,  1352,  1353,  1354,  1355,  1356,
    1357,  1358,  1359,  1360,  1361,  1362,  1363,  1364,  1365,  1366,
    1367,  1368,  1369,  1370,  1371,  1372,  1452,  1453,     0,     0,
      37,    38,    47,    39,    40,    41,    42,    48,    43,    44,
      45,   265,   131,   132,    46,   263,   272,   307,   308,   341,
     306,   310,     0,   311,   682,   684,   683,     0,     0,     0,
     682,    67,    67,     0,     0,     0,     0,   681,     0,   686,
       0,     0,   571,     0,   628,     0,     0,   564,     0,   564,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   658,
     657,     0,   660,    67,   947,  1421,  1420,     0,  1420,     0,
       0,  1422,  1417,    16,    15,     0,   178,   140,   143,   150,
     151,   152,   154,   153,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,     0,     0,     0,     0,    65,    64,
       0,     0,     0,     0,    22,   386,     0,     0,   458,   457,
     459,   460,     0,     0,     0,     0,     0,     0,     0,   398,
     405,   484,  1279,   782,   690,   738,   933,   954,  1114,  1129,
    1136,  1222,  1309,  1426,  1439,   957,  1224,     0,   411,     0,
       0,    22,     0,   490,     0,     0,     0,     0,   483,   422,
       0,   436,     0,     0,     0,     0,     0,   880,   881,     0,
       0,     0,     0,     0,   870,   871,     0,     0,     0,     0,
      22,     0,     0,     0,     0,    22,     0,   786,   783,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,   781,     0,   882,   915,     0,     0,     0,     0,
       0,     0,    22,     0,     0,    22,     0,     0,    22,   953,
     960,   964,   436,   965,     0,     0,   978,     0,    22,     0,
       0,     0,     0,     0,  1113,     0,  1118,     0,  1131,     0,
       0,     0,     0,     0,     0,     0,  1128,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1308,     0,     0,  1328,
    1337,     0,     0,     0,     0,     0,    22,     0,    22,  1425,
    1431,  1432,     0,     0,     0,     0,  1445,     0,  1438,  1442,
       0,   258,   277,   258,   258,     0,     0,   258,   258,     0,
     248,     0,    29,     0,     0,     0,    32,    33,   273,     0,
       0,     0,   304,    36,   126,   126,     0,     0,     0,     0,
       0,     0,     0,   210,   211,     0,   213,     0,     0,   189,
     192,   188,   191,   194,     0,    37,    38,   239,   190,   228,
     225,   226,   227,   235,     0,   243,     0,     0,     0,   654,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   493,   492,     0,   677,
     675,   676,    66,     0,     0,     0,     0,   669,   504,   503,
       0,     0,  1419,   685,   687,   686,     0,   566,     0,   558,
       0,   556,     0,   564,   564,   564,   564,   564,   563,   564,
     564,  1104,   564,   564,     0,   564,   564,     0,     0,   648,
     640,   650,   642,   636,   638,   644,   646,  1392,  1387,  1390,
    1388,  1389,  1391,  1393,  1394,  1395,     0,  1385,   661,     0,
       0,     0,     0,  1413,  1422,  1409,  1411,  1423,     0,     0,
       0,   170,   165,     0,     0,     0,   376,   378,   379,   479,
       0,     0,   381,   453,   454,     9,    11,     0,   455,    18,
      20,    19,    21,     0,    17,  1400,     0,  1398,   461,     0,
     469,  1377,  1382,  1378,     0,     0,     0,  1403,  1402,   396,
     403,   395,   955,   956,   410,  1223,   412,     0,   485,     0,
     415,   416,   470,   421,   420,   419,   417,    22,   486,   434,
     438,   487,   488,   696,   743,   804,     0,     0,     0,   820,
       0,     0,     0,   874,   872,   875,   873,   876,   878,   877,
     879,     0,     0,     0,     0,    22,    22,     0,    22,     0,
       0,     0,     0,   821,     0,    23,    24,    25,     0,    26,
       0,    26,     0,     0,     0,     0,     0,     0,    22,     0,
      22,     0,    22,    22,     0,    22,    22,    22,    22,    22,
      22,     0,     0,    22,     0,    22,    22,     0,     0,     0,
      22,   805,   913,   917,   806,   942,   958,    22,    22,   979,
     966,    22,   976,   973,     0,    22,   967,   961,   962,   438,
     959,   981,  1115,  1125,  1124,     0,     0,  1121,     0,     0,
    1126,  1127,  1117,  1116,   429,   170,     0,   443,   444,     0,
       0,   442,   424,     0,   425,   440,   423,     0,    22,     0,
    1132,  1133,  1147,  1231,  1281,  1310,     0,     0,    54,    53,
    1324,    22,     0,  1311,  1312,  1330,     0,  1329,     0,  1333,
    1331,  1332,  1322,  1325,  1335,     0,    22,  1343,    22,     0,
       0,  1433,     0,  1435,  1341,  1428,  1427,  1440,   470,  1443,
       0,  1441,     0,   251,   256,   254,     0,   187,   188,     0,
     255,   257,   250,    28,    30,     0,     0,   274,   330,     0,
       0,   331,   127,   128,     0,     0,     0,     0,     0,     0,
       0,   212,     0,   289,     0,     0,     0,     0,   199,   240,
     241,     0,     0,     0,   266,     0,   267,     0,     0,   301,
     299,   297,   294,   295,   296,   298,   300,   302,   303,   290,
     291,   292,   293,   320,   319,   313,   314,   315,     0,   318,
     312,   316,   317,   325,   326,   327,   322,   323,   324,   328,
     329,   622,   620,   621,   605,   608,   612,   615,   618,   619,
     606,   607,   609,   610,   611,   613,   614,   616,   617,   623,
     624,   625,   497,   498,   499,   501,   502,   500,     0,   495,
     667,   663,   671,   673,   508,   509,     0,   506,   679,     0,
     560,   568,   570,   170,     0,   581,     0,   602,     0,   583,
     582,   587,   588,     0,     0,   601,   603,   604,   572,   580,
       0,   627,   630,   631,   632,   633,   629,   634,     0,    67,
      67,    67,    67,    67,    67,     0,   564,    67,   564,    67,
    1089,    67,    67,  1340,   652,     0,   659,   656,   665,   946,
     170,     0,     0,   951,  1415,     0,  1424,  1405,     0,   166,
     170,     0,   141,   172,   145,     0,     0,   470,     0,     0,
     374,     0,  1401,  1397,     0,   463,   466,     0,  1381,     0,
    1380,  1383,     0,     0,     0,    12,    13,    14,     0,  1130,
     413,   418,   473,   476,   491,     0,     0,   439,   414,   414,
       0,     0,     0,   812,     0,     0,    22,    22,   848,   850,
       0,     0,     0,     0,     0,     0,    22,     0,    22,   865,
     864,   552,   867,   822,    52,    51,   786,     0,   786,     0,
       0,   789,   790,   809,   783,     0,     0,   807,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
       0,     0,     0,     0,     0,     0,    22,     0,     0,   849,
       0,     0,   816,     0,     0,    22,     0,     0,   918,   414,
     968,     0,   971,   970,   969,     0,   977,   975,   963,     0,
    1119,  1120,  1122,  1123,   173,   174,   441,   175,   451,   445,
     427,    22,   428,   426,   431,     0,   414,   414,   414,     0,
       0,  1317,    26,  1326,     0,     0,    22,    22,  1323,     0,
    1315,  1436,  1429,  1342,     0,  1434,   478,  1449,  1444,   258,
     249,   258,     0,    30,   276,     0,     0,     0,   122,   124,
     338,     0,   305,     0,     0,     0,     0,   340,     0,     0,
       0,     0,     0,     0,   193,     0,     0,   229,   236,   244,
       0,     0,     0,     0,   494,     0,   505,   562,   579,   586,
       0,     0,   575,   576,   599,   600,     0,   596,   597,   598,
     592,   590,   591,   573,   589,   574,   584,   585,   736,     0,
       0,     0,     0,     0,     0,  1103,  1112,     0,     0,  1107,
    1110,     0,  1105,     0,    67,     0,    67,     0,     0,     0,
    1386,   950,   949,   948,   952,  1407,     8,   168,     0,   179,
     180,     0,     0,     0,   480,   375,   377,    10,   462,   464,
     465,   467,   468,  1376,  1379,     0,  1375,   383,     0,     0,
      22,    22,   406,     0,   474,    67,   470,   489,     0,   437,
     432,     0,   703,   705,   705,     0,   698,   691,     0,   746,
       0,   745,   739,   740,     0,     0,     0,   834,   833,   832,
       0,     0,   791,     0,    22,     0,     0,   857,   856,   863,
       0,   844,     0,     0,     0,     0,    27,     0,   787,   788,
       0,   784,   785,   818,     0,     0,   838,     0,   827,     0,
     814,     0,   815,   846,   830,   851,   829,   828,   862,   831,
       0,   852,     0,   854,   825,   817,     0,   823,     0,   826,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,     0,    22,    22,     0,    22,   916,   889,     0,   170,
       0,     0,     0,     0,   944,   938,   934,     0,   972,   974,
    1074,     0,    22,   994,    22,   992,     0,     0,   984,    22,
     980,     0,   998,  1075,     0,   450,   430,  1134,     0,  1150,
    1141,  1143,     0,     0,  1149,  1137,  1138,     0,  1234,    22,
       0,  1233,  1225,  1226,     0,     0,  1293,     0,  1293,     0,
       0,  1293,  1280,  1283,  1284,     0,  1287,  1313,  1314,  1316,
       0,    60,    61,  1318,  1320,  1321,  1319,     0,   345,   345,
       0,     0,   342,   343,   344,     0,     0,     0,     0,     0,
    1338,     0,     0,   345,  1334,     0,  1336,     0,  1437,  1344,
    1447,  1451,   252,   253,     0,   275,     0,   332,     0,     0,
       0,     0,     0,     0,     0,     0,   269,     0,     0,     0,
     199,     0,     0,     0,     0,     0,     0,    34,    35,     0,
     496,   507,     0,   577,   578,     0,   593,   594,   780,   774,
     776,   778,  1093,  1091,  1108,  1111,  1106,  1109,     0,  1095,
       0,  1099,  1275,  1277,     0,     0,   183,   181,   182,     0,
     147,     0,  1384,     0,     0,   399,   400,   404,   471,     0,
     475,   477,   433,   435,   692,   470,   693,   723,   694,   727,
     695,   697,   470,   741,     0,   744,     0,   839,   841,     0,
       0,   795,     0,     0,     0,     0,     0,   793,   842,     0,
       0,     0,   858,   843,   845,     0,    22,   551,     0,     0,
       0,   554,     0,   868,   811,   810,   808,   837,   836,   819,
     835,   813,   855,   853,   824,   869,     0,    22,    22,    22,
       0,     0,    22,     0,     0,   895,   896,   897,     0,   893,
     909,   908,   910,   898,   914,   937,   936,   935,   939,   940,
       0,   943,   470,   997,     0,     0,    22,   985,     0,     0,
     983,     0,     0,  1001,   996,  1000,     0,   990,   982,     0,
    1008,   446,   447,   448,   449,    50,    49,  1183,  1192,  1140,
     470,  1139,     0,     0,  1145,    22,  1148,   470,  1230,  1227,
    1229,  1232,  1295,  1294,     0,     0,     0,    25,  1297,  1296,
    1285,  1300,  1301,  1288,     0,  1282,  1327,     0,     0,   346,
       0,     0,     0,     0,     0,     0,     0,   368,   368,   359,
       0,     0,     0,     0,  1430,     0,     0,     0,    80,    91,
      92,    78,     0,    81,    82,     0,     0,    85,    86,    90,
      87,   129,    88,     0,   104,   104,     0,     0,   130,     0,
     104,   104,     0,     0,     0,   335,   336,   334,   337,     0,
       0,   208,     0,     0,   206,     0,   202,     0,     0,   200,
       0,     0,     0,   321,   595,  1097,  1101,     0,   176,   184,
     171,     0,     0,     0,    57,    58,    59,    55,    56,   472,
     701,   699,   700,   702,   704,   723,   721,   706,     0,     0,
     730,   769,    22,     0,     0,     0,   799,   797,   798,   801,
     800,   802,     0,   792,   860,   859,   861,     0,     0,   550,
       0,   545,   549,   553,    22,    22,     0,   903,   904,   905,
     906,   907,     0,     0,   912,   899,   886,   887,   888,   894,
     911,    22,    22,  1077,  1081,   987,   988,   986,  1062,   989,
    1062,  1022,  1002,   991,  1076,  1009,  1190,  1189,  1180,  1196,
    1195,  1203,  1142,  1205,  1206,  1213,  1144,  1146,  1269,     0,
    1290,    22,  1289,  1286,  1298,     0,  1291,    62,     0,   345,
     357,   358,     0,   351,     0,   245,     0,     0,     0,     0,
     356,     0,     0,     0,     0,     0,     0,     0,  1450,     0,
      31,   333,    79,    83,    84,    89,    74,    72,    70,    69,
      71,    73,    68,    75,    97,     0,   114,    99,    95,   105,
     115,     0,     0,   116,   113,   123,   119,   120,   121,   117,
     125,     0,   270,   271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   242,   167,   169,   149,   401,
     402,   706,     0,   726,   728,   729,     0,   732,   767,   747,
     742,   840,   796,   803,   794,     0,     0,     0,   884,   885,
     883,   892,   891,   890,    22,     0,   902,   941,  1075,  1079,
    1083,     0,     0,     0,  1011,     0,  1194,  1178,  1177,  1201,
    1211,  1267,  1235,  1228,  1292,  1302,   350,   347,     0,   180,
     348,   185,     0,   354,   368,   369,   370,   371,   368,   372,
     353,   352,     0,     0,     0,   361,     0,  1446,  1448,     0,
      93,    77,    76,     0,     0,    76,   104,   104,     0,   106,
     107,   108,   109,   110,   104,   104,     0,   339,   223,   207,
     205,     0,     0,   203,   221,   201,     0,     0,   219,     0,
     217,   216,     0,   214,   725,     0,   517,   518,    22,     0,
       0,     0,     0,     0,   724,   714,   510,   512,     0,   544,
       0,   731,    22,   734,   748,   771,   546,   547,   548,   900,
     901,  1078,     0,   995,  1065,  1063,  1066,   993,    22,     0,
      22,   999,     0,     0,     0,     0,     0,     0,     0,  1007,
    1021,     0,     0,     0,    22,    22,    22,  1193,     0,     0,
    1182,  1197,  1207,     0,  1271,     0,   355,     0,     0,   180,
     195,   198,     0,   360,   197,   233,   230,   231,   232,   237,
       0,     0,     0,     0,     0,     0,     0,    98,    96,     0,
     100,     0,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   712,   513,     0,   707,
     711,   715,     0,   716,     0,   713,   520,   519,   521,   516,
     722,   733,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   770,   766,     0,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,     0,  1082,  1061,
       0,  1067,     0,     0,  1005,  1006,  1004,  1003,  1015,  1018,
    1019,  1020,  1012,  1013,     0,     0,  1016,  1010,     0,     0,
    1184,  1185,  1186,  1191,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,  1168,  1170,  1181,     0,
       0,     0,  1200,     0,     0,     0,  1210,     0,     0,    22,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1270,  1262,
       0,     0,     0,     0,  1307,     0,   186,   349,   247,   199,
       0,     0,   180,     0,     0,     0,     0,     0,     0,    94,
       0,     0,   101,   112,   111,   222,   204,   220,     0,   218,
       0,   215,     0,     0,     0,     0,     0,   717,   718,     0,
       0,     0,     0,     0,     0,     0,     0,   749,     0,   752,
     753,   751,     0,     0,     0,     0,     0,   758,    22,   763,
     764,   750,     0,     0,   768,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1027,     0,     0,     0,  1055,    22,     0,
    1069,  1060,  1049,  1050,  1051,  1024,  1042,    22,    22,  1023,
    1044,  1026,     0,     0,  1028,    22,    22,  1025,     0,    22,
    1080,  1068,  1064,  1014,  1017,  1217,  1217,     0,  1167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1155,
      22,     0,     0,     0,    22,     0,    22,     0,  1179,     0,
    1215,  1199,  1198,  1204,  1202,  1209,  1208,  1214,  1212,  1241,
    1239,     0,     0,     0,  1255,    22,    22,  1260,  1263,  1266,
    1265,  1264,  1261,  1236,     0,  1240,    22,     0,     0,  1237,
    1238,     0,     0,    22,  1242,    22,    22,    22,  1268,     0,
       0,  1306,  1299,  1303,   196,     0,   234,   238,   246,   366,
       0,   363,   364,   362,   365,     0,     0,     0,     0,   708,
     709,   511,   513,   710,   719,   720,    63,     0,     0,     0,
       0,     0,     0,     0,   540,   541,   542,   543,     0,     0,
       0,   544,     0,     0,   756,   757,   482,   481,   759,   760,
     765,   754,   755,  1053,  1052,  1054,  1057,  1056,  1045,    22,
       0,     0,  1058,  1043,  1041,  1029,  1040,  1039,  1046,  1038,
      22,  1187,  1188,     0,  1153,     0,     0,  1174,  1175,  1176,
    1163,  1217,  1164,     0,  1217,  1157,    22,  1156,  1158,  1159,
       0,  1172,  1169,  1173,  1171,  1216,  1253,  1254,  1256,  1259,
    1246,  1248,     0,  1257,  1251,  1252,  1249,  1250,  1243,  1244,
    1245,  1247,     0,     0,     0,     0,   103,   102,   209,     0,
     514,   521,     0,     0,   521,   521,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   521,     0,     0,   515,
     761,   762,  1047,  1048,  1071,  1070,  1059,  1218,  1165,  1151,
    1152,  1161,  1166,  1162,  1154,  1160,  1258,  1305,  1304,   367,
       0,   526,   521,   521,   528,   527,   529,   521,   521,  1072,
       0,     0,   524,   525,   522,   523,  1073,     0,   224
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2082, -2082, -2082, -2082, -2082,  -279,  -355,   -70,   250,  -423,
    -702, -2082,  -159,  -151,  1818,  1820,  1821, -2082, -2082, -2082,
    -247, -2082, -2082,  -417, -1372,  -760,  -564, -2082, -2082,  1345,
   -1571,  -102,  -251,   732,  -858, -2082,  1313,  1323,  1324,  1326,
    1067,   794,   797,  1070,  -545,  -437,  1085, -2082, -2082, -2082,
   -2082,  2322, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082,  -891, -2082, -2082,
   -2082,  2221,  -635,  -587,  1808, -2082, -2082, -1766,  1292, -2082,
     735,  -242,  1961,   570, -1228, -1898,  2656, -1807, -1797,  1964,
     577,  2376, -2082,  1970, -2082, -2082, -2082, -2082,  -493, -2082,
   -2082, -2082, -1202,  -157, -1207,    -6, -2082, -1234, -1205, -1529,
   -2082, -2082,  -424, -2082, -2082,   208, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082,   -77,  -120, -2082,  2772,  1729, -2082,  2447,
    2091,  -100,  -548,  -468, -2082,  -133, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082,  1561,  -723,  -508, -2082, -2082, -1662, -2082,
   -2082, -2082, -2082, -2082,  -259, -2082,  1657,   -90, -2082,  1656,
   -1236, -2082,   421, -2081, -2082, -2082,  -582, -2082,   403, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,  -274, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,  -923, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,  1524,  2311, -1219, -2082, -2082, -2082, -2082, -2082, -2082,
    1571,   956, -2082, -2082, -2082,  1113, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,  1796,   316,
   -2082, -2082,  1106, -2082, -2082, -2082, -2082, -2082,  1087, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082,  1071, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082,   941, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,   526, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,   688,   676, -2082, -2082, -2082, -2082,   523,   674,
   -2082, -2082, -2082, -2082,   532,   690, -1882, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082,  -685,  1245, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082,  2103, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082,  1885,  1925, -2082, -2082, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082,  1187,  2327, -2082, -2082, -2082, -2082,
   -2082, -2082, -2082, -2082, -2082, -2082, -2082
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   108,   109,   704,   717,   388,  2010,  1900,
    1148,   542,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,  1717,  2124,   870,  1829,  1512,  1513,
    2517,   350,   613,  1955,  2063,  1782,  1783,  1784,  1785,  1786,
    1956,  1957,  1958,  1960,  1961,  2073,  1963,  1787,  1793,  1548,
    1549,   922,  1248,  1249,   262,   263,   264,    22,    23,    24,
      25,   110,   681,   111,   112,   113,   114,   344,  1328,  1080,
    1081,  1205,  1206,   851,  1083,   115,   680,  1595,  1596,  1597,
    2040,   265,   579,  2165,   936,   580,   937,   581,   582,   583,
    2169,   584,  2170,   585,   586,  2042,   538,   266,   539,   267,
     268,   916,   269,   270,   271,  1560,  1533,  1750,  1598,  1927,
    2048,   116,   691,   117,   118,   399,   120,   121,   370,  1353,
    1108,   721,   122,   389,   400,   401,  1360,  1361,  1116,   740,
    1117,   402,   856,   852,  1475,  1210,   123,   362,   363,   124,
    1112,  1610,  1355,  1113,  1236,  1237,  1087,  1088,  2377,   125,
     126,   127,   732,   403,   609,  1008,  1009,   621,  1016,  1017,
    2105,  2106,  2354,  2107,  2108,  2109,  2366,  2528,  2209,  1652,
    1393,  1142,    26,    27,    28,    29,   644,    30,    31,    32,
     630,  1293,  1294,  1040,  1001,   277,    33,   632,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,   312,
     669,    45,    46,    47,    48,    49,    50,    51,   278,    52,
      53,   279,   626,   273,   128,  1368,  1118,   129,  1834,  1614,
    1615,  1993,  2110,  2205,  1992,  1837,  1616,  1618,  1840,  1997,
    2113,  1620,    54,   130,  1374,  1119,   131,  1622,  2115,  2225,
    2114,  1999,  1623,    55,    56,    57,    58,   132,   782,   780,
    1383,  1636,  1637,   133,   772,  1394,   454,   455,  2011,  1879,
    1448,  1187,   813,  1188,   456,   134,  1457,  1189,   135,    59,
     671,   385,   136,   137,   828,   472,   473,   474,   475,   476,
    1199,  1471,  1701,  1698,  1704,  1705,  2023,  2132,  1472,  2024,
    2141,  1473,  2250,  2021,  2125,  2126,  2253,  2550,  2660,  2635,
    1692,  1710,  1884,  2018,  2122,  2020,  1693,    60,    61,    62,
      63,    64,    65,    66,    67,  1055,   138,   139,   487,   140,
     724,   141,   142,  1487,  1722,  1723,  1216,   143,  1720,  2289,
    2445,  2447,  2570,  2150,  2149,  2028,  1721,  1718,  2148,  2026,
    2025,  1897,  1719,  1901,  2029,  2293,  2453,  2151,  1902,  1905,
    2030,  2297,  2457,  2152,  1906,  2451,  2561,   386,   144,  1494,
    1217,   145,  1727,  2154,  2320,  2472,  2153,  2032,  1728,    68,
      69,   146,   147,  1218,  1505,  1734,  1506,  1740,  1743,  1914,
    1915,  2155,  2325,  2492,   148,   149,   882,   883,   509,   510,
    1536,  1229,   885,    70,   150,   522,   364,   151,  1098,  1100,
     714,  1103,   666,   667,   152,   153,    71,    72,    73,    74,
      75,    76,    77,    78,   321,   678,   154,  1538,   523,   155,
     156,   530,   898,  1939,  1765,  1541,   899
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     357,   272,   577,   540,   779,   781,   546,   578,   924,  1114,
    1535,   325,   718,   453,   547,   326,   327,   471,  1146,   485,
     611,   497,  1532,   854,  1534,   647,  1803,  1531,  1748,   507,
     520,   614,  1559,  1561,  1563,  1564,   529,   819,   903,   486,
     904,   905,  1261,  1039,   910,   911,  2082,  1741,  2089,   508,
     521,   404,  1808,   405,  2092,   406,  1126,   457,   753,   458,
     902,   477,   670,  2061,  2065,   499,  1038,   500,   531,   501,
     686,   502,   687,   532,   698,   688,  1903,   524,   525,  1154,
      80,   328,  2432,   533,  1073,   534,   869,   716,   716,   695,
     575,  2159,   693,   694,   696,  1101,   544,   545,   576,  1144,
    2160,  2161,   907,   908,  2061,  2065,   544,   545,   309,  1144,
    1724,  1535,   775,   776,    81,   777,  2355,  1297,   590,   591,
     592,   593,   594,  1532,    82,   627,    83,    84,  1531,   775,
     776,     1,   777,   731,  1675,   595,   596,   597,   598,   599,
     600,   601,   602,   603,  2166,   755,   604,   774,   695,   686,
    1846,   687,    85,   696,   688,    79,   590,   591,   592,   593,
     594,   545,   757,  1715,   552,   939,   940,   695,  2434,   807,
    1838,  2468,   696,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   689,  2465,   604,   822,  1946,  1947,  1948,   606,
    1331,   531,   695,   695,   695,   638,   532,   696,   696,   696,
     348,  1937,   349,  1949,  1950,  1951,   533,  2469,   534,   759,
     844,   119,   157,   869,  1155,   699,   700,   701,   702,    86,
     550,    87,    88,   708,    89,  2128,    90,   310,    91,  1928,
      92,    93,    94,   887,    95,  2167,   590,   591,   592,   593,
     594,   695,   568,  1155,   315,  2168,   696,    96,    97,    98,
      99,   100,   101,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   713,   695,   604,  1208,   706,   158,   696,  2160,
    2161,   907,   908,  2157,   683,   569,   570,   163,   571,   572,
     573,  1952,  1953,   351,   352,  1751,   699,   700,   701,   702,
     695,  2259,   734,   735,   578,   696,  2415,   695,   719,  1761,
     618,   102,   696,  1938,   353,  1111,   736,   103,   607,   775,
     776,  1215,   777,   104,   105,   159,  1676,   762,   590,   591,
     592,   593,   594,   695,  1220,  1122,   695,   835,   696,   695,
     551,   696,  2129,  1056,   696,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   695,   470,   604,  2518,  1092,   696,
    1127,   287,   699,   700,   701,   702,   919,  1573,  1574,  1048,
    1049,  1050,  1051,  1052,  1334,  1053,  1054,   754,  1057,  1059,
    2429,  1061,  1062,   348,   540,   349,   540,   540,  1535,  2130,
     540,   540,   590,   591,   592,   593,   594,   628,  1278,  2265,
    1532,   314,   695,  2328,  2379,  1531,  1847,   696,  1076,   595,
     596,   597,   598,   599,   600,   601,   602,   603,  2260,  1156,
     604,  2416,   638,  1839,   770,   699,   700,   701,   702,   619,
    1969,   695,   288,  2470,   716,   695,   696,  2466,  2433,  1094,
     696,  2355,   709,  2166,  1099,  1321,  1104,  1594,  1156,   590,
     591,   592,   593,   594,   699,   700,   701,   702,   699,   700,
     701,   702,  2402,  1222,   756,  1223,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   645,   920,   604,   316,   836,
    1295,   758,  1124,  1125,   590,   591,   592,   593,   594,  2160,
    2161,   907,   908,  1202,  1203,   695,   317,  1742,   806,  2519,
     696,   595,   596,   597,   598,   599,   600,   601,   602,   603,
    2471,  1102,   604,  2529,  1158,  2435,   746,  1161,   699,   700,
     701,   702,   695,  2430,  2436,  2171,   322,   696,   760,  2172,
    1509,  2413,  1130,  1323,  2167,  2131,   348,  2380,   349,   906,
     348,  1145,   349,  1922,  2168,   699,   700,   701,   702,   345,
     646,  1872,   917,  2261,  2562,  1196,   346,  1762,  1183,  1149,
    1058,   925,   926,   927,   928,   929,   930,   638,  1763,   716,
     716,  2479,  1047,   347,   548,  1132,  2498,  2397,   938,  2403,
    1209,   355,  2294,  2483,  1209,  1975,   747,  1977,  1209,  2295,
    1979,  1804,  1982,  1984,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,  1262,  2427,
     695,  2083,  1455,  2090,   705,   696,   695,  1809,  1810,  2093,
    1233,   696,  2480,  1235,   535,  2066,   690,   869,  1904,   575,
     536,  1238,   537,   699,   700,   701,   702,   576,   106,   699,
     700,   701,   702,   311,   773,   697,   274,   107,   275,  2464,
     354,   730,  1282,  1131,  2123,  2530,  2162,  1109,  1867,  1868,
    2163,  2373,  2374,  2251,  2127,   348,  2074,   349,   778,  2252,
    2633,  1191,  1873,  1133,   569,   570,   907,   908,   572,   573,
     763,   733,  2296,  1078,  1925,   771,  1899,   569,   570,   907,
     908,   572,   573,   784,  1089,  2037,  1348,  1349,   794,  2641,
     785,  1091,  2643,   365,   697,   690,   804,   639,   577,   941,
     578,   578,  1864,   356,  2404,  1535,  1184,  1703,   546,  2049,
     933,   934,   820,   697,   608,   823,   547,  1532,   826,  2041,
    1212,  2047,  1531,   366,  1213,   280,  1639,   275,   833,  1157,
    2543,  2544,   590,   591,   592,   593,   594,   535,   697,   697,
     697,  -866,  1411,   536,  1150,   537,  1542,   801,  1543,   595,
     596,   597,   598,   599,   600,   601,   602,   603,  1656,  1192,
     604,  1014,   368,   703,   543,   623,   891,   624,   893,   318,
     319,   320,   541,  1149,   276,  2395,  2374,  2462,  2374,  1575,
    1283,   367,  1314,   369,  1316,   802,   575,   697,  2140,   488,
    1556,  1557,  2521,  2449,   576,  1350,  1351,   767,  1299,  1300,
    1301,  1302,  1303,  1304,   323,   324,  1315,   640,  1317,   697,
    1318,  1319,  1381,  1736,  1685,  2495,  1744,  2375,   803,  1015,
    1535,   574,  1865,   543,  1224,   620,   548,   590,   591,   592,
     593,   594,  1532,  1149,   549,  1421,   697,  1531,  1866,  1629,
    1207,  1375,  1376,   697,   595,   596,   597,   598,   599,   600,
     601,   602,   603,  1386,  2188,   604,  2008,  2009,   553,  2190,
     943,  2191,   554,   276,  2193,   944,  1151,  1152,   556,   697,
    1398,  1399,   697,  1253,  1288,   697,  1401,  1402,  2224,  2376,
    1404,  1405,  1289,  1407,  1585,  1409,  2249,  1586,   768,  1587,
     697,   623,   711,   624,  1225,  1065,   695,  1066,  1422,   712,
    1706,   696,  1687,   625,  1426,  1273,   695,  1274,   323,   324,
     695,   696,  1458,   769,   555,   696,  1459,  2319,   634,   699,
     700,   701,   702,   557,   775,   776,  1258,   777,  1259,   699,
     700,   701,   702,   699,   700,   701,   702,  1254,   697,  1535,
    1535,  2375,  1619,  2375,   587,   635,  1514,  2612,  2613,   695,
     558,  1532,  1532,  2041,   696,  1539,  1531,  1531,  2627,  2628,
     323,   324,  1680,   641,  1275,   854,  1276,   697,  1150,  1883,
    1324,   697,   699,   700,   701,   702,  1630,   945,   642,   643,
     682,  2331,   946,  1332,  2332,   559,   657,  1115,   387,   590,
     591,   592,   593,   594,  1255,  1343,   560,  1344,  1367,  1372,
     855,  1694,  1322,  2396,   561,  2463,   595,   596,   597,   598,
     599,   600,   601,   602,   603,  1134,  1135,   604,  1137,  1373,
     636,  2321,  2322,   544,   545,  2162,  1964,  2323,  1150,  1256,
     562,   697,  1695,   588,   775,   776,   489,   777,  1163,  1221,
    1165,   605,  1167,  1168,   637,  1170,  1171,  1172,  1173,  1174,
    1175,  1226,  1876,  1178,   943,  1180,  1181,  1696,   697,  1241,
    1186,   658,   610,  1588,  1153,  1590,  2290,  1190,  1193,  1456,
     612,  1194,  2291,   875,  1358,  1197,  1738,  1396,   490,   491,
    1877,  1878,   540,   492,   540,  1284,  1285,  1286,  1287,  2324,
    1151,  1152,   617,  1069,   493,   622,  1485,  1492,  1503,  1612,
     722,   723,  2067,   494,  1609,  2075,  1641,  1835,  1214,  2067,
    2075,   629,  1352,  1535,  1841,   631,  1486,  1493,  1504,   633,
    2507,  1219,  2508,  1874,  2551,  1532,  1880,   546,   648,  1631,
    1531,  1632,   649,  1633,  1634,   547,  1231,  1635,  1232,   590,
     591,   592,   593,   594,   775,   776,   697,  1737,   638,   349,
    1151,  1152,   697,  1105,  1106,  1107,   595,   596,   597,   598,
     599,   600,   601,   602,   603,  1682,  2292,   604,   590,   591,
     592,   593,   594,  1689,   650,  2201,   348,  2592,   349,  2206,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   651,  1830,   604,   595,   596,   597,
     598,   599,   600,   601,   602,   603,  1831,  1832,   604,  2202,
     574,  1730,  1898,   602,   603,   652,  1732,   604,  1768,  1908,
    1145,   751,   752,  1266,  1769,  1770,  1771,  1772,   653,  1773,
    1774,  1775,  1070,   846,  1776,   654,  1777,  1778,   655,  1545,
    1962,   656,  1779,  1780,  1227,  1550,  1962,  1551,  1552,  1553,
    1554,   590,   591,   592,   593,   594,  1071,  1065,  1764,  1602,
    1566,  1599,   315,  1699,   544,   545,  1569,  1144,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   673,  1891,   604,
    1072,   590,   591,   592,   593,   594,   668,  1555,  1654,  2567,
    2568,  2569,  2203,  2204,  1861,   876,   845,   846,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   675,   575,   604,
     676,  1833,   847,   280,   677,   275,   576,   848,   590,   591,
     592,   593,   594,  1645,   877,   -66,   -66,  1716,   -66,   838,
     839,  1716,   853,   878,   679,   595,   596,   597,   598,   599,
     600,   601,   602,   603,  1768,   684,   604,  1843,  1655,  1688,
    1769,  1770,  1771,  1772,   685,  1773,  1774,  1775,   358,   855,
    1776,  1686,  1777,  1778,  1824,  1825,   692,  1826,  1779,  1780,
     716,  1862,   545,  1646,  1715,   715,  1380,  1382,  1852,   725,
    1853,  2650,  1794,  1932,  1933,   707,  1390,  1934,  1392,   590,
     591,   592,   593,   594,  1935,  1936,   710,  1739,  2142,  2143,
     726,   659,  2144,  2145,  2146,   720,   595,   596,   597,   598,
     599,   600,   601,   602,   603,  1885,  1886,   604,   727,  1305,
    1889,  1647,  2360,   790,   791,  1648,  1420,  1893,  1649,  1650,
    1894,   728,  1986,  2667,  1987,  1428,  1306,   729,   359,   360,
     361,   737,   697,  2013,   660,   661,   662,   663,   664,   665,
    1827,   276,   697,   739,  2361,  1910,   697,  1912,  1828,  1095,
    1096,  1476,  1395,   738,  1397,  1916,   741,  1989,  1990,   590,
     591,   592,   593,   594,   742,  1307,  1515,  1516,  1711,  1712,
    1713,  1714,  1359,  1002,  1003,  1004,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   697,   743,   604,   879,   880,
     881,  2147,   744,   672,  1954,   674,   283,  1005,  1006,   745,
    1954,  1007,  1749,  1749,  2057,  1753,   284,   840,   841,  1754,
    1755,  2181,  2182,   748,  1817,   749,  2362,  1749,   750,  2184,
    2185,  1244,  1245,   281,   282,   285,   286,  1250,  1251,  1145,
     761,  1326,   313,   716,   716,  2522,  2523,   845,   846,  1799,
     764,  1800,  2524,  2525,  2526,  2527,   783,   590,   591,   592,
     593,   594,   766,   847,  2363,  1339,  1340,  1308,   848,   765,
    2364,  1669,   786,  2111,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   853,   787,   604,   590,   591,   592,   593,
     594,   789,  2365,   544,   866,   867,   868,  1341,  1342,   792,
    1605,  1606,   788,   595,   596,   597,   598,   599,   600,   601,
     602,   603,  1576,  1577,   604,  2385,  2386,  2387,  2388,  2389,
    2390,  2391,  2392,   171,   793,   173,   174,   575,  1801,  1802,
    2033,  1806,  1807,   796,  1640,   576,   590,   591,   592,   593,
     594,  1716,  2616,  2617,  2618,  2619,  2620,  1850,  1851,   795,
    2116,  2117,  2118,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   797,  1309,   604,  2069,  2070,  2071,  2072,    82,
     798,    83,    84,  1857,  1858,   799,  2060,  2621,  2622,  2623,
    2624,  2625,  2068,   590,   591,   592,   593,   594,  1943,  1944,
    1677,   800,  1679,  1681,  1919,  1683,  2061,  2062,  2080,  2081,
     595,   596,   597,   598,   599,   600,   601,   602,   603,  2085,
    2086,   604,  1697,   805,  1700,  2194,  2195,  2096,  2097,  1707,
    1310,   809,  1240,   811,  2357,  2358,   716,   716,   716,  2369,
    2370,  2514,  2515,   808,  1252,   810,  2120,  1995,  1781,  1729,
    2532,  2533,  1918,  1946,  1947,  1948,  2199,  2343,  2344,  1651,
    1926,   817,   812,   815,  1929,   814,  1931,   818,   821,   825,
    1949,  1950,  1951,   816,   824,   827,   830,   834,  1994,   831,
     837,  2095,   857,   390,  1145,  1145,   842,   832,   391,   392,
    2177,   843,   855,  1954,   858,  1954,   394,   859,  1971,   860,
     861,   871,    96,    97,    98,    99,   100,   101,  1362,   872,
    2164,   862,   873,   863,   874,  1257,   478,   615,   616,   590,
     591,   592,   593,   594,   864,  1311,   865,   886,   884,  2096,
    2097,  2098,   716,  2200,   888,   889,   595,   596,   597,   598,
     599,   600,   601,   602,   603,  1264,   892,   604,  1952,  1953,
     890,   894,   895,   395,   896,   912,   396,  1312,  1313,   901,
    2255,   897,  2099,   900,  2258,   913,  2262,  2263,   914,  2266,
    1460,   915,   575,   575,  1788,  1461,   918,   931,   921,   390,
     576,   576,  1336,  2100,   391,   392,  2101,  2102,  1363,   942,
     604,   390,   394,   947,  2475,   932,   391,   392,   948,  1010,
     526,  1011,  1012,   479,   394,  1084,  1859,  1013,  1018,  1020,
    2339,  1079,  2340,  2341,  2342,  1021,   590,   591,   592,   593,
     594,  2103,  1060,  1749,  1063,  1064,  1067,  1869,  1870,  1871,
    1068,  2044,  1875,   595,   596,   597,   598,   599,   600,   601,
     602,   603,  1074,  2367,   604,  1077,  2371,  1120,  1085,   395,
    1086,  2381,   396,  1337,  1090,  1093,  1887,  1097,  2393,  1121,
    1110,   395,  1123,  1128,   396,  1129,  2405,  2406,  1136,  1138,
    2409,  1139,  2411,  1140,  2414,  1462,  2417,   845,   846,  1147,
    1141,  1143,  1159,  2421,  1160,  1907,  1162,  1164,  1166,  1169,
    1176,  1177,  1179,   847,  1182,  2423,  2424,  1185,   848,  2425,
    2426,  1668,  1195,  1364,  1365,  1200,  1201,  2509,  2510,  1204,
    1211,  2513,   876,   849,  1230,  1234,  2207,  1239,  1242,   850,
    1243,  2450,  1246,  1041,  1247,  2450,  1260,  1263,  1265,  2459,
    1270,  1271,  1277,  1795,  1272,  1279,  2473,  2541,  2542,  2651,
     323,   324,  2654,  2655,  1296,  2484,  1280,   590,   591,   592,
     593,   594,  1281,  1298,  2656,  1325,  2173,  2174,  2175,  1327,
    2176,  1333,  1335,  1346,   595,   596,   597,   598,   599,   600,
     601,   602,   603,  1463,  1347,   604,   480,   481,   482,   483,
    2662,  2663,  1338,   716,   716,  2664,  2665,   716,  1354,  2096,
    2097,  1356,  1384,  2520,  1385,  1042,   371,  1357,  2164,  2164,
    1510,  1377,  2000,  2534,  2535,  2536,  2537,  2538,  1378,  1379,
    1387,  1464,  1388,   716,   716,   845,   846,  1389,  1391,  2630,
    2631,  1796,  2099,   372,  1511,  2545,  2546,  2547,  1465,  1403,
    1466,   847,  2594,  1716,  1467,  1406,   848,  2634,  1468,  1469,
    2133,  2016,  2017,  2554,  2555,  1474,  1537,  1408,  1540,  2558,
    1797,   849,  1410,  1412,  1413,  1544,   373,   850,  1414,  1415,
    2564,  1416,  1043,  1417,  2571,  1546,  2329,  2574,  2575,  1418,
    1547,  2034,  2578,  2579,  1044,  1045,  1419,  1565,  1423,  1424,
    2585,  2134,  1567,  1425,  1427,  1429,  1046,  1477,  2135,  1507,
    1508,  1568,  2586,  2587,  2588,  1572,  1578,   484,  1579,  1580,
    1798,  1449,   846,  1581,  1582,  2591,  1583,  2104,   716,  2595,
     390,   374,  2596,  2597,  1584,   391,   392,  1589,  1591,  1592,
     375,  1593,  1600,   394,  1601,  1450,  1603,  1604,  1607,  1608,
    1613,  2491,  1621,  1624,  1625,  1666,  2606,  2607,  1626,  1627,
    1628,  1638,  1642,  1643,  1644,  1667,  1653,  1813,  1657,  1658,
     160,  1659,   161,   162,   163,   164,   165,   166,  1660,   167,
    1661,  1662,  1663,  1664,  1665,  1671,  1670,   168,   169,   935,
    1672,  1674,   170,  1678,  2119,  1470,  1684,  1673,  1690,  1691,
     395,  1702,  1708,   396,   171,   172,   173,   174,  1709,  1725,
     175,  1733,  1726,  1366,  2638,   527,  2639,  2640,   590,   591,
     592,   593,   594,  1731,  2642,   528,  2136,  2137,  2138,  1735,
    1745,  2645,  1747,  1752,  1756,   595,   596,   597,   598,   599,
     600,   601,   602,   603,  1757,   376,   604,  1758,  1759,   377,
    1760,  1766,  1767,  1805,  1811,  1812,  1814,  1815,  2500,  1816,
     176,   177,   563,   564,   565,   566,   178,   179,  1818,   180,
     181,   182,   183,   184,   185,   186,   187,   188,  2196,  1820,
    1821,  1822,  1823,   300,  1836,  1842,   189,   190,   191,  1844,
    1845,   192,  2211,  1972,   590,   591,   592,   593,   594,   193,
     378,  1848,  1849,  1854,  1860,   379,   380,   194,  2254,   301,
    2256,   595,   596,   597,   598,   599,   600,   601,   602,   603,
    1855,  1882,   604,  1888,  2270,  2271,  2272,   590,   591,   592,
     593,   594,   302,  1890,   303,  1881,   304,  1856,   381,  1863,
    1892,  1909,  1895,  1911,   595,   596,   597,   598,   599,   600,
     601,   602,   603,  1896,  1495,   604,   590,   591,   592,   593,
     594,  1917,   382,  1941,  1920,  1921,   383,  1930,  1451,  1452,
    1453,  1940,  1942,   595,   596,   597,   598,   599,   600,   601,
     602,   603,  1945,  1965,   604,   195,  1959,  2139,  1980,  1974,
    1973,  1970,  1978,  2003,  2002,  1996,  1988,  2001,  1985,  1998,
    2005,  2014,  2006,  2007,   590,   591,   592,   593,   594,   305,
     306,   307,   308,  2401,   384,  2015,  2019,  2027,  2031,  2604,
    2410,   595,   596,   597,   598,   599,   600,   601,   602,   603,
    2647,  2648,   604,  2035,   590,   591,   592,   593,   594,  2038,
    2052,  2053,  2054,  2055,  2059,  2056,  2076,  2058,  2064,  2112,
     196,   595,   596,   597,   598,   599,   600,   601,   602,   603,
    2078,  2439,   604,  2079,  2084,  2087,  2156,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,  2088,  2091,  2460,
    -867,  -867,  -867,  2467,  2158,  2183,  2186,  2187,  2189,  2192,
    2197,  2198,  2208,  2264,   207,   208,  2210,  -867,  -867,  -867,
    -867,  -867,   600,   601,   602,   603,  2257,  2267,   604,  2268,
    2269,   160,  2273,   161,   162,   163,   164,   165,   166,  2330,
     167,  2077,  2326,  2334,  2333,  2345,   209,  2346,   168,   169,
    2347,  2349,  1495,   170,    82,  2350,    83,    84,  2348,  2352,
    2351,  2353,  2356,  2368,  1454,   171,   172,   173,   174,  2359,
    2372,   175,   210,   211,   212,   213,  2382,  2378,  2539,   329,
     330,   331,   332,   333,   334,   335,   336,   337,  2383,   338,
     339,   340,   341,   342,   343,  2384,  2398,  2394,  2548,  2399,
    2407,  2408,  2400,  2412,  2418,  2419,  2420,  2552,  2553,  2437,
    2431,  2441,  2422,  2438,  2443,  2556,  2557,  2442,  2448,  2559,
    2440,   176,   177,   563,   564,   565,   566,   178,   179,  2444,
     180,   181,   182,   183,   184,   185,   186,   187,   188,  2446,
    2577,  1903,  2454,  2458,  2581,  2461,  2583,   189,   190,   191,
    2474,  2477,   192,  2476,  2478,  2481,   214,   215,   390,  2482,
     193,  2485,  2486,   391,   392,  2589,  2590,  2489,   194,  2487,
    2488,   394,   216,   217,  2493,  2505,  2593,    96,    97,    98,
      99,   100,   101,  2598,  2490,  2599,  2600,  2601,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,  2506,  2516,  2540,  2549,
    2560,  2563,  2565,  2566,  2499,  2573,  2501,  2576,   395,  2502,
    2503,   396,  2580,  2511,  2504,   246,   247,  2602,   248,  2603,
    2512,  2636,  2646,  2608,   249,  2179,   195,  2531,  2611,  2632,
     590,   591,   592,   593,   594,  2614,  2609,  2615,  2659,  2626,
    2637,  2649,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,  2644,  2652,   604,   595,
     596,   597,   598,   599,   600,   601,   602,   603,  2653,  2661,
     604,   589,  2335,  2657,  2658,  2666,   590,   591,   592,   593,
     594,  1290,  2668,  1291,  1292,  1746,  1966,  1496,  2180,  2178,
    1967,   196,  1789,   595,   596,   597,   598,   599,   600,   601,
     602,   603,  1790,  1791,   604,  1792,  1968,   923,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,  1329,  1819,
    1497,  1498,   160,  2327,   161,   162,   163,   164,   165,   166,
    2496,   167,  1082,  1267,   567,   207,   208,  1268,  2497,   168,
     169,  1558,   909,   498,   170,  1269,  1447,  1611,  2336,   829,
    1198,   590,   591,   592,   593,   594,   171,   172,   173,   174,
    1570,  1571,   175,  2610,  2629,  1617,  1019,   209,   595,   596,
     597,   598,   599,   600,   601,   602,   603,  2094,  1991,   604,
    1400,  2337,  2012,   590,   591,   592,   593,   594,  2004,  2121,
    2572,  2022,  2428,   210,   211,   212,   213,  2452,  2582,  2456,
     595,   596,   597,   598,   599,   600,   601,   602,   603,  2584,
    2338,   604,   176,   177,  2455,  1913,  1228,  1345,   178,   179,
    1320,   180,   181,   182,   183,   184,   185,   186,   187,   188,
       0,  1075,     0,     0,     0,     0,     0,     0,   189,   190,
     191,     0,     0,   192,   590,   591,   592,   593,   594,     0,
       0,   193,     0,     0,     0,     0,     0,     0,  2494,   194,
       0,   595,   596,   597,   598,   599,   600,   601,   602,   603,
       0,     0,   604,     0,     0,  1924,     0,   214,   215,   590,
     591,   592,   593,   594,  1499,     0,     0,     0,  2605,  1500,
       0,  1501,     0,   216,   217,     0,   595,   596,   597,   598,
     599,   600,   601,   602,   603,     0,     0,   604,     0,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   195,     0,     0,
    1330,     0,     0,     0,  2212,     0,     0,     0,     0,     0,
       0,     0,  1502,  2213,     0,     0,   246,   247,  2214,   248,
     590,   591,   592,   593,   594,   249,     0,     0,     0,     0,
       0,     0,   590,   591,   592,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,     0,     0,   604,   595,
     596,   597,   598,   599,   600,   601,   602,   603,     0,     0,
     604,     0,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     5,     6,     0,     0,     0,     0,     0,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,     0,   167,     0,     0,     0,   207,   208,     0,     0,
     168,   169,  1562,     0,     0,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,   173,
     174,     0,     0,   175,     0,     0,     0,  2215,   209,     0,
       0,     0,     0,     7,     0,     0,  2096,  2097,     0,     0,
       0,     0,     0,     0,     0,     0,     8,     0,     0,     0,
       0,     0,     0,     0,   210,   211,   212,   213,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2099,
       0,     9,    10,   176,   177,     0,     0,     0,     0,   178,
     179,     0,   180,   181,   182,   183,   184,   185,   186,   187,
     188,  2216,  2217,     0,     0,  2218,     0,     0,     0,   189,
     190,   191,     0,     0,   192,     0,     0,     0,     0,     0,
       0,    11,   193,    12,     0,    13,     0,     0,     0,     0,
     194,     0,     0,     0,     0,     0,    14,     0,  2219,     0,
       0,     0,  1923,     0,  2220,  2221,  2222,     0,   214,   215,
       0,     0,     0,     0,  2036,    82,     0,    83,    84,     0,
       0,     0,    15,     0,   216,   217,    16,     0,     0,     0,
       0,    17,    18,     0,     0,     0,     0,     0,     0,     0,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   195,   329,
     330,   331,   332,   333,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,     0,     0,   246,   247,     0,
     248,     0,     0,     0,     0,     0,   249,     0,     0,     0,
       0,    82,     0,    83,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   390,
       0,     0,     0,  2043,   391,   392,     0,     0,     0,     0,
       0,     0,   394,   196,     0,     0,     0,     0,    96,    97,
      98,    99,   100,   101,     0,     0,     0,    19,     0,     0,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,     0,   167,     0,     0,     0,   207,   208,     0,
       0,   168,   169,  1976,     0,     0,   170,     0,     0,   395,
       0,     0,   396,     0,     0,     0,     0,     0,   171,   172,
     173,   174,   503,     0,   175,   390,     0,     0,     0,   209,
     391,   392,     0,     0,   504,     0,  2050,    82,   394,    83,
      84,     0,     0,     0,    96,    97,    98,    99,   100,   101,
       0,     0,     0,     0,     0,   210,   211,   212,   213,     0,
       0,     0,   289,     0,   290,     0,     0,     0,     0,  2274,
       0,  2051,     0,     0,   176,   177,  1478,     0,     0,     0,
     178,   179,     0,   180,   181,   182,   183,   184,   185,   186,
     187,   188,     0,     0,     0,   395,   291,     0,   396,     0,
     189,   190,   191,   292,  2223,   192,     0,     0,     0,     0,
       0,   511,     0,   193,     0,     0,     0,     0,     0,     0,
       0,   194,  2275,  2276,     0,     0,     0,   505,     0,     0,
       0,    20,    21,   293,     0,   294,     0,     0,     0,   214,
     215,   390,    82,   295,    83,    84,   391,   392,  2277,     0,
    1479,     0,   296,     0,   394,   216,   217,     0,   512,     0,
      96,    97,    98,    99,   100,   101,     0,     0,     0,     0,
       0,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   195,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   395,     0,     0,   396,     0,     0,  2278,   246,   247,
       0,   248,     0,     0,     0,     0,     0,   249,     0,     0,
    2279,     0,    82,     0,    83,    84,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   390,     0,     0,     0,
       0,   391,   392,     0,     0,  1488,     0,     0,     0,   394,
       0,   297,     0,     0,   196,    96,    97,    98,    99,   100,
     101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,     0,   167,     0,     0,     0,   207,   208,
     513,     0,   168,   169,  1981,     0,   395,   170,     0,   396,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   171,
     172,   173,   174,     0,     0,   175,   390,     0,     0,     0,
     209,   391,   392,     0,     0,   393,     0,     0,     0,   394,
     298,     0,     0,   506,     0,    96,    97,    98,    99,   100,
     101,     0,     0,     0,     0,     0,   210,   211,   212,   213,
       0,     0,     0,     0,   299,     0,     0,     0,     0,     0,
       0,     0,     0,   514,   515,   176,   177,     0,     0,     0,
       0,   178,   179,     0,   180,   181,   182,   183,   184,   185,
     186,   187,   188,     0,     0,     0,   395,     0,     0,   396,
       0,   189,   190,   191,     0,     0,   192,     0,     0,     0,
       0,     0,     0,     0,   193,     0,     0,     0,   516,   517,
     518,   397,   194,     0,  2280,     0,  2281,  2282,     0,   519,
       0,  2283,  2284,     0,  2285,     0,     0,     0,     0,     0,
     214,   215,  2286,  2287,     0,     0,     0,     0,     0,  1480,
    1481,     0,     0,  1482,     0,     0,   216,   217,  1483,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1489,     0,   489,     0,     0,     0,     0,   246,
     247,     0,   248,     0,     0,     0,     0,     0,   249,     0,
      82,     0,    83,    84,     0,     0,     0,     0,  2288,     0,
       0,     0,     0,     0,     0,  1484,   390,     0,     0,     0,
       0,   391,   392,     0,     0,     0,   490,   491,     0,   394,
       0,   492,     0,     0,     0,   196,     0,     0,  1490,     0,
       0,     0,   493,     0,     0,     0,     0,     0,     0,     0,
       0,   494,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,     0,   167,     0,     0,     0,   207,
     208,     0,     0,   168,   169,  1983,   395,     0,   170,   396,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,   173,   174,   390,     0,   175,     0,     0,   391,
     392,   209,     0,  1369,     0,     0,   981,   394,   982,   983,
    1491,     0,     0,    96,    97,    98,    99,   100,   101,     0,
       0,     0,     0,     0,     0,     0,     0,   210,   211,   212,
     213,     0,   963,   964,     0,     0,     0,     0,     0,     0,
     965,     0,     0,     0,     0,     0,   176,   177,     0,     0,
       0,     0,   178,   179,     0,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   395,     0,   966,   396,   967,     0,
       0,     0,   189,   190,   191,     0,     0,   192,     0,     0,
       0,     0,     0,     0,     0,   193,     0,     0,     0,     0,
       0,     0,   968,   194,     0,     0,     0,     0,     0,     0,
     398,     0,   969,   970,     0,   971,   972,   973,   974,   975,
       0,   214,   215,     0,     0,     0,   976,   977,   978,     0,
     979,   980,     0,     0,     0,     0,     0,   216,   217,   984,
     985,   986,   987,   988,   989,   495,     0,     0,  1370,     0,
       0,     0,     0,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   195,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     246,   247,     0,   248,     0,     0,     0,     0,     0,   249,
       0,     0,     0,   459,    82,     0,    83,    84,     0,     0,
       0,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   196,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,     0,   167,     0,     0,     0,
     207,   208,     0,     0,   168,   169,     0,     0,     0,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   171,   172,   173,   174,     0,     0,   175,   390,     0,
       0,     0,   209,   391,   392,     0,     0,     0,     0,     0,
     496,   394,     0,     0,     0,     0,     0,    96,    97,    98,
      99,   100,   101,     0,     0,     0,     0,     0,   210,   211,
     212,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   176,   177,     0,
       0,     0,     0,   178,   179,     0,   180,   181,   182,   183,
     184,   185,   186,   187,   188,     0,     0,     0,   395,     0,
       0,   396,     0,   189,   190,   191,     0,     0,   192,     0,
       0,     0,     0,     0,   460,     0,   193,     0,     0,     0,
       0,     0,     0,     0,   194,     0,     0,     0,  1371,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   214,   215,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   216,   217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   195,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   246,   247,     0,   248,     0,     0,     0,     0,     0,
     249,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1517,   196,     0,     0,
       0,     0,     0,     0,     0,     0,   461,   462,   463,   464,
       0,     0,     0,     0,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   172,     0,     0,     0,     0,   175,
       0,     0,     0,     0,   465,     0,     0,     0,     0,     0,
     466,   207,   208,   467,     0,     0,   468,     0,     0,     0,
       0,     0,  1518,  1519,  1520,  1521,  1522,  1523,  1524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1517,     0,     0,   209,     0,  1525,     0,     0,  1526,     0,
       0,     0,     0,     0,     0,   178,   179,     0,   180,   181,
     182,   183,   184,   185,   186,  1527,     0,     0,   172,   210,
     211,   212,   213,   175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1528,     0,  1529,     0,  1518,  1519,  1520,  1521,
    1522,  1523,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1525,
       0,     0,  1526,     0,     0,     0,     0,     0,     0,   178,
     179,     0,   180,   181,   182,   183,   184,   185,   186,  1527,
       0,     0,   469,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,   215,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1528,     0,  1529,   216,
     217,     0,     0,     0,   195,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,     0,   248,     0,     0,     0,   196,
       0,   249,     0,     0,     0,     0,     0,     0,   195,     0,
       0,     0,     0,     0,     0,     0,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,   208,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1517,   196,     0,   209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     172,   210,   211,   212,   213,   175,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   208,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1518,  1519,
    1520,  1521,  1522,  1523,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   209,
       0,  1525,     0,     0,  1526,     0,     0,     0,     0,     0,
       0,   178,   179,     0,   180,   181,   182,   183,   184,   185,
     186,  1527,     0,     0,     0,   210,   211,   212,   213,     0,
       0,     0,     0,     0,     0,   214,   215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
    1529,   216,   217,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   214,
     215,     0,     0,     0,   246,   247,     0,     0,     0,     0,
       0,  1530,     0,     0,     0,   216,   217,     0,     0,     0,
     195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   246,   247,
       0,     0,     0,     0,  2039,   196,  2045,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,     0,     0,   172,     0,     0,     0,     0,   175,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
     208,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1430,     0,     0,     0,     0,     0,     0,
       0,   209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,   179,     0,   180,   181,
     182,   183,   184,   185,   186,  2046,     0,   210,   211,   212,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   489,   544,
     866,   867,   868,     0,     0,     0,     0,     0,     0,  1431,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2298,     0,     0,   171,
       0,   173,   174,     0,     0,     0,  1358,     0,     0,     0,
    1432,  1433,     0,     0,     0,   492,     0,     0,     0,     0,
       0,   214,   215,     0,     0,     0,   493,     0,     0,     0,
       0,     0,     0,     0,     0,   494,     0,   216,   217,     0,
       0,     0,     0,     0,   195,     0,     0,     0,     0,     0,
       0,     0,     0,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,     0,  1434,     0,  1435,     0,  1436,     0,     0,     0,
       0,     0,     0,     0,  1023,   846,     0,     0,     0,     0,
     246,   247,     0,     0,     0,     0,  1024,     0,     0,   196,
    1025,     0,     0,  1026,  1027,     0,     0,     0,  1028,     0,
       0,     0,     0,     0,     0,     0,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,     0,  1029,  2096,  2097,
    2299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   207,   208,     0,     0,     0,     0,     0,
    1030,  1031,  1032,     0,  1033,  1034,     0,  1035,  1036,  1037,
       0,  2099,     0,     0,     0,     0,     0,     0,     0,  1437,
       0,     0,     0,     0,     0,   209,     0,     0,  1438,  1439,
       0,     0,     0,  2300,  2301,  1440,     0,  2302,     0,  1441,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1442,   210,   211,   212,   213,     0,     0,     0,     0,  1443,
       0,  1444,     0,     0,  1445,  2303,     0,     0,     0,     0,
    2304,     0,     0,     0,     0,  2305,     0,     0,  2306,     0,
       0,     0,  2226,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2307,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2308,   214,   215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   216,   217,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,  2309,   407,   408,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2096,  2097,     0,     0,   246,   247,     0,     0,  2310,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   409,
       0,     0,     0,     0,     0,     0,     0,     0,  2311,     0,
       0,     0,     0,  2099,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1446,     0,     0,     0,     0,   410,
       0,  2227,     0,   195,     0,  2228,  2229,     0,     0,  2230,
    2231,     0,     0,     0,     0,  2312,  2313,  2314,  2315,     0,
    2316,     0,     0,     0,  2317,     0,     0,     0,     0,     0,
       0,     0,     0,  2232,     0,     0,     0,  2233,   390,     0,
       0,     0,  2234,   391,   392,     0,   411,   412,     0,  2235,
       0,   394,   413,     0,  2236,     0,     0,   414,   415,   416,
     417,     0,     0,     0,     0,     0,     0,     0,   196,     0,
     418,     0,     0,     0,   419,     0,   420,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,     0,  2318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2237,     0,   395,     0,
       0,   396,   207,   208,     0,  2238,     0,     0,     0,     0,
     421,     0,     0,     0,   422,     0,     0,     0,     0,     0,
       0,     0,     0,   423,     0,  2239,     0,     0,     0,     0,
       0,     0,     0,     0,   209,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     424,   425,   426,   427,  2240,   428,     0,  2241,  2242,  2243,
     210,   211,   212,   213,     0,  2244,     0,     0,     0,     0,
    2245,     0,     0,     0,     0,   429,   430,     0,   431,   432,
    2246,     0,   433,   434,     0,     0,     0,  2247,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   435,   436,
       0,     0,     0,   437,   438,   439,     0,     0,     0,     0,
       0,     0,   440,     0,     0,     0,   441,     0,     0,   442,
     443,     0,   444,     0,   445,     0,     0,     0,   446,   447,
       0,   448,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   449,     0,   214,   215,     0,     0,     0,     0,
     450,   451,     0,     0,     0,     0,     0,     0,     0,     0,
     216,   217,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2248,     0,
       0,     0,     0,   246,   247,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   452
};

static const yytype_int16 yycheck[] =
{
     102,     7,   249,   160,   427,   428,   165,   249,   556,   732,
    1229,    81,   367,   133,   165,    85,    86,   137,   778,   139,
     279,   141,  1229,   491,  1229,   299,     7,  1229,    25,   149,
     150,   282,  1260,  1261,  1262,  1263,   156,   461,   531,   139,
     533,   534,     7,   630,   537,   538,     7,    61,     7,   149,
     150,   128,     7,   130,     7,   132,    82,   134,    47,   136,
       7,   138,   313,    11,    12,   142,   630,   144,    15,   146,
      15,   148,    17,    20,   353,    20,    22,   154,   155,   781,
       3,    87,   119,    30,   671,    32,   503,   366,   367,    15,
     249,     6,   351,   352,    20,   158,    17,    18,   249,    20,
      15,    16,    17,    18,    11,    12,    17,    18,    39,    20,
    1482,  1330,    17,    18,    37,    20,  2197,  1040,     8,     9,
      10,    11,    12,  1330,    47,     3,    49,    50,  1330,    17,
      18,     4,    20,   392,   159,    25,    26,    27,    28,    29,
      30,    31,    32,    33,  2042,    47,    36,   426,    15,    15,
     133,    17,    75,    20,    20,     0,     8,     9,    10,    11,
      12,    18,    47,    20,   170,    30,    31,    15,   119,   448,
      34,   163,    20,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    48,   247,    36,   464,     8,     9,    10,    39,
    1081,    15,    15,    15,    15,    20,    20,    20,    20,    20,
      20,   463,    22,    25,    26,    27,    30,   199,    32,    47,
     489,     3,     3,   630,    45,    38,    39,    40,    41,   142,
      31,   144,   145,    22,   147,   265,   149,   158,   151,  1758,
     153,   154,   155,   512,   157,  2042,     8,     9,    10,    11,
      12,    15,   248,    45,    22,  2042,    20,   170,   171,   172,
     173,   174,   175,    25,    26,    27,    28,    29,    30,    31,
      32,    33,   364,    15,    36,    39,   356,     3,    20,    15,
      16,    17,    18,  2039,   344,    15,    16,    17,    18,    19,
      20,   103,   104,   193,   194,  1519,    38,    39,    40,    41,
      15,   163,   394,   395,   536,    20,   320,    15,   368,  1533,
      39,   224,    20,   565,   214,   729,   396,   230,   158,    17,
      18,   859,    20,   236,   237,     3,   341,   419,     8,     9,
      10,    11,    12,    15,   872,   748,    15,    48,    20,    15,
     141,    20,   372,   158,    20,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    15,   137,    36,    48,   703,    20,
     376,     3,    38,    39,    40,    41,    31,  1280,  1281,   633,
     634,   635,   636,   637,  1087,   639,   640,   356,   642,   643,
     307,   645,   646,    20,   531,    22,   533,   534,  1597,   419,
     537,   538,     8,     9,    10,    11,    12,   265,  1023,   210,
    1597,   267,    15,  2159,   163,  1597,   379,    20,   677,    25,
      26,    27,    28,    29,    30,    31,    32,    33,   280,   240,
      36,   435,    20,   277,   237,    38,    39,    40,    41,   158,
    1792,    15,   182,   415,   703,    15,    20,   491,   465,   708,
      20,  2512,   231,  2331,   713,  1070,   715,  1328,   240,     8,
       9,    10,    11,    12,    38,    39,    40,    41,    38,    39,
      40,    41,   163,   876,   356,   878,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   195,   141,    36,   246,   190,
    1034,   356,   751,   752,     8,     9,    10,    11,    12,    15,
      16,    17,    18,   838,   839,    15,   264,   501,   355,   190,
      20,    25,    26,    27,    28,    29,    30,    31,    32,    33,
     492,   564,    36,    48,   783,   456,   238,   786,    38,    39,
      40,    41,    15,   450,   465,  2044,     3,    20,   356,  2048,
    1222,   210,   237,  1071,  2331,   565,    20,   296,    22,   535,
      20,   778,    22,  1752,  2331,    38,    39,    40,    41,   561,
     270,   237,   548,   415,  2426,   824,   561,    25,   368,    45,
     158,   557,   558,   559,   560,   561,   562,    20,    36,   838,
     839,   356,   632,   152,   561,   251,  2332,  2229,   574,   280,
     849,   176,   465,   421,   853,  1803,   308,  1805,   857,   472,
    1808,   562,  1810,  1811,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   563,   456,
      15,   562,  1189,   562,   354,    20,    15,   562,   563,   562,
     889,    20,   407,   892,   561,   563,   561,  1034,   564,   778,
     567,   900,   569,    38,    39,    40,    41,   778,   551,    38,
      39,    40,    41,   564,   560,   561,    20,   560,    22,  2301,
     550,   391,    20,   358,   565,   190,   561,   724,   242,   243,
     565,    63,    64,   419,   565,    20,   563,    22,   366,   425,
     565,   251,   358,   349,    15,    16,    17,    18,    19,    20,
     420,   165,   565,   679,   564,   425,   564,    15,    16,    17,
      18,    19,    20,   300,   690,  1919,   139,   140,   438,  2571,
     307,   697,  2574,   182,   561,   561,   446,   160,   945,   564,
     942,   943,   184,   193,   415,  1924,   808,  1467,   867,  1928,
     562,   563,   462,   561,   564,   465,   867,  1924,   468,  1924,
     853,  1928,  1924,   484,   857,    20,   349,    22,   478,   560,
     422,   423,     8,     9,    10,    11,    12,   561,   561,   561,
     561,   564,  1166,   567,   240,   569,  1239,   240,  1241,    25,
      26,    27,    28,    29,    30,    31,    32,    33,   560,   349,
      36,   167,   166,   178,    33,    20,   516,    22,   518,   547,
     548,   549,    33,    45,   158,    63,    64,    63,    64,    48,
     158,   542,  1056,   248,  1058,   278,   945,   561,  2024,   564,
     562,   563,  2363,   464,   945,   248,   249,   234,  1049,  1050,
    1051,  1052,  1053,  1054,    20,    21,  1057,   270,  1059,   561,
    1061,  1062,   564,  1498,  1449,   561,  1501,   229,   311,   225,
    2039,   561,   304,    33,    47,   564,   561,     8,     9,    10,
      11,    12,  2039,    45,   141,   560,   561,  2039,   320,    86,
     846,  1120,  1121,   561,    25,    26,    27,    28,    29,    30,
      31,    32,    33,  1132,  2082,    36,   359,   360,    15,  2087,
     563,  2089,   564,   158,  2092,   568,   362,   363,   561,   561,
    1149,  1150,   561,   563,  1033,   561,  1155,  1156,  2114,   291,
    1159,  1160,  1033,  1162,  1308,  1164,  2122,  1311,   325,  1313,
     561,    20,   539,    22,   117,   563,    15,   565,  1177,   546,
     430,    20,  1450,   158,  1183,   563,    15,   565,    20,    21,
      15,    20,  1191,   350,   564,    20,  1195,  2153,   168,    38,
      39,    40,    41,   561,    17,    18,   932,    20,   934,    38,
      39,    40,    41,    38,    39,    40,    41,   563,   561,  2158,
    2159,   229,  1365,   229,   140,   195,  1225,  2518,  2519,    15,
     561,  2158,  2159,  2158,    20,  1234,  2158,  2159,  2529,  2530,
      20,    21,   371,   426,   563,  1433,   565,   561,   240,  1692,
    1072,   561,    38,    39,    40,    41,   223,   563,   441,   442,
      92,   563,   568,  1085,   566,   561,    82,   737,    48,     8,
       9,    10,    11,    12,   563,  1097,   561,  1099,  1118,  1119,
      20,   372,    22,   291,   561,   291,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   765,   766,    36,   768,  1119,
     270,   497,   498,    17,    18,   561,  1786,   503,   240,   563,
     561,   561,   403,   140,    17,    18,   119,    20,   788,    22,
     790,    36,   792,   793,   294,   795,   796,   797,   798,   799,
     800,   274,   304,   803,   563,   805,   806,   428,   561,   568,
     810,   157,     3,  1314,   560,  1316,   465,   817,   818,  1189,
      22,   821,   471,    81,   157,   825,  1499,  1147,   161,   162,
     332,   333,  1239,   166,  1241,    17,    18,    19,    20,   565,
     362,   363,     3,     3,   177,     3,  1216,  1217,  1218,  1358,
     393,   394,  1960,   186,  1355,  1963,  1385,  1615,   858,  1967,
    1968,     3,   565,  2332,  1622,     3,  1216,  1217,  1218,   282,
    2348,   871,  2350,  1671,   243,  2332,  1674,  1286,   158,   376,
    2332,   378,     3,   380,   381,  1286,   886,   384,   888,     8,
       9,    10,    11,    12,    17,    18,   561,    20,    20,    22,
     362,   363,   561,    42,    43,    44,    25,    26,    27,    28,
      29,    30,    31,    32,    33,  1444,   565,    36,     8,     9,
      10,    11,    12,  1452,     3,   163,    20,   243,    22,    23,
       8,     9,    10,    11,    12,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     3,   159,    36,    25,    26,    27,
      28,    29,    30,    31,    32,    33,   170,   171,    36,   197,
     561,  1490,  1720,    32,    33,     3,  1495,    36,    45,  1727,
    1467,   311,   312,   561,    51,    52,    53,    54,     3,    56,
      57,    58,   142,   143,    61,     3,    63,    64,     3,  1245,
    1785,     3,    69,    70,   467,  1251,  1791,  1253,  1254,  1255,
    1256,     8,     9,    10,    11,    12,   166,   563,  1537,   565,
    1266,  1331,    22,   372,    17,    18,  1272,    20,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     3,  1702,    36,
     190,     8,     9,    10,    11,    12,    15,   563,   560,   475,
     476,   477,   280,   281,  1649,   303,   142,   143,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     3,  1467,    36,
       3,   275,   158,    20,   484,    22,  1467,   163,     8,     9,
      10,    11,    12,   139,   332,    17,    18,  1478,    20,   139,
     140,  1482,   178,   341,    25,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    45,    20,    36,  1626,   560,  1451,
      51,    52,    53,    54,    20,    56,    57,    58,   154,    20,
      61,    22,    63,    64,    17,    18,   560,    20,    69,    70,
    1649,  1650,    18,   189,    20,   238,  1126,  1127,   563,   482,
     565,  2609,   563,   130,   131,   560,  1136,   134,  1138,     8,
       9,    10,    11,    12,   141,   142,   560,  1499,   462,   463,
      20,   497,   466,   467,   468,   564,    25,    26,    27,    28,
      29,    30,    31,    32,    33,  1694,  1695,    36,    48,     3,
    1699,   237,    48,   323,   324,   241,  1176,  1706,   244,   245,
    1709,   564,   560,  2661,   562,  1185,    20,   152,   234,   235,
     236,   247,   561,  1866,   540,   541,   542,   543,   544,   545,
    1609,   158,   561,   564,    80,  1734,   561,  1736,  1609,   232,
     233,  1211,  1146,   560,  1148,  1744,   560,  1822,  1823,     8,
       9,    10,    11,    12,   560,    59,  1226,  1227,   180,   181,
     182,   183,   565,   167,   168,   169,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   561,   564,    36,   506,   507,
     508,   565,   564,   316,  1783,   318,   213,   191,   192,   564,
    1789,   195,  1518,  1519,  1937,  1521,   223,   161,   162,  1525,
    1526,  2066,  2067,   320,  1594,   560,   152,  1533,    22,  2074,
    2075,   562,   563,     9,    10,    11,    12,   562,   563,  1786,
     309,   560,    18,  1822,  1823,   197,   198,   142,   143,  1555,
     357,  1557,   204,   205,   206,   207,   251,     8,     9,    10,
      11,    12,   247,   158,   190,    43,    44,   151,   163,   182,
     196,   166,   251,  1996,    25,    26,    27,    28,    29,    30,
      31,    32,    33,   178,   298,    36,     8,     9,    10,    11,
      12,   307,   218,    17,    18,    19,    20,    43,    44,   323,
    1350,  1351,   284,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    17,    18,    36,   407,   408,   409,   410,   411,
     412,   413,   414,    47,   153,    49,    50,  1786,   562,   563,
    1909,   562,   563,   336,  1384,  1786,     8,     9,    10,    11,
      12,  1792,   199,   200,   201,   202,   203,   385,   386,   329,
    2005,  2006,  2007,    25,    26,    27,    28,    29,    30,    31,
      32,    33,   284,   247,    36,    65,    66,    67,    68,    47,
     284,    49,    50,   242,   243,   344,  1955,   199,   200,   201,
     202,   203,  1961,     8,     9,    10,    11,    12,    59,    60,
    1440,   342,  1442,  1443,   563,  1445,    11,    12,   562,   563,
      25,    26,    27,    28,    29,    30,    31,    32,    33,   562,
     563,    36,  1462,   353,  1464,   242,   243,   187,   188,  1469,
     304,   135,   562,   560,   199,   200,  2005,  2006,  2007,   288,
     289,   199,   200,   367,   562,   353,  2015,  1839,   565,  1489,
     170,   171,  1748,     8,     9,    10,  2101,  2184,  2185,   565,
    1756,   440,   564,   564,  1760,   560,  1762,   182,   151,   363,
      25,    26,    27,   564,   152,   356,   560,    15,  1838,   564,
      15,   139,   178,   151,  2021,  2022,   560,   564,   156,   157,
    2059,   560,    20,  2062,   222,  2064,   164,   166,  1794,   560,
     560,   247,   170,   171,   172,   173,   174,   175,    80,   166,
    2042,   564,   560,   564,   560,   562,   184,   283,   284,     8,
       9,    10,    11,    12,   564,   399,   564,   182,   564,   187,
     188,   189,  2101,  2102,   348,   166,    25,    26,    27,    28,
      29,    30,    31,    32,    33,   562,   251,    36,   103,   104,
     242,   560,   560,   221,   564,    14,   224,   431,   432,   560,
    2129,   564,   220,   251,  2133,    15,  2135,  2136,    15,  2138,
     160,    33,  2021,  2022,   565,   165,    30,    15,    31,   151,
    2021,  2022,   562,   241,   156,   157,   244,   245,   160,     7,
      36,   151,   164,    15,  2307,   563,   156,   157,    15,     3,
     160,     3,     3,   271,   164,   560,  1646,     3,     3,     3,
    2179,   561,  2181,  2182,  2183,     3,     8,     9,    10,    11,
      12,   279,     3,  1919,     3,     3,     3,  1667,  1668,  1669,
       3,  1927,  1672,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     3,  2212,    36,     3,  2215,   251,   563,   221,
     563,  2220,   224,   562,   560,   560,  1696,   367,  2227,   251,
      20,   221,   560,   560,   224,   560,  2235,  2236,   334,   225,
    2239,   560,  2241,   560,  2243,   265,  2245,   142,   143,    34,
     564,   560,   251,  2252,   251,  1725,   251,   251,   152,   560,
     364,   240,   560,   158,   560,  2264,  2265,   240,   163,  2268,
    2269,   166,   178,   275,   276,    15,    15,  2352,  2353,    20,
     185,  2356,   303,   178,   560,   290,  2108,    15,    48,   184,
      15,  2290,   141,     3,    31,  2294,   563,   563,    15,  2298,
     240,   240,     3,   562,   561,    20,  2305,  2382,  2383,  2611,
      20,    21,  2614,  2615,    20,  2314,   166,     8,     9,    10,
      11,    12,   166,     3,  2626,     3,  2052,  2053,  2054,   562,
    2056,    20,   560,   560,    25,    26,    27,    28,    29,    30,
      31,    32,    33,   363,   560,    36,   444,   445,   446,   447,
    2652,  2653,    22,  2352,  2353,  2657,  2658,  2356,    31,   187,
     188,   563,   182,  2362,   251,    75,   159,   560,  2330,  2331,
      47,   560,  1842,  2372,  2373,  2374,  2375,  2376,   560,   560,
     560,   401,   560,  2382,  2383,   142,   143,   560,   560,  2532,
    2533,   562,   220,   186,    15,  2394,  2395,  2396,   418,   560,
     420,   158,  2477,  2274,   424,   560,   163,  2550,   428,   429,
     238,  1881,  1882,  2412,  2413,   179,   178,   560,   564,  2418,
     562,   178,   560,   560,   560,    18,   219,   184,   560,   560,
    2429,   560,   142,   560,  2433,    31,  2162,  2436,  2437,   560,
      31,  1911,  2441,  2442,   154,   155,   560,   563,   560,   560,
    2449,   279,    15,   560,   560,   560,   166,   560,   286,   560,
     560,    15,  2461,  2462,  2463,    20,     3,   565,     3,     3,
     562,   142,   143,     3,     3,  2474,     3,   565,  2477,  2478,
     151,   274,  2481,  2482,    15,   156,   157,     3,     3,     3,
     283,     3,   562,   164,   563,   166,   250,   250,   560,    22,
     560,  2323,   560,   151,   560,   292,  2505,  2506,   563,   560,
     560,   560,   560,   560,   560,   348,   560,   562,   560,   560,
      13,   560,    15,    16,    17,    18,    19,    20,   560,    22,
     560,   560,   560,   560,   560,   166,   357,    30,    31,    32,
     182,   166,    35,    54,  2014,   565,   560,   331,   130,   560,
     221,   247,   560,   224,    47,    48,    49,    50,   433,   168,
      53,   184,   560,   565,  2563,   555,  2565,  2566,     8,     9,
      10,    11,    12,   560,  2573,   565,   404,   405,   406,   140,
     560,  2580,    33,   561,    25,    25,    26,    27,    28,    29,
      30,    31,    32,    33,   561,   388,    36,   561,   560,   392,
      25,    33,    31,   563,   563,    15,    18,     3,  2334,     3,
     103,   104,   105,   106,   107,   108,   109,   110,   565,   112,
     113,   114,   115,   116,   117,   118,   119,   120,  2098,   560,
      15,   251,   251,   142,   564,   152,   129,   130,   131,   178,
     387,   134,  2112,   562,     8,     9,    10,    11,    12,   142,
     443,   383,   382,   560,   243,   448,   449,   150,  2128,   168,
    2130,    25,    26,    27,    28,    29,    30,    31,    32,    33,
     560,   305,    36,   564,  2144,  2145,  2146,     8,     9,    10,
      11,    12,   191,   564,   193,   292,   195,   560,   481,   560,
     564,   178,   564,    63,    25,    26,    27,    28,    29,    30,
      31,    32,    33,   564,    45,    36,     8,     9,    10,    11,
      12,    15,   505,    31,   560,   560,   509,   560,   389,   390,
     391,    15,    55,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    62,   560,    36,   228,    35,   565,     7,    32,
     562,   560,    32,   268,   377,   278,   562,   560,   565,   564,
     244,   182,   244,   244,     8,     9,    10,    11,    12,   268,
     269,   270,   271,  2233,   557,   251,   564,   564,   564,  2495,
    2240,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    2602,  2603,    36,   564,     8,     9,    10,    11,    12,   562,
     561,   561,   561,   560,     7,   561,    71,   560,   563,   275,
     293,    25,    26,    27,    28,    29,    30,    31,    32,    33,
     562,  2281,    36,   562,   562,   561,   560,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   562,   562,  2299,
       8,     9,    10,  2303,   101,    33,    15,    32,    32,     7,
     564,   243,   564,   307,   337,   338,   560,    25,    26,    27,
      28,    29,    30,    31,    32,    33,   560,   560,    36,   465,
     465,    13,   560,    15,    16,    17,    18,    19,    20,     7,
      22,   562,   565,   563,   562,   562,   369,   562,    30,    31,
     562,   562,    45,    35,    47,   561,    49,    50,   563,   244,
     562,   244,   244,   292,   565,    47,    48,    49,    50,   197,
     290,    53,   395,   396,   397,   398,   244,   247,  2378,    83,
      84,    85,    86,    87,    88,    89,    90,    91,   244,    93,
      94,    95,    96,    97,    98,   560,   247,   290,  2398,   437,
     344,   409,   564,   307,   117,   407,   560,  2407,  2408,   457,
     450,   251,   560,   450,   292,  2415,  2416,   460,   560,  2419,
     455,   103,   104,   105,   106,   107,   108,   109,   110,   278,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   278,
    2440,    22,   560,   560,  2444,   290,  2446,   129,   130,   131,
     251,   251,   134,   344,   117,   251,   479,   480,   151,   251,
     142,   488,   490,   156,   157,  2465,  2466,   500,   150,   494,
     560,   164,   495,   496,   560,    33,  2476,   170,   171,   172,
     173,   174,   175,  2483,   499,  2485,  2486,  2487,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,    33,    22,   297,   438,
     474,   251,   244,   244,   560,   251,   560,   452,   221,   560,
     560,   224,   178,   565,   560,   558,   559,   188,   561,   188,
     560,   421,   421,   562,   567,  2063,   228,   565,   560,  2549,
       8,     9,    10,    11,    12,   560,   563,   560,   416,   560,
    2560,   560,     8,     9,    10,    11,    12,    25,    26,    27,
      28,    29,    30,    31,    32,    33,  2576,   560,    36,    25,
      26,    27,    28,    29,    30,    31,    32,    33,   560,   563,
      36,     3,   562,   560,   560,   560,     8,     9,    10,    11,
      12,  1033,   562,  1033,  1033,  1510,  1789,   300,  2064,  2062,
    1790,   293,  1549,    25,    26,    27,    28,    29,    30,    31,
      32,    33,  1549,  1549,    36,  1549,  1791,   555,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,  1080,  1597,
     333,   334,    13,  2158,    15,    16,    17,    18,    19,    20,
    2330,    22,   681,   942,   248,   337,   338,   943,  2331,    30,
      31,    32,   536,   141,    35,   945,  1187,  1356,   562,   472,
     829,     8,     9,    10,    11,    12,    47,    48,    49,    50,
    1273,  1275,    53,  2512,  2531,  1364,   625,   369,    25,    26,
      27,    28,    29,    30,    31,    32,    33,  1991,  1835,    36,
    1154,   562,  1865,     8,     9,    10,    11,    12,  1852,  2018,
    2434,  1890,  2274,   395,   396,   397,   398,  2291,  2445,  2295,
      25,    26,    27,    28,    29,    30,    31,    32,    33,  2447,
     562,    36,   103,   104,  2294,  1740,   883,  1102,   109,   110,
    1065,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   674,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,    -1,   134,     8,     9,    10,    11,    12,    -1,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,   562,   150,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      -1,    -1,    36,    -1,    -1,   100,    -1,   479,   480,     8,
       9,    10,    11,    12,   497,    -1,    -1,    -1,   562,   502,
      -1,   504,    -1,   495,   496,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    -1,    -1,    36,    -1,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   228,    -1,    -1,
     564,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   565,    54,    -1,    -1,   558,   559,    59,   561,
       8,     9,    10,    11,    12,   567,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    -1,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    -1,    -1,    36,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      36,    -1,   293,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
      -1,    -1,    -1,    13,    -1,    15,    16,    17,    18,    19,
      20,    -1,    22,    -1,    -1,    -1,   337,   338,    -1,    -1,
      30,    31,    32,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,    49,
      50,    -1,    -1,    53,    -1,    -1,    -1,   178,   369,    -1,
      -1,    -1,    -1,   144,    -1,    -1,   187,   188,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   395,   396,   397,   398,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,   182,   183,   103,   104,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   242,   243,    -1,    -1,   246,    -1,    -1,    -1,   129,
     130,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,   222,   142,   224,    -1,   226,    -1,    -1,    -1,    -1,
     150,    -1,    -1,    -1,    -1,    -1,   237,    -1,   279,    -1,
      -1,    -1,   560,    -1,   285,   286,   287,    -1,   479,   480,
      -1,    -1,    -1,    -1,   560,    47,    -1,    49,    50,    -1,
      -1,    -1,   263,    -1,   495,   496,   267,    -1,    -1,    -1,
      -1,   272,   273,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   228,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   558,   559,    -1,
     561,    -1,    -1,    -1,    -1,    -1,   567,    -1,    -1,    -1,
      -1,    47,    -1,    49,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,   560,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   293,    -1,    -1,    -1,    -1,   170,   171,
     172,   173,   174,   175,    -1,    -1,    -1,   388,    -1,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,    -1,    -1,    -1,    13,    -1,    15,    16,    17,    18,
      19,    20,    -1,    22,    -1,    -1,    -1,   337,   338,    -1,
      -1,    30,    31,    32,    -1,    -1,    35,    -1,    -1,   221,
      -1,    -1,   224,    -1,    -1,    -1,    -1,    -1,    47,    48,
      49,    50,   234,    -1,    53,   151,    -1,    -1,    -1,   369,
     156,   157,    -1,    -1,   246,    -1,   560,    47,   164,    49,
      50,    -1,    -1,    -1,   170,   171,   172,   173,   174,   175,
      -1,    -1,    -1,    -1,    -1,   395,   396,   397,   398,    -1,
      -1,    -1,   193,    -1,   195,    -1,    -1,    -1,    -1,    86,
      -1,   560,    -1,    -1,   103,   104,    86,    -1,    -1,    -1,
     109,   110,    -1,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,    -1,    -1,   221,   227,    -1,   224,    -1,
     129,   130,   131,   234,   565,   134,    -1,    -1,    -1,    -1,
      -1,   237,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   150,   139,   140,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   552,   553,   264,    -1,   266,    -1,    -1,    -1,   479,
     480,   151,    47,   274,    49,    50,   156,   157,   165,    -1,
     160,    -1,   283,    -1,   164,   495,   496,    -1,   284,    -1,
     170,   171,   172,   173,   174,   175,    -1,    -1,    -1,    -1,
      -1,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,    -1,    -1,   224,    -1,    -1,   234,   558,   559,
      -1,   561,    -1,    -1,    -1,    -1,    -1,   567,    -1,    -1,
     247,    -1,    47,    -1,    49,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,   156,   157,    -1,    -1,   160,    -1,    -1,    -1,   164,
      -1,   392,    -1,    -1,   293,   170,   171,   172,   173,   174,
     175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,    -1,    -1,    -1,    13,    -1,    15,    16,    17,
      18,    19,    20,    -1,    22,    -1,    -1,    -1,   337,   338,
     436,    -1,    30,    31,    32,    -1,   221,    35,    -1,   224,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    49,    50,    -1,    -1,    53,   151,    -1,    -1,    -1,
     369,   156,   157,    -1,    -1,   160,    -1,    -1,    -1,   164,
     481,    -1,    -1,   565,    -1,   170,   171,   172,   173,   174,
     175,    -1,    -1,    -1,    -1,    -1,   395,   396,   397,   398,
      -1,    -1,    -1,    -1,   505,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   103,   104,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    -1,    -1,    -1,   221,    -1,    -1,   224,
      -1,   129,   130,   131,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,   554,   555,
     556,   246,   150,    -1,   451,    -1,   453,   454,    -1,   565,
      -1,   458,   459,    -1,   461,    -1,    -1,    -1,    -1,    -1,
     479,   480,   469,   470,    -1,    -1,    -1,    -1,    -1,   469,
     470,    -1,    -1,   473,    -1,    -1,   495,   496,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   427,    -1,   119,    -1,    -1,    -1,    -1,   558,
     559,    -1,   561,    -1,    -1,    -1,    -1,    -1,   567,    -1,
      47,    -1,    49,    50,    -1,    -1,    -1,    -1,   565,    -1,
      -1,    -1,    -1,    -1,    -1,   565,   151,    -1,    -1,    -1,
      -1,   156,   157,    -1,    -1,    -1,   161,   162,    -1,   164,
      -1,   166,    -1,    -1,    -1,   293,    -1,    -1,   483,    -1,
      -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   186,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,    -1,    -1,    -1,    13,    -1,    15,    16,
      17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,   337,
     338,    -1,    -1,    30,    31,    32,   221,    -1,    35,   224,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,   151,    -1,    53,    -1,    -1,   156,
     157,   369,    -1,   160,    -1,    -1,    47,   164,    49,    50,
     565,    -1,    -1,   170,   171,   172,   173,   174,   175,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   395,   396,   397,
     398,    -1,    51,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,   103,   104,    -1,    -1,
      -1,    -1,   109,   110,    -1,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   221,    -1,    85,   224,    87,    -1,
      -1,    -1,   129,   130,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   150,    -1,    -1,    -1,    -1,    -1,    -1,
     565,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,   479,   480,    -1,    -1,    -1,   135,   136,   137,    -1,
     139,   140,    -1,    -1,    -1,    -1,    -1,   495,   496,   170,
     171,   172,   173,   174,   175,   380,    -1,    -1,   295,    -1,
      -1,    -1,    -1,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     558,   559,    -1,   561,    -1,    -1,    -1,    -1,    -1,   567,
      -1,    -1,    -1,    46,    47,    -1,    49,    50,    -1,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,    -1,    -1,    -1,    13,    -1,    15,
      16,    17,    18,    19,    20,    -1,    22,    -1,    -1,    -1,
     337,   338,    -1,    -1,    30,    31,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    48,    49,    50,    -1,    -1,    53,   151,    -1,
      -1,    -1,   369,   156,   157,    -1,    -1,    -1,    -1,    -1,
     565,   164,    -1,    -1,    -1,    -1,    -1,   170,   171,   172,
     173,   174,   175,    -1,    -1,    -1,    -1,    -1,   395,   396,
     397,   398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,   104,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,    -1,    -1,   221,    -1,
      -1,   224,    -1,   129,   130,   131,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,   237,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,   565,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   479,   480,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   495,   496,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   558,   559,    -1,   561,    -1,    -1,    -1,    -1,    -1,
     567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   399,   400,   401,   402,
      -1,    -1,    -1,    -1,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    48,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,    -1,
     433,   337,   338,   436,    -1,    -1,   439,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    -1,    -1,   369,    -1,    99,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,    -1,    48,   395,
     396,   397,   398,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   146,    -1,   148,    -1,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,
      -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,    -1,   565,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   479,   480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,   148,   495,
     496,    -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   558,   559,    -1,   561,    -1,    -1,    -1,   293,
      -1,   567,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   337,   338,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,   293,    -1,   369,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      48,   395,   396,   397,   398,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   369,
      -1,    99,    -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,    -1,    -1,   395,   396,   397,   398,    -1,
      -1,    -1,    -1,    -1,    -1,   479,   480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,
     148,   495,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   479,
     480,    -1,    -1,    -1,   558,   559,    -1,    -1,    -1,    -1,
      -1,   565,    -1,    -1,    -1,   495,   496,    -1,    -1,    -1,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   558,   559,
      -1,    -1,    -1,    -1,   564,   293,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,    -1,    48,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,
     338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   395,   396,   397,
     398,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    47,
      -1,    49,    50,    -1,    -1,    -1,   157,    -1,    -1,    -1,
     161,   162,    -1,    -1,    -1,   166,    -1,    -1,    -1,    -1,
      -1,   479,   480,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,    -1,   495,   496,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,    -1,   233,    -1,   235,    -1,   237,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,   143,    -1,    -1,    -1,    -1,
     558,   559,    -1,    -1,    -1,    -1,   154,    -1,    -1,   293,
     158,    -1,    -1,   161,   162,    -1,    -1,    -1,   166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   185,   187,   188,
     189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   337,   338,    -1,    -1,    -1,    -1,    -1,
     208,   209,   210,    -1,   212,   213,    -1,   215,   216,   217,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,
      -1,    -1,    -1,    -1,    -1,   369,    -1,    -1,   339,   340,
      -1,    -1,    -1,   242,   243,   346,    -1,   246,    -1,   350,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     361,   395,   396,   397,   398,    -1,    -1,    -1,    -1,   370,
      -1,   372,    -1,    -1,   375,   274,    -1,    -1,    -1,    -1,
     279,    -1,    -1,    -1,    -1,   284,    -1,    -1,   287,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   343,   479,   480,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   495,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   404,    49,    50,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     187,   188,    -1,    -1,   558,   559,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   565,    -1,    -1,    -1,    -1,   112,
      -1,   238,    -1,   228,    -1,   242,   243,    -1,    -1,   246,
     247,    -1,    -1,    -1,    -1,   484,   485,   486,   487,    -1,
     489,    -1,    -1,    -1,   493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   270,    -1,    -1,    -1,   274,   151,    -1,
      -1,    -1,   279,   156,   157,    -1,   159,   160,    -1,   286,
      -1,   164,   165,    -1,   291,    -1,    -1,   170,   171,   172,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     183,    -1,    -1,    -1,   187,    -1,   189,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   565,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   343,    -1,   221,    -1,
      -1,   224,   337,   338,    -1,   352,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   246,    -1,   372,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,   276,   401,   278,    -1,   404,   405,   406,
     395,   396,   397,   398,    -1,   412,    -1,    -1,    -1,    -1,
     417,    -1,    -1,    -1,    -1,   298,   299,    -1,   301,   302,
     427,    -1,   305,   306,    -1,    -1,    -1,   434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,   322,
      -1,    -1,    -1,   326,   327,   328,    -1,    -1,    -1,    -1,
      -1,    -1,   335,    -1,    -1,    -1,   339,    -1,    -1,   342,
     343,    -1,   345,    -1,   347,    -1,    -1,    -1,   351,   352,
      -1,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   365,    -1,   479,   480,    -1,    -1,    -1,    -1,
     373,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     495,   496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   565,    -1,
      -1,    -1,    -1,   558,   559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   565
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   571,   572,    72,    73,    74,   144,   157,   182,
     183,   222,   224,   226,   237,   263,   267,   272,   273,   388,
     552,   553,   627,   628,   629,   630,   742,   743,   744,   745,
     747,   748,   749,   756,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   771,   772,   773,   774,   775,
     776,   777,   779,   780,   802,   813,   814,   815,   816,   839,
     877,   878,   879,   880,   881,   882,   883,   884,   939,   940,
     963,   976,   977,   978,   979,   980,   981,   982,   983,     0,
       3,    37,    47,    49,    50,    75,   142,   144,   145,   147,
     149,   151,   153,   154,   155,   157,   170,   171,   172,   173,
     174,   175,   224,   230,   236,   237,   551,   560,   573,   574,
     631,   633,   634,   635,   636,   645,   681,   683,   684,   685,
     686,   687,   692,   706,   709,   719,   720,   721,   784,   787,
     803,   806,   817,   823,   835,   838,   842,   843,   886,   887,
     889,   891,   892,   897,   928,   931,   941,   942,   954,   955,
     964,   967,   974,   975,   986,   989,   990,     3,     3,     3,
      13,    15,    16,    17,    18,    19,    20,    22,    30,    31,
      35,    47,    48,    49,    50,    53,   103,   104,   109,   110,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   129,
     130,   131,   134,   142,   150,   228,   293,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   337,   338,   369,
     395,   396,   397,   398,   479,   480,   495,   496,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   558,   559,   561,   567,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   624,   625,   626,   651,   667,   669,   670,   672,
     673,   674,   675,   783,    20,    22,   158,   755,   778,   781,
      20,   781,   781,   213,   223,   781,   781,     3,   182,   193,
     195,   227,   234,   264,   266,   274,   283,   392,   481,   505,
     142,   168,   191,   193,   195,   268,   269,   270,   271,    39,
     158,   564,   769,   781,   267,    22,   246,   264,   547,   548,
     549,   984,     3,    20,    21,   577,   577,   577,   675,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    93,    94,
      95,    96,    97,    98,   637,   561,   561,   152,    20,    22,
     601,   193,   194,   214,   550,   176,   193,   601,   154,   234,
     235,   236,   707,   708,   966,   182,   484,   542,   166,   248,
     688,   159,   186,   219,   274,   283,   388,   392,   443,   448,
     449,   481,   505,   509,   557,   841,   927,    48,   577,   693,
     151,   156,   157,   160,   164,   221,   224,   246,   565,   685,
     694,   695,   701,   723,   693,   693,   693,    49,    50,    82,
     112,   159,   160,   165,   170,   171,   172,   173,   183,   187,
     189,   233,   237,   246,   273,   274,   275,   276,   278,   298,
     299,   301,   302,   305,   306,   321,   322,   326,   327,   328,
     335,   339,   342,   343,   345,   347,   351,   352,   354,   365,
     373,   374,   565,   694,   826,   827,   834,   693,   693,    46,
     237,   399,   400,   401,   402,   427,   433,   436,   439,   565,
     685,   694,   845,   846,   847,   848,   849,   693,   184,   271,
     444,   445,   446,   447,   565,   694,   701,   888,   564,   119,
     161,   162,   166,   177,   186,   380,   565,   694,   696,   693,
     693,   693,   693,   234,   246,   339,   565,   694,   701,   958,
     959,   237,   284,   436,   509,   510,   554,   555,   556,   565,
     694,   701,   965,   988,   693,   693,   160,   555,   565,   694,
     991,    15,    20,    30,    32,   561,   567,   569,   666,   668,
     673,    33,   581,    33,    17,    18,   582,   583,   561,   141,
      31,   141,   675,    15,   564,   564,   561,   561,   561,   561,
     561,   561,   561,   105,   106,   107,   108,   656,   675,    15,
      16,    18,    19,    20,   561,   582,   583,   590,   651,   652,
     655,   657,   658,   659,   661,   663,   664,   140,   140,     3,
       8,     9,    10,    11,    12,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    36,    36,    39,   158,   564,   724,
       3,   724,    22,   602,   602,   781,   781,     3,    39,   158,
     564,   727,     3,    20,    22,   158,   782,     3,   265,     3,
     750,     3,   757,   282,   168,   195,   270,   294,    20,   160,
     270,   426,   441,   442,   746,   195,   270,   746,   158,     3,
       3,     3,     3,     3,     3,     3,     3,    82,   157,   497,
     540,   541,   542,   543,   544,   545,   972,   973,    15,   770,
     602,   840,   984,     3,   984,     3,     3,   484,   985,    25,
     646,   632,    92,   577,    20,    20,    15,    17,    20,    48,
     561,   682,   560,   724,   724,    15,    20,   561,   575,    38,
      39,    40,    41,   178,   575,   578,   727,   560,    22,   231,
     560,   539,   546,   601,   970,   238,   575,   576,   576,   577,
     564,   691,   393,   394,   890,   482,    20,    48,   564,   152,
     578,   724,   722,   165,   601,   601,   727,   247,   560,   564,
     699,   560,   560,   564,   564,   564,   238,   308,   320,   560,
      22,   311,   312,    47,   356,    47,   356,    47,   356,    47,
     356,   309,   601,   578,   357,   182,   247,   234,   325,   350,
     237,   578,   824,   560,   575,    17,    18,    20,   366,   579,
     819,   579,   818,   251,   300,   307,   251,   298,   284,   307,
     323,   324,   323,   153,   578,   329,   336,   284,   284,   344,
     342,   240,   278,   311,   578,   353,   355,   575,   367,   135,
     353,   560,   564,   832,   560,   564,   564,   440,   182,   682,
     578,   151,   575,   578,   152,   363,   578,   356,   844,   699,
     560,   564,   564,   578,    15,    48,   190,    15,   139,   140,
     161,   162,   560,   560,   575,   142,   143,   158,   163,   178,
     184,   643,   703,   178,   703,    20,   702,   178,   222,   166,
     560,   560,   564,   564,   564,   564,    18,    19,    20,   593,
     596,   247,   166,   560,   560,    81,   303,   332,   341,   506,
     507,   508,   956,   957,   564,   962,   182,   575,   348,   166,
     242,   578,   251,   578,   560,   560,   564,   564,   992,   996,
     251,   560,     7,   668,   668,   668,   675,    17,    18,   661,
     668,   668,    14,    15,    15,    33,   671,   675,    30,    31,
     141,    31,   621,   621,   702,   675,   675,   675,   675,   675,
     675,    15,   563,   562,   563,    32,   654,   656,   675,    30,
      31,   564,     7,   563,   568,   563,   568,    15,    15,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,    51,    52,    59,    85,    87,   111,   121,
     122,   124,   125,   126,   127,   128,   135,   136,   137,   139,
     140,    47,    49,    50,   170,   171,   172,   173,   174,   175,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   754,   167,   168,   169,   191,   192,   195,   725,   726,
       3,     3,     3,     3,   167,   225,   728,   729,     3,   782,
       3,     3,     3,   142,   154,   158,   161,   162,   166,   185,
     208,   209,   210,   212,   213,   215,   216,   217,   596,   643,
     753,     3,    75,   142,   154,   155,   166,   577,   746,   746,
     746,   746,   746,   746,   746,   885,   158,   746,   158,   746,
       3,   746,   746,     3,     3,   563,   565,     3,     3,     3,
     142,   166,   190,   643,     3,   985,   575,     3,   675,   561,
     639,   640,   641,   644,   560,   563,   563,   716,   717,   675,
     560,   675,   576,   560,   575,   232,   233,   367,   968,   575,
     969,   158,   564,   971,   575,    42,    43,    44,   690,   693,
      20,   682,   710,   713,   714,   578,   698,   700,   786,   805,
     251,   251,   579,   560,   575,   575,    82,   376,   560,   560,
     237,   358,   251,   349,   578,   578,   334,   578,   225,   560,
     560,   564,   741,   560,    20,   590,   595,    34,   580,    45,
     240,   362,   363,   560,   580,    45,   240,   560,   575,   251,
     251,   575,   251,   578,   251,   578,   152,   578,   578,   560,
     578,   578,   578,   578,   578,   578,   364,   240,   578,   560,
     578,   578,   560,   368,   601,   240,   578,   831,   833,   837,
     578,   251,   349,   578,   578,   178,   575,   578,   700,   850,
      15,    15,   576,   576,    20,   641,   642,   675,    39,   575,
     705,   185,   705,   705,   578,   702,   896,   930,   943,   578,
     702,    22,   579,   579,    47,   117,   274,   467,   956,   961,
     560,   578,   578,   575,   290,   575,   714,   715,   575,    15,
     562,   568,    48,    15,   562,   563,   141,    31,   622,   623,
     562,   563,   562,   563,   563,   563,   563,   562,   675,   675,
     563,     7,   563,   563,   562,    15,   561,   652,   659,   663,
     240,   240,   561,   563,   565,   563,   565,     3,   642,    20,
     166,   166,    20,   158,    17,    18,    19,    20,   582,   583,
     584,   585,   586,   751,   752,   596,    20,   755,     3,   602,
     602,   602,   602,   602,   602,     3,    20,    59,   151,   247,
     304,   399,   431,   432,   746,   602,   746,   602,   602,   602,
     973,   642,    22,   702,   601,     3,   560,   562,   638,   644,
     564,   637,   601,    20,   714,   560,   562,   562,    22,    43,
      44,    43,    44,   601,   601,   972,   560,   560,   139,   140,
     248,   249,   565,   689,    31,   712,   563,   560,   157,   565,
     696,   697,    80,   160,   275,   276,   565,   694,   785,   160,
     295,   565,   694,   701,   804,   575,   575,   560,   560,   560,
     578,   564,   578,   820,   182,   251,   575,   560,   560,   560,
     578,   560,   578,   740,   825,   819,   577,   819,   575,   575,
     818,   575,   575,   560,   575,   575,   560,   575,   560,   575,
     560,   682,   560,   560,   560,   560,   560,   560,   560,   560,
     578,   560,   575,   560,   560,   560,   575,   560,   578,   560,
      54,   130,   161,   162,   233,   235,   237,   330,   339,   340,
     346,   350,   361,   370,   372,   375,   565,   697,   830,   142,
     166,   389,   390,   391,   565,   643,   694,   836,   575,   575,
     160,   165,   265,   363,   401,   418,   420,   424,   428,   429,
     565,   851,   858,   861,   179,   704,   578,   560,    86,   160,
     469,   470,   473,   478,   565,   694,   701,   893,   160,   427,
     483,   565,   694,   701,   929,    45,   300,   333,   334,   497,
     502,   504,   565,   694,   701,   944,   946,   560,   560,   580,
      47,    15,   598,   599,   575,   578,   578,    20,    76,    77,
      78,    79,    80,    81,    82,    99,   102,   119,   146,   148,
     565,   672,   674,   676,   678,   783,   960,   178,   987,   575,
     564,   995,   668,   668,    18,   675,    31,    31,   619,   620,
     675,   675,   675,   675,   675,   563,   562,   563,    32,   654,
     675,   654,    32,   654,   654,   563,   675,    15,    15,   675,
     726,   729,    20,   755,   755,    48,    17,    18,     3,     3,
       3,     3,     3,     3,    15,   682,   682,   682,   602,     3,
     602,     3,     3,     3,   637,   647,   648,   649,   678,   577,
     562,   563,   565,   250,   250,   578,   578,   560,    22,   602,
     711,   713,   724,   560,   789,   790,   796,   790,   797,   579,
     801,   560,   807,   812,   151,   560,   563,   560,   560,    86,
     223,   376,   378,   380,   381,   384,   821,   822,   560,   349,
     578,   575,   560,   560,   560,   139,   189,   237,   241,   244,
     245,   565,   739,   560,   560,   560,   560,   560,   560,   560,
     560,   560,   560,   560,   560,   560,   292,   348,   166,   166,
     357,   166,   182,   331,   166,   159,   341,   578,    54,   578,
     371,   578,   575,   578,   560,   642,    22,   702,   601,   575,
     130,   560,   870,   876,   372,   403,   428,   578,   853,   372,
     578,   852,   247,   595,   854,   855,   430,   578,   560,   433,
     871,   180,   181,   182,   183,    20,   583,   594,   907,   912,
     898,   906,   894,   895,   594,   168,   560,   932,   938,   578,
     575,   560,   575,   184,   945,   140,   945,    20,   579,   601,
     947,    61,   501,   948,   945,   560,   599,    33,    25,   675,
     677,   677,   561,   675,   675,   675,    25,   561,   561,   560,
      25,   677,    25,    36,   575,   994,    33,    31,    45,    51,
      52,    53,    54,    56,    57,    58,    61,    63,    64,    69,
      70,   565,   605,   606,   607,   608,   609,   617,   565,   606,
     607,   608,   609,   618,   563,   562,   562,   562,   562,   675,
     675,   562,   563,     7,   562,   563,   562,   563,     7,   562,
     563,   563,    15,   562,    18,     3,     3,   577,   565,   648,
     560,    15,   251,   251,    17,    18,    20,   582,   583,   597,
     159,   170,   171,   275,   788,   715,   564,   795,    34,   277,
     798,   715,   152,   575,   178,   387,   133,   379,   383,   382,
     385,   386,   563,   565,   560,   560,   560,   242,   243,   578,
     243,   576,   575,   560,   184,   304,   320,   242,   243,   578,
     578,   578,   237,   358,   702,   578,   304,   332,   333,   829,
     702,   292,   305,   714,   872,   575,   575,   578,   564,   575,
     564,   682,   564,   575,   575,   564,   564,   911,   715,   564,
     579,   913,   918,    22,   564,   919,   924,   578,   715,   178,
     575,    63,   575,   946,   949,   950,   575,    15,   675,   563,
     560,   560,   783,   560,   100,   564,   675,   679,   679,   675,
     560,   675,   130,   131,   134,   141,   142,   463,   565,   993,
      15,    31,    55,    59,    60,    62,     8,     9,    10,    25,
      26,    27,   103,   104,   575,   603,   610,   611,   612,    35,
     613,   614,   614,   616,   595,   560,   610,   613,   616,   594,
     560,   675,   562,   562,    32,   654,    32,   654,    32,   654,
       7,    32,   654,    32,   654,   565,   560,   562,   562,   576,
     576,   795,   794,   791,   577,   601,   278,   799,   564,   811,
     578,   560,   377,   268,   822,   244,   244,   244,   359,   360,
     578,   828,   828,   579,   182,   251,   578,   578,   873,   564,
     875,   863,   863,   856,   859,   910,   909,   564,   905,   914,
     920,   564,   937,   575,   578,   564,   560,   677,   562,   564,
     650,   678,   665,   560,   675,    20,   119,   674,   680,   783,
     560,   560,   561,   561,   561,   560,   561,   579,   560,     7,
     575,    11,    12,   604,   563,    12,   563,   604,   575,    65,
      66,    67,    68,   615,   563,   604,    71,   562,   562,   562,
     562,   563,     7,   562,   562,   562,   563,   561,   562,     7,
     562,   562,     7,   562,   791,   139,   187,   188,   189,   220,
     241,   244,   245,   279,   565,   730,   731,   733,   734,   735,
     792,   579,   275,   800,   810,   808,   576,   576,   576,   578,
     575,   871,   874,   565,   595,   864,   865,   565,   265,   372,
     419,   565,   857,   238,   279,   286,   404,   405,   406,   565,
     730,   860,   462,   463,   466,   467,   468,   565,   908,   904,
     903,   917,   923,   936,   933,   951,   560,   647,   101,     6,
      15,    16,   561,   565,   651,   653,   655,   657,   658,   660,
     662,   679,   679,   675,   675,   675,   675,   575,   612,   603,
     611,   614,   614,    33,   614,   614,    15,    32,   654,    32,
     654,   654,     7,   654,   242,   243,   578,   564,   243,   576,
     575,   163,   197,   280,   281,   793,    23,   601,   564,   738,
     560,   578,    45,    54,    59,   178,   242,   243,   246,   279,
     285,   286,   287,   565,   730,   809,    59,   238,   242,   243,
     246,   247,   270,   274,   279,   286,   291,   343,   352,   372,
     401,   404,   405,   406,   412,   417,   427,   434,   565,   730,
     862,   419,   425,   866,   578,   575,   578,   560,   575,   163,
     280,   415,   575,   575,   307,   210,   575,   560,   465,   465,
     578,   578,   578,   560,    86,   139,   140,   165,   234,   247,
     451,   453,   454,   458,   459,   461,   469,   470,   565,   899,
     465,   471,   565,   915,   465,   472,   565,   921,    45,   189,
     242,   243,   246,   274,   279,   284,   287,   320,   343,   404,
     427,   447,   484,   485,   486,   487,   489,   493,   565,   730,
     934,   497,   498,   503,   565,   952,   565,   650,   647,   675,
       7,   563,   566,   562,   563,   562,   562,   562,   562,   575,
     575,   575,   575,   615,   615,   562,   562,   562,   563,   562,
     561,   562,   244,   244,   732,   733,   244,   199,   200,   197,
      48,    80,   152,   190,   196,   218,   736,   575,   292,   288,
     289,   575,   290,    63,    64,   229,   291,   718,   247,   163,
     296,   575,   244,   244,   560,   407,   408,   409,   410,   411,
     412,   413,   414,   575,   290,    63,   291,   718,   247,   437,
     564,   578,   163,   280,   415,   575,   575,   344,   409,   575,
     578,   575,   307,   210,   575,   320,   435,   575,   117,   407,
     560,   575,   560,   575,   575,   575,   575,   456,   912,   307,
     450,   450,   119,   465,   119,   456,   465,   457,   450,   578,
     455,   251,   460,   292,   278,   900,   278,   901,   560,   464,
     575,   925,   913,   916,   560,   925,   919,   922,   560,   575,
     578,   290,    63,   291,   718,   247,   491,   578,   163,   199,
     415,   492,   935,   575,   251,   579,   344,   251,   117,   356,
     407,   251,   251,   421,   575,   488,   490,   494,   560,   500,
     499,   601,   953,   560,   562,   561,   653,   660,   647,   560,
     675,   560,   560,   560,   560,    33,    33,   654,   654,   576,
     576,   565,   560,   576,   199,   200,    22,   600,    48,   190,
     575,   600,   197,   198,   204,   205,   206,   207,   737,    48,
     190,   565,   170,   171,   575,   575,   575,   575,   575,   578,
     297,   576,   576,   422,   423,   575,   575,   575,   578,   438,
     867,   243,   578,   578,   575,   575,   578,   578,   575,   578,
     474,   926,   926,   251,   575,   244,   244,   475,   476,   477,
     902,   575,   902,   251,   575,   575,   452,   578,   575,   575,
     178,   578,   918,   578,   924,   575,   575,   575,   575,   578,
     578,   575,   243,   578,   576,   575,   575,   575,   578,   578,
     578,   578,   188,   188,   675,   562,   575,   575,   562,   563,
     732,   560,   600,   600,   560,   560,   199,   200,   201,   202,
     203,   199,   200,   201,   202,   203,   560,   600,   600,   738,
     579,   579,   578,   565,   579,   869,   421,   578,   575,   575,
     575,   926,   575,   926,   578,   575,   421,   601,   601,   560,
     654,   736,   560,   560,   736,   736,   736,   560,   560,   416,
     868,   563,   736,   736,   736,   736,   560,   654,   562
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   570,   571,   571,   572,   572,   573,   573,   574,   575,
     575,   575,   576,   576,   576,   577,   577,   578,   578,   578,
     578,   578,   578,   579,   579,   579,   580,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   590,   591,
     591,   592,   592,   593,   593,   593,   593,   593,   593,   594,
     594,   595,   595,   596,   596,   597,   597,   597,   597,   597,
     598,   599,   599,   600,   601,   601,   602,   602,   603,   603,
     603,   603,   603,   603,   603,   603,   604,   604,   605,   605,
     605,   605,   605,   605,   605,   605,   605,   605,   606,   607,
     608,   609,   609,   610,   610,   610,   610,   611,   611,   612,
     612,   613,   613,   613,   614,   614,   615,   615,   615,   615,
     616,   616,   616,   617,   617,   617,   617,   618,   618,   618,
     618,   618,   619,   619,   620,   620,   621,   622,   623,   624,
     625,   626,   626,   627,   628,   627,   629,   627,   630,   573,
     632,   631,   573,   633,   573,   634,   573,   635,   573,   636,
     637,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   637,   637,   637,   637,   637,   638,   638,   639,   639,
     640,   640,   641,   642,   642,   643,   644,   573,   646,   645,
     647,   647,   648,   649,   649,   650,   650,   651,   651,   652,
     652,   652,   652,   652,   652,   653,   653,   653,   653,   654,
     655,   655,   655,   655,   655,   655,   655,   655,   655,   655,
     656,   656,   656,   656,   657,   657,   657,   658,   658,   658,
     658,   658,   658,   658,   658,   659,   659,   659,   659,   659,
     660,   660,   660,   660,   660,   661,   661,   662,   662,   663,
     663,   663,   663,   664,   664,   665,   665,   665,   666,   666,
     667,   668,   668,   668,   668,   668,   668,   668,   668,   669,
     669,   669,   669,   669,   669,   669,   669,   669,   669,   670,
     670,   670,   670,   671,   671,   671,   672,   673,   674,   674,
     674,   674,   674,   674,   674,   674,   674,   674,   674,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   675,   675,   675,   675,   675,   675,   675,   675,
     675,   675,   676,   676,   676,   677,   677,   677,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   679,   680,
     680,   680,   680,   573,   681,   681,   682,   682,   682,   682,
     573,   683,   573,   684,   685,   685,   685,   685,   685,   685,
     685,   685,   685,   685,   573,   686,   687,   688,   688,   689,
     689,   689,   689,   690,   690,   691,   691,   573,   692,   692,
     693,   693,   693,   693,   694,   694,   694,   694,   694,   694,
     694,   694,   695,   696,   696,   696,   696,   696,   696,   696,
     696,   696,   697,   697,   698,   698,   699,   699,   700,   701,
     702,   703,   703,   703,   703,   704,   704,   704,   704,   704,
     705,   705,   573,   706,   706,   706,   573,   707,   707,   707,
     707,   708,   708,   708,   708,   708,   708,   708,   708,   709,
     710,   711,   711,   712,   712,   713,   714,   714,   715,   716,
     717,   718,   718,   719,   720,   721,   721,   721,   721,   721,
     722,   723,   724,   724,   724,   725,   725,   726,   726,   726,
     726,   726,   726,   727,   727,   727,   728,   728,   729,   729,
     730,   731,   731,   732,   732,   733,   733,   734,   734,   735,
     735,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     737,   737,   737,   737,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   738,   739,   739,   739,   739,   739,
     739,   739,   740,   740,   741,   627,   742,   627,   743,   627,
     744,   627,   745,   746,   746,   627,   747,   627,   748,   627,
     749,   750,   750,   750,   750,   750,   750,   750,   750,   750,
     750,   750,   750,   750,   750,   750,   750,   750,   750,   751,
     751,   751,   751,   751,   751,   751,   751,   752,   752,   752,
     752,   753,   753,   753,   753,   754,   754,   754,   754,   754,
     754,   754,   754,   754,   754,   754,   754,   754,   754,   754,
     754,   754,   754,   754,   754,   755,   627,   756,   757,   757,
     757,   757,   757,   757,   757,   627,   758,   627,   759,   627,
     760,   627,   761,   627,   762,   627,   763,   627,   764,   627,
     765,   627,   766,   627,   767,   627,   768,   769,   769,   769,
     770,   770,   627,   771,   627,   772,   627,   773,   627,   774,
     627,   775,   627,   776,   627,   777,   778,   778,   627,   779,
     627,   780,   781,   781,   781,   782,   782,   782,   783,   719,
     784,   785,   785,   785,   785,   785,   786,   786,   787,   788,
     788,   788,   788,   789,   789,   790,   791,   792,   792,   792,
     792,   792,   792,   792,   792,   793,   793,   793,   793,   793,
     793,   794,   794,   795,   795,   796,   797,   798,   798,   798,
     799,   799,   800,   800,   801,   627,   802,   719,   803,   804,
     804,   804,   804,   805,   805,   806,   807,   808,   809,   809,
     809,   809,   809,   809,   809,   809,   809,   809,   809,   809,
     809,   809,   809,   809,   809,   809,   809,   810,   810,   811,
     811,   812,   783,   627,   813,   627,   814,   627,   815,   627,
     816,   719,   817,   818,   818,   818,   819,   819,   819,   819,
     819,   820,   820,   821,   821,   822,   822,   822,   822,   822,
     822,   822,   822,   822,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   823,   823,   823,   823,
     823,   823,   823,   823,   823,   823,   824,   825,   823,   823,
     826,   826,   826,   826,   826,   826,   826,   826,   826,   826,
     826,   826,   827,   828,   828,   828,   829,   829,   829,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   830,   830,   830,   830,   830,   830,   830,
     830,   830,   830,   831,   831,   832,   832,   833,   834,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   719,   835,   836,   836,   836,   836,   836,   836,
     836,   836,   837,   837,   838,   627,   839,   840,   840,   840,
     840,   840,   840,   719,   841,   841,   841,   842,   843,   843,
     844,   844,   845,   846,   847,   847,   847,   847,   847,   847,
     847,   847,   847,   847,   847,   847,   847,   847,   847,   848,
     849,   850,   850,   851,   851,   851,   851,   851,   851,   851,
     851,   851,   852,   851,   853,   851,   851,   851,   851,   854,
     854,   855,   856,   856,   857,   857,   857,   858,   858,   859,
     859,   860,   860,   860,   860,   860,   860,   860,   860,   860,
     860,   860,   861,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   862,   862,   862,   862,   862,   862,   862,   862,
     862,   862,   863,   863,   864,   865,   866,   866,   866,   867,
     867,   868,   868,   869,   870,   871,   871,   873,   872,   874,
     874,   875,   875,   876,   783,   783,   783,   783,   627,   877,
     627,   878,   627,   879,   627,   880,   627,   881,   627,   882,
     627,   883,   627,   884,   885,   885,   885,   885,   885,   885,
     885,   885,   885,   719,   886,   887,   887,   887,   888,   888,
     888,   888,   888,   888,   888,   888,   888,   888,   719,   890,
     889,   891,   891,   891,   891,   719,   892,   893,   893,   893,
     893,   894,   893,   895,   893,   893,   893,   896,   896,   897,
     898,   899,   899,   899,   899,   899,   899,   899,   899,   899,
     899,   899,   899,   899,   899,   899,   899,   899,   900,   899,
     901,   899,   899,   899,   902,   902,   902,   903,   904,   904,
     905,   905,   906,   907,   908,   908,   908,   908,   908,   909,
     910,   910,   911,   911,   912,   913,   914,   915,   915,   915,
     916,   917,   917,   918,   918,   919,   920,   921,   921,   921,
     922,   923,   923,   924,   924,   925,   925,   926,   926,   783,
     783,   719,   927,   927,   928,   929,   929,   929,   929,   929,
     929,   930,   930,   931,   932,   933,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   935,   935,   935,   935,   936,   936,   937,
     937,   938,   783,   783,   627,   939,   627,   940,   719,   941,
     942,   943,   943,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   945,   945,   946,   947,   947,   948,   948,
     949,   950,   951,   951,   952,   952,   952,   953,   719,   954,
     955,   955,   955,   955,   955,   955,   956,   956,   956,   956,
     956,   956,   957,   957,   958,   959,   959,   959,   959,   959,
     959,   959,   959,   959,   960,   961,   961,   962,   962,   627,
     963,   964,   965,   965,   965,   783,   783,   783,   783,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   783,   783,   783,   783,   783,   783,   783,   783,
     783,   783,   783,   573,   966,   967,   968,   968,   969,   969,
     970,   970,   970,   971,   971,   972,   972,   973,   973,   973,
     973,   973,   973,   973,   973,   973,   573,   974,   974,   573,
     975,   975,   975,   975,   627,   976,   627,   977,   627,   978,
     627,   979,   627,   980,   627,   981,   627,   982,   627,   983,
     984,   984,   985,   985,   985,   719,   986,   964,   964,   987,
     987,   988,   988,   988,   988,   988,   988,   988,   719,   989,
     990,   990,   991,   991,   991,   992,   993,   994,   994,   995,
     995,   996,   783,   783
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       3,     7,     2,     2,     5,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     4,     1,     3,     1,     3,     1,
       3,     4,     6,     6,     0,     1,     1,     1,     1,     1,
       2,     4,     4,     2,     2,     2,     2,     2,     4,     2,
       2,     2,     0,     3,     0,     3,     0,     0,     0,     6,
       6,     1,     1,     1,     2,     1,     2,     1,     2,     1,
       0,     4,     1,     2,     1,     4,     1,     6,     1,     8,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     0,     4,     2,     5,
       0,     4,     1,     1,     1,     2,     4,     1,     0,     5,
       0,     1,     1,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     3,     1,     1,     1,
       5,     7,     5,     7,     9,     7,     5,     7,     5,    11,
       1,     1,     2,     1,     7,     9,     7,     7,     9,     7,
       9,     7,     9,     7,    15,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     3,     1,     3,     1,     3,     1,
       2,     2,     6,     1,     3,     0,     4,     3,     1,     3,
       3,     2,     4,     4,     2,     2,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     1,     3,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     4,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     6,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     7,     6,     6,     6,     6,     4,     8,
       4,     1,     1,     1,     1,     0,     1,     3,     4,     6,
       4,     3,     4,     4,     4,     5,     3,     3,     3,     2,
       5,     4,     7,     7,     7,     7,     7,     9,     0,     1,
       1,     1,     1,     1,     4,     5,     1,     3,     1,     1,
       1,     3,     1,     5,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     0,     1,     2,
       2,     4,     4,     0,     3,     0,     3,     1,     1,     1,
       0,     1,     2,     3,     0,     2,     2,     2,     3,     2,
       2,     2,     1,     2,     2,     2,     3,     3,     3,     2,
       4,     3,     1,     2,     0,     3,     0,     3,     0,     3,
       1,     2,     1,     1,     1,     0,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     3,     1,     1,     1,     1,
       1,     2,     4,     3,     4,     4,     3,     4,     4,     3,
       0,     1,     2,     0,     1,     3,     1,     3,     1,     0,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     5,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       1,     4,     1,     0,     3,     5,     2,     1,     1,     2,
       2,     0,     5,     5,     5,     5,     4,     4,     4,     4,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     0,     2,     4,     4,     4,     2,
       2,     1,     0,     3,     3,     1,     3,     1,     3,     1,
       4,     1,     5,     1,     0,     1,     3,     1,     4,     1,
       4,     0,     2,     3,     3,     3,     3,     4,     4,     3,
       2,     2,     2,     2,     3,     3,     3,     2,     2,     1,
       1,     1,     1,     2,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     4,     0,     2,
       2,     2,     2,     2,     2,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     4,     1,     3,     1,     4,     1,     1,     3,
       0,     1,     1,     4,     1,     4,     1,     4,     1,     3,
       1,     4,     1,     4,     1,     3,     2,     2,     1,     4,
       1,     2,     1,     1,     1,     1,     0,     1,     1,     1,
       2,     1,     2,     2,     2,     2,     0,     3,     5,     1,
       1,     1,     1,     0,     2,     0,     0,     2,     4,     4,
       4,     2,     2,     2,     1,     1,     1,     2,     2,     3,
       3,     0,     3,     0,     3,     4,     3,     0,     2,     2,
       0,     2,     0,     2,     4,     1,     5,     1,     2,     1,
       1,     2,     4,     0,     3,     5,     0,     0,     0,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     2,     3,
       3,     4,     4,     2,     2,     3,     1,     0,     3,     0,
       3,     4,     1,     1,     6,     1,     6,     1,     6,     1,
       6,     2,     2,     0,     3,     3,     0,     3,     3,     2,
       2,     1,     3,     1,     3,     1,     3,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     4,     6,     4,
       6,     6,     4,     6,     5,     5,     4,     5,     5,     6,
       3,     3,     4,     5,     6,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     6,     6,     6,     5,     6,
       8,     6,     6,     6,     5,     6,     5,     4,     4,     4,
       4,     5,     5,     6,     5,     6,     5,     5,     6,     7,
       7,     7,     5,     5,     4,     4,     0,     0,     6,     6,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     2,     3,     2,     2,     2,     2,     3,
       5,     5,     4,     3,     3,     3,     3,     3,     2,     2,
       2,     3,     3,     0,     3,     0,     3,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     2,     2,     1,     2,
       2,     4,     0,     3,     5,     1,     4,     0,     3,     3,
       3,     2,     3,     2,     1,     2,     2,     2,     3,     3,
       0,     1,     2,     3,     1,     1,     2,     2,     3,     3,
       3,     3,     4,     2,     4,     3,     2,     3,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     3,     3,     4,     4,     2,
       2,     2,     3,     3,     3,     2,     3,     3,     3,     4,
       2,     1,     0,     2,     3,     1,     0,     1,     2,     0,
       2,     0,     1,     3,     0,     0,     2,     0,     3,     0,
       3,     0,     3,     3,     1,     1,     1,     1,     1,     4,
       1,     6,     1,     6,     1,     6,     1,     7,     1,     6,
       1,     7,     1,     5,     0,     2,     3,     2,     3,     3,
       2,     3,     2,     2,     2,     3,     3,     3,     1,     3,
       3,     2,     3,     3,     2,     2,     2,     2,     2,     0,
       4,     2,     3,     3,     5,     1,     2,     1,     1,     2,
       2,     0,     3,     0,     3,     2,     3,     0,     3,     5,
       0,     4,     4,     3,     4,     2,     3,     3,     3,     3,
       4,     4,     4,     3,     3,     4,     4,     2,     0,     3,
       0,     3,     3,     3,     1,     1,     1,     0,     0,     3,
       0,     3,     4,     1,     2,     2,     2,     4,     4,     0,
       0,     3,     0,     3,     3,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     2,     0,     2,     1,
       1,     1,     1,     2,     2,     1,     1,     2,     4,     2,
       2,     0,     3,     5,     0,     0,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     1,     1,     1,     6,     1,     6,     1,     2,
       5,     0,     3,     1,     1,     2,     3,     1,     2,     3,
       3,     3,     4,     0,     1,     2,     1,     1,     2,     6,
       0,     0,     0,     3,     4,     4,     2,     0,     2,     2,
       3,     3,     3,     5,     5,     4,     3,     2,     3,     3,
       3,     3,     1,     2,     2,     2,     3,     5,     1,     2,
       2,     2,     2,     2,     1,     0,     2,     0,     3,     1,
       4,     3,     3,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     2,     0,     0,     2,
       2,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     1,
       3,     4,     3,     3,     1,     4,     1,     5,     1,     3,
       1,     3,     1,     3,     1,     4,     1,     2,     1,     3,
       0,     1,     0,     1,     2,     2,     2,     3,     3,     0,
       2,     1,     1,     2,     3,     2,     3,     4,     2,     2,
       3,     3,     1,     2,     3,     0,     2,     0,     3,     0,
       3,     3,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      YY_LAC_DISCARD ("YYBACKUP");                              \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return 1 if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYSIZE_T *yycapacity, YYSIZE_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yytype_int16 **yybottom,
                      yytype_int16 *yybottom_no_free,
                      yytype_int16 **yytop, yytype_int16 *yytop_empty)
{
  YYSIZE_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYSIZE_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYSIZE_T yyalloc = 2 * yysize_new;
      yytype_int16 *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return 1;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        (yytype_int16*) YYSTACK_ALLOC (yyalloc * sizeof *yybottom_new);
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return 1;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                         \
do {                                                             \
  if (!yy_lac_established)                                       \
    {                                                            \
      YYDPRINTF ((stderr,                                        \
                  "LAC: initial context established for %s\n",   \
                  yytname[yytoken]));                            \
      yy_lac_established = 1;                                    \
      {                                                          \
        int yy_lac_status =                                      \
          yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken); \
        if (yy_lac_status == 2)                                  \
          goto yyexhaustedlab;                                   \
        if (yy_lac_status == 1)                                  \
          goto yyerrlab;                                         \
      }                                                          \
    }                                                            \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      if (yydebug)                                                       \
        YYFPRINTF (stderr, "LAC: initial context discarded due to "      \
                   Event "\n");                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return 2 if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yytype_int16 *yyesa, yytype_int16 **yyes,
        YYSIZE_T *yyes_capacity, yytype_int16 *yyssp, int yytoken)
{
  yytype_int16 *yyes_prev = yyssp;
  yytype_int16 *yyesp = yyes_prev;
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yytname[yytoken]));
  if (yytoken == YYUNDEFTOK)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          yyrule = yydefact[*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      {
        YYSIZE_T yylen = yyr2[yyrule];
        YYDPRINTF ((stderr, " R%d", yyrule - 1));
        if (yyesp != yyes_prev)
          {
            YYSIZE_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yylen -= yysize;
                yyesp = yyes_prev;
              }
          }
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      {
        int yystate;
        {
          int yylhs = yyr1[yyrule] - YYNTOKENS;
          yystate = yypgoto[yylhs] + *yyesp;
          if (yystate < 0 || YYLAST < yystate
              || yycheck[yystate] != *yyesp)
            yystate = yydefgoto[yylhs];
          else
            yystate = yytable[yystate];
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            *yyesp = yystate;
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return 2;
              }
            *++yyesp = yystate;
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store or if
   yy_lac returned 2.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyesa, yytype_int16 **yyes,
                YYSIZE_T *yyes_capacity, yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          int yyx;

          for (yyx = 0; yyx < YYNTOKENS; ++yyx)
            if (yyx != YYTERROR && yyx != YYUNDEFTOK)
              {
                {
                  int yy_lac_status = yy_lac (yyesa, yyes, yyes_capacity,
                                              yyssp, yyx);
                  if (yy_lac_status == 2)
                    return 2;
                  if (yy_lac_status == 1)
                    continue;
                }
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
# if YYDEBUG
      else if (yydebug)
        YYFPRINTF (stderr, "No expected tokens.\n");
# endif
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

    yytype_int16 yyesa[20];
    yytype_int16 *yyes;
    YYSIZE_T yyes_capacity;

  int yy_lac_established = 0;
  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  yyes = yyesa;
  yyes_capacity = sizeof yyesa / sizeof *yyes;
  if (YYMAXDEPTH < yyes_capacity)
    yyes_capacity = YYMAXDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
          case 2:
#line 136 "conf/confbase.Y" /* yacc.c:1646  */
    { return 0; }
#line 5735 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 137 "conf/confbase.Y" /* yacc.c:1646  */
    { return 0; }
#line 5741 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 153 "conf/confbase.Y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_allocz(sizeof(struct f_val));
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, val) > F_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val, val);
   }
#line 5751 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 162 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 5757 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 163 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number constant expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 5765 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 169 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) S_; }
#line 5771 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 170 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 5777 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 171 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.time) = (yyvsp[-1].i) US_; }
#line 5783 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 179 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 5789 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 180 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 5795 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 181 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 5801 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 182 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5807 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 183 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5813 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 184 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 5819 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 191 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 5825 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 192 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 5831 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 193 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address constant expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 5840 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 200 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 5846 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 201 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 5852 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 208 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 5861 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 215 "conf/confbase.Y" /* yacc.c:1646  */
    {
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 5874 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 225 "conf/confbase.Y" /* yacc.c:1646  */
    {
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 5890 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 238 "conf/confbase.Y" /* yacc.c:1646  */
    {
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 5912 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 257 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 5921 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 263 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 5930 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 269 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 5941 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 277 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 5952 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 285 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 5961 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 295 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 5967 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 308 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 5977 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 317 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 5987 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 326 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network constant expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 5997 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 336 "conf/confbase.Y" /* yacc.c:1646  */
    { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 6003 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 337 "conf/confbase.Y" /* yacc.c:1646  */
    { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 6009 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 338 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network constant expected");
   }
#line 6022 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 349 "conf/confbase.Y" /* yacc.c:1646  */
    {
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 6032 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 357 "conf/confbase.Y" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 6043 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 366 "conf/confbase.Y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 6053 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 375 "conf/confbase.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String constant expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 6062 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 383 "conf/confbase.Y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 6068 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 37 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_TRUE; }
#line 6074 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 38 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_EQ;  }
#line 6080 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 39 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_NEQ; }
#line 6086 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 40 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_LT;  }
#line 6092 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 41 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_LEQ; }
#line 6098 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 42 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_GT;  }
#line 6104 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 43 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_GEQ; }
#line 6110 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 44 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_FALSE; }
#line 6116 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 48 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_OR; }
#line 6122 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 49 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_OP_AND; }
#line 6128 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 53 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 6134 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 54 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 6140 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 55 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_PORT; }
#line 6146 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 56 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 6152 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 57 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 6158 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 58 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 6164 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 59 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 6170 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 60 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 6176 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 61 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 6182 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 62 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_LABEL; }
#line 6188 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 65 "conf/flowspec.Y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 6194 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 66 "conf/flowspec.Y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 6200 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 67 "conf/flowspec.Y" /* yacc.c:1646  */
    { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 6206 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 70 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 6212 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 71 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 6218 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 75 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6227 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 79 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6236 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 88 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 6245 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 92 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 6256 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 106 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6265 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 110 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6274 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 114 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 6283 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 121 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 0x00; }
#line 6289 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 122 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 0x02; }
#line 6295 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 126 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 1; }
#line 6301 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 127 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 2; }
#line 6307 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 128 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 4; }
#line 6313 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 129 "conf/flowspec.Y" /* yacc.c:1646  */
    { (yyval.i32) = 8; }
#line 6319 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 133 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6327 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 136 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6335 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 139 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 6343 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 145 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 6352 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 155 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 6361 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 159 "conf/flowspec.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 6372 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 181 "conf/flowspec.Y" /* yacc.c:1646  */
    {
  if (this_flow == NULL)
    this_flow = flow_builder_init(&root_pool);
  else
    flow_builder_clear(this_flow);
}
#line 6383 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 188 "conf/flowspec.Y" /* yacc.c:1646  */
    { this_flow->ipv6 = 0; }
#line 6389 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 189 "conf/flowspec.Y" /* yacc.c:1646  */
    { this_flow->ipv6 = 1; }
#line 6395 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 192 "conf/flowspec.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 6404 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 198 "conf/flowspec.Y" /* yacc.c:1646  */
    {
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 6413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 319 "filter/config.Y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, filter, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 320 "filter/config.Y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .sym = (yyvsp[-2].s), .root = (yyvsp[0].fl) };
     (yyvsp[-2].s)->filter = f;

     cf_pop_scope();
   }
#line 6431 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 331 "filter/config.Y" /* yacc.c:1646  */
    { f_eval_int(f_linearize((yyvsp[0].x))); }
#line 6437 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 335 "filter/config.Y" /* yacc.c:1646  */
    {
  cf_define_symbol((yyvsp[-1].s), SYM_ATTRIBUTE, attribute, ca_lookup(new_config->pool, (yyvsp[-1].s)->name, (yyvsp[-2].i))->fda);
}
#line 6445 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 341 "filter/config.Y" /* yacc.c:1646  */
    {
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->function;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 6459 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 354 "filter/config.Y" /* yacc.c:1646  */
    {
  cf_assert_symbol((yyvsp[-5].s), SYM_FUNCTION);
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-5].s)->function;
  t->cmp = (yyvsp[-3].s)->function;
  t->result = (yyvsp[-1].i);
  t->fn_name = (yyvsp[-5].s)->name;
  t->dsc = (yyvsp[-3].s)->name;
  add_tail(&new_config->tests, &t->n);
 }
#line 6475 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 368 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 6481 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 369 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 6487 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 370 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 6493 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 371 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_RD; }
#line 6499 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 372 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_NET; }
#line 6505 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 373 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 6511 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 374 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 6517 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 375 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 6523 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 376 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 6529 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 377 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 6535 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 378 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 6541 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 379 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 6547 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 380 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 6553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 381 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 6559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 382 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 6565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 383 "filter/config.Y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6590 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 407 "filter/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->scope->slots >= 0xfe) cf_error("Too many declarations, at most 255 allowed");
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
   }
#line 6599 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 414 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6605 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 415 "filter/config.Y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-1].s)->scope->slots;
   }
#line 6614 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 422 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6620 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 423 "filter/config.Y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, (yyvsp[-1].s)->scope->slots++);
     (yyval.i) = (yyvsp[-3].i) + 1;
   }
#line 6629 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 432 "filter/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[0].s), SYM_FILTER);
     (yyval.f) = (yyvsp[0].s)->filter;
   }
#line 6638 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 436 "filter/config.Y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .root = (yyvsp[0].fl) };
     (yyval.f) = f;
   }
#line 6648 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 444 "filter/config.Y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN { ACCEPT; } ELSE { REJECT; }' */
     (yyval.f) = f_new_where((yyvsp[0].x));
   }
#line 6657 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 451 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.fl) = f_linearize((yyvsp[-1].x));
     (yyval.fl)->vars = (yyvsp[-3].i);
   }
#line 6666 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 459 "filter/config.Y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, function, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6675 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 462 "filter/config.Y" /* yacc.c:1646  */
    {
     DBG("Definition of function %s with %u args and %u local vars.\n", (yyvsp[-3].s)->name, (yyvsp[-1].i), (yyvsp[0].fl)->vars);
     (yyvsp[0].fl)->args = (yyvsp[-1].i);
     (yyvsp[-3].s)->function = (yyvsp[0].fl);
     cf_pop_scope();
   }
#line 6686 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 472 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6692 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 473 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].xp).begin; }
#line 6698 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 476 "filter/config.Y" /* yacc.c:1646  */
    {
  (yyval.xp).begin = (yyval.xp).end = (yyvsp[0].x);
  if ((yyvsp[0].x))
    while ((yyval.xp).end->next)
      (yyval.xp).end = (yyval.xp).end->next;
}
#line 6709 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 485 "filter/config.Y" /* yacc.c:1646  */
    {
  if (!(yyvsp[-1].xp).begin)
    (yyval.xp) = (yyvsp[0].xp);
  else if (!(yyvsp[0].xp).begin)
    (yyval.xp) = (yyvsp[-1].xp);
  else {
    (yyval.xp).begin = (yyvsp[-1].xp).begin;
    (yyval.xp).end = (yyvsp[0].xp).end;
    (yyvsp[-1].xp).end->next = (yyvsp[0].xp).begin;
  }
 }
#line 6725 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 499 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6733 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 502 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6741 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 511 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 6747 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 512 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 6753 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 525 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6759 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 526 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6765 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 527 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_RD; (yyval.v).val.ec = (yyvsp[0].i64); }
#line 6771 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 528 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6777 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 529 "filter/config.Y" /* yacc.c:1646  */
    {
     if (f_eval(f_linearize((yyvsp[-1].x)), cfg_mem, &((yyval.v))) > F_RETURN) cf_error("Runtime error");
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6786 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 533 "filter/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[0].s), SYM_CONSTANT);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(yyvsp[0].s)->val;
   }
#line 6796 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 541 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6802 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 542 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 6808 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 543 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6814 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 544 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6820 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 548 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int(f_linearize((yyvsp[0].x))); }
#line 6826 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 551 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6832 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 552 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6838 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 553 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6844 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 554 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6850 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 555 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6856 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 556 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6862 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 557 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6868 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 558 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6874 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 559 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6880 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 561 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6886 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 565 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.ecs) = EC_RT; }
#line 6892 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 566 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.ecs) = EC_RO; }
#line 6898 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 567 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.ecs) = (yyvsp[0].i); }
#line 6904 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 568 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.ecs) = EC_GENERIC; }
#line 6910 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 572 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6916 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 573 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].ecs), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6922 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 574 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6928 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 578 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6934 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 579 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6940 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 580 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6946 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 581 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6952 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 582 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6958 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 583 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6964 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 584 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 586 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6976 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 593 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6982 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 594 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 601 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6994 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 602 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7000 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 607 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7006 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 612 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 616 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 7018 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 617 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 7024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 618 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 7030 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 619 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 7040 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 627 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, 0); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 7046 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 628 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); if (!trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi)) cf_error("Mixed IPv4/IPv6 prefixes in prefix set"); }
#line 7052 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 631 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 7058 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 632 "filter/config.Y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     struct f_line *line = f_linearize((yyvsp[0].x));
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = line;
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 7071 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 640 "filter/config.Y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = f_linearize((yyvsp[0].x));
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 7083 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 650 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7089 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 651 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7095 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 655 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7101 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 659 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .asn = (yyvsp[-1].i), .kind = PM_ASN, }, }); (yyval.x)->next = (yyvsp[0].x);  }
#line 7107 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 660 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .from = (yyvsp[-3].i), .to = (yyvsp[-1].i), .kind = PM_ASN_RANGE }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7113 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 661 "filter/config.Y" /* yacc.c:1646  */
    {
   if ((yyvsp[-2].e)->from.type != T_INT) cf_error("Only integer sets allowed in path mask");
   (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = build_tree((yyvsp[-2].e)), .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x);
 }
#line 7122 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 665 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_ASTERISK }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7128 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 666 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_QUESTION }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7134 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 667 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_LOOP }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7140 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 668 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); (yyval.x)->next = (yyvsp[0].x); }
#line 7146 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 669 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7152 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 673 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_INT, .val.i = (yyvsp[0].i), }); }
#line 7158 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 674 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }); }
#line 7164 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 675 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }); }
#line 7170 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 676 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_STRING, .val.s = (yyvsp[0].t), }); }
#line 7176 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 677 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (yyvsp[0].v)); }
#line 7182 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 678 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_RD, .val.ec = (yyvsp[0].i64), }); }
#line 7188 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 679 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_NET, .val.net = (yyvsp[0].net_ptr), }); }
#line 7194 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 680 "filter/config.Y" /* yacc.c:1646  */
    {
     DBG( "We've got a set here..." );
     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = build_tree((yyvsp[-1].e)), });
     DBG( "ook\n" );
 }
#line 7204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 685 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PREFIX_SET, .val.ti = (yyvsp[-1].trie), }); }
#line 7210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 686 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = (yyvsp[0].i) >> 16, .val.i = (yyvsp[0].i) & 0xffff, }); }
#line 7216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 690 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PAIR_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7222 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 691 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EC_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].ecs)); }
#line 7228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 692 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LC_CONSTRUCT, (yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7234 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 693 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATHMASK_CONSTRUCT, (yyvsp[0].x)); }
#line 7240 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 698 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7246 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 699 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 700 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->next = (yyvsp[-2].x); }
#line 7258 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 703 "filter/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");

     struct f_inst *fc = f_new_inst(FI_CALL, (yyvsp[-3].s));
     uint args = 0;
     while ((yyvsp[-1].x)) {
       args++;
       struct f_inst *tmp = (yyvsp[-1].x)->next;
       (yyvsp[-1].x)->next = fc;

       fc = (yyvsp[-1].x);
       (yyvsp[-1].x) = tmp;
     }

     if (args != (yyvsp[-3].s)->function->args)
       cf_error("Function call '%s' got %u arguments, need %u arguments.",
	   (yyvsp[-3].s)->name, args, (yyvsp[-3].s)->function->args);

     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_VOID });
     (yyval.x)->next = fc;
   }
#line 7285 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 728 "filter/config.Y" /* yacc.c:1646  */
    {
    switch ((yyvsp[0].s)->class) {
      case SYM_CONSTANT_RANGE:
	(yyval.x) = f_new_inst(FI_CONSTANT, *((yyvsp[0].s)->val));
	break;
      case SYM_VARIABLE_RANGE:
	(yyval.x) = f_new_inst(FI_VAR_GET, (yyvsp[0].s));
	break;
      case SYM_ATTRIBUTE:
	(yyval.x) = f_new_inst(FI_EA_GET, *(yyvsp[0].s)->attribute);
	break;
      default:
	cf_error("Can't get value of symbol %s", (yyvsp[0].s)->name);
    }
  }
#line 7305 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 746 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	0); }
#line 7311 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 747 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	0); }
#line 7317 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 748 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	1); }
#line 7323 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 749 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	1); }
#line 7329 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 750 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	1); }
#line 7335 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 751 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	0); }
#line 7341 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 752 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	0); }
#line 7347 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 753 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 7353 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 754 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	1); }
#line 7359 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 755 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_WEIGHT,	0); }
#line 7365 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 756 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_GW_MPLS,	0); }
#line 7371 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 760 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7377 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 761 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7383 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 762 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7389 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 763 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7395 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 764 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7401 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 765 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7407 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 766 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 767 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 768 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7425 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 769 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7431 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 770 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7437 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 771 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7443 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 772 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 7449 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 773 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7455 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 774 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7461 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 775 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT, (yyvsp[0].x)); }
#line 7467 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 776 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED, (yyvsp[-1].x)); }
#line 7473 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 778 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7479 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 779 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7485 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 780 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7491 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 782 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7497 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 784 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7503 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 786 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EA_GET, (yyvsp[0].fda)); }
#line 7509 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 788 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IS_V4, (yyvsp[-2].x)); }
#line 7515 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 789 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_TYPE, (yyvsp[-2].x)); }
#line 7521 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 790 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP, (yyvsp[-2].x)); }
#line 7527 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 791 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER, (yyvsp[-2].x)); }
#line 7533 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 792 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH, (yyvsp[-2].x)); }
#line 7539 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 793 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROA_MAXLEN, (yyvsp[-2].x)); }
#line 7545 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 794 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ASN, (yyvsp[-2].x)); }
#line 7551 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 795 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NET_SRC, (yyvsp[-2].x)); }
#line 7557 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 796 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NET_DST, (yyvsp[-2].x)); }
#line 7563 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 797 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK, (yyvsp[-5].x), (yyvsp[-1].x)); }
#line 7569 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 798 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST, (yyvsp[-2].x)); }
#line 7575 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 799 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST, (yyvsp[-2].x)); }
#line 7581 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 800 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG, (yyvsp[-2].x)); }
#line 7587 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 801 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PAIR_DATA, (yyvsp[-2].x)); }
#line 7593 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 802 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LC_DATA1, (yyvsp[-2].x)); }
#line 7599 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 803 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LC_DATA2, (yyvsp[-2].x)); }
#line 7605 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 804 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MIN, (yyvsp[-2].x)); }
#line 7611 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 805 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MAX, (yyvsp[-2].x)); }
#line 7617 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 815 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_path); }
#line 7623 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 816 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_clist); }
#line 7629 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 817 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_eclist); }
#line 7635 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 818 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_lclist); }
#line 7641 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 819 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7647 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 820 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7653 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 821 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_DEL, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7659 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 822 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_FILTER, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7665 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 824 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROA_CHECK_IMPLICIT, (yyvsp[-1].r)); }
#line 7671 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 825 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ROA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 7677 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 827 "filter/config.Y" /* yacc.c:1646  */
    {  (yyval.x) = f_new_inst(FI_FORMAT, (yyvsp[-1].x)); }
#line 7683 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 835 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fret) = F_ACCEPT; }
#line 7689 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 836 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fret) = F_REJECT; }
#line 7695 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 837 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.fret) = F_ERROR; }
#line 7701 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 840 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7707 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 841 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7713 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 842 "filter/config.Y" /* yacc.c:1646  */
    {
     ASSERT((yyvsp[-2].x));
     ASSERT((yyvsp[-2].x)->next == NULL);
     (yyvsp[-2].x)->next = (yyvsp[0].x);
     (yyval.x) = (yyvsp[-2].x);
   }
#line 7724 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 851 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-2].x), (yyvsp[0].x), NULL);
   }
#line 7732 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 854 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-4].x), (yyvsp[-2].x), (yyvsp[0].x));
   }
#line 7740 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 857 "filter/config.Y" /* yacc.c:1646  */
    {
     switch ((yyvsp[-3].s)->class) {
       case SYM_VARIABLE_RANGE:
	 (yyval.x) = f_new_inst(FI_VAR_SET, (yyvsp[-1].x), (yyvsp[-3].s));
	 break;
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), *(yyvsp[-3].s)->attribute);
	 break;
       default:
	 cf_error("Can't assign to symbol %s", (yyvsp[-3].s)->name);
     }
   }
#line 7757 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 869 "filter/config.Y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN, (yyvsp[-1].x));
   }
#line 7766 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 873 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), (yyvsp[-3].fda));
   }
#line 7774 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 876 "filter/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].fsa).readonly)
       cf_error( "This static attribute is read-only.");
     (yyval.x) = f_new_inst(FI_RTA_SET, (yyvsp[-1].x), (yyvsp[-3].fsa));
   }
#line 7784 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 881 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET, (yyvsp[-1].x));
   }
#line 7792 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 884 "filter/config.Y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_EA_UNSET, (yyvsp[-2].fda));
   }
#line 7800 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 887 "filter/config.Y" /* yacc.c:1646  */
    {
    struct f_inst *breaker = f_new_inst(FI_DIE, (yyvsp[-2].fret));
    if ((yyvsp[-1].x)) {
      struct f_inst *printer = f_new_inst(FI_PRINT, (yyvsp[-1].x));
      struct f_inst *flusher = f_new_inst(FI_FLUSH);
      printer->next = flusher;
      flusher->next = breaker;
      (yyval.x) = printer;
    } else
      (yyval.x) = breaker;
   }
#line 7816 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 898 "filter/config.Y" /* yacc.c:1646  */
    {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
    (yyval.x)->next = f_new_inst(FI_FLUSH);
   }
#line 7825 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 902 "filter/config.Y" /* yacc.c:1646  */
    {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
   }
#line 7833 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 905 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DROP_RESULT, (yyvsp[-1].x)); }
#line 7839 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 906 "filter/config.Y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH, (yyvsp[-3].x), build_tree((yyvsp[-1].e)));
   }
#line 7847 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 910 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7853 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 911 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7859 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 912 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7865 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 913 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_DEL, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7871 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 914 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_FILTER, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7877 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 915 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 7883 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 916 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.x) = assert_assign(&(yyvsp[-5].flv), (yyvsp[-2].x), (yyvsp[-6].t) + 1, (yyvsp[-4].t) - 1); }
#line 7889 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 920 "filter/config.Y" /* yacc.c:1646  */
    {
  (yyval.t) = cf_text;
}
#line 7897 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 925 "filter/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_VARIABLE); (yyval.flv) = (struct f_lval) { .type = F_LVAL_VARIABLE, .sym = (yyvsp[0].s) }; }
#line 7903 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 926 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.flv) = (struct f_lval) { .type = F_LVAL_PREFERENCE }; }
#line 7909 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 927 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.flv) = (struct f_lval) { .type = F_LVAL_SA, .sa = (yyvsp[0].fsa) }; }
#line 7915 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 928 "filter/config.Y" /* yacc.c:1646  */
    { (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = (yyvsp[0].fda) }; }
#line 7921 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 162 "nest/config.Y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 7927 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 163 "nest/config.Y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 7933 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 167 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 7939 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 168 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int(f_linearize((yyvsp[-1].x))); }
#line 7945 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 169 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 7951 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 170 "nest/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 7964 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 182 "nest/config.Y" /* yacc.c:1646  */
    { new_config->hostname = (yyvsp[-1].t); }
#line 7970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 186 "nest/config.Y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 7976 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 192 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP4; }
#line 7982 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 193 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP6; }
#line 7988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 194 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_IP6_SADR; }
#line 7994 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 195 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_VPN4; }
#line 8000 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 196 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_VPN6; }
#line 8006 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 197 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_ROA4; }
#line 8012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 198 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_ROA6; }
#line 8018 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 199 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_FLOW4; }
#line 8024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 200 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_FLOW6; }
#line 8030 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 201 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NET_MPLS; }
#line 8036 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 213 "nest/config.Y" /* yacc.c:1646  */
    {
   this_table = rt_new_table((yyvsp[0].s), (yyvsp[-2].i));
   }
#line 8044 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 220 "nest/config.Y" /* yacc.c:1646  */
    { this_table->sorted = 1; }
#line 8050 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 224 "nest/config.Y" /* yacc.c:1646  */
    { this_table->sorted = (yyvsp[0].i); }
#line 8056 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 225 "nest/config.Y" /* yacc.c:1646  */
    {
     if (!net_val_match(this_table->addr_type, NB_IP | NB_VPN | NB_ROA | NB_IP6_SADR))
       cf_error("Trie option not supported for %s table", net_label[this_table->addr_type]);
     this_table->trie_used = (yyvsp[0].i);
   }
#line 8066 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 230 "nest/config.Y" /* yacc.c:1646  */
    { this_table->min_settle_time = (yyvsp[0].time); }
#line 8072 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 231 "nest/config.Y" /* yacc.c:1646  */
    { this_table->max_settle_time = (yyvsp[0].time); }
#line 8078 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 247 "nest/config.Y" /* yacc.c:1646  */
    { proto_postconfig(); }
#line 8084 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 250 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 8090 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 251 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 8096 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 255 "nest/config.Y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;
     }
#line 8107 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 261 "nest/config.Y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 8116 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 265 "nest/config.Y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8131 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 275 "nest/config.Y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8144 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 287 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 8150 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 288 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 8156 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 289 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 8162 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 290 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 8168 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 291 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 8174 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 292 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 8180 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 293 "nest/config.Y" /* yacc.c:1646  */
    { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 8186 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 298 "nest/config.Y" /* yacc.c:1646  */
    {
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 8194 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 303 "nest/config.Y" /* yacc.c:1646  */
    {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 8204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 308 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->in_filter = (yyvsp[0].f); }
#line 8210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 309 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->out_filter = (yyvsp[0].f); }
#line 8216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 310 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->rx_limit = (yyvsp[0].cl); }
#line 8222 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 311 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->in_limit = (yyvsp[0].cl); }
#line 8228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 312 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->out_limit = (yyvsp[0].cl); }
#line 8234 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 313 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 8240 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 314 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 8246 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 315 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->rpki_reload = (yyvsp[0].i); }
#line 8252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 321 "nest/config.Y" /* yacc.c:1646  */
    { this_channel->debug = (yyvsp[0].i); }
#line 8258 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 335 "nest/config.Y" /* yacc.c:1646  */
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 8269 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 345 "nest/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_TABLE); (yyval.r) = (yyvsp[0].s)->table; }
#line 8275 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 348 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 8281 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 350 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 8287 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 351 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 8293 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 355 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 8299 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 356 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 8305 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 357 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 8311 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 358 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 8317 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 359 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 8323 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 363 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 8329 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 364 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.cl) = (struct channel_limit){}; }
#line 8335 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 371 "nest/config.Y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 8341 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 372 "nest/config.Y" /* yacc.c:1646  */
    { new_config->channel_default_debug = (yyvsp[0].i); }
#line 8347 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 373 "nest/config.Y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 8353 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 381 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 8359 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 382 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 8365 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 383 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 8371 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 384 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 8377 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 388 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 8383 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 389 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 8389 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 390 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = TM_ISO_SHORT_S; }
#line 8395 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 391 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_SHORT_MS; }
#line 8401 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 392 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_SHORT_US; }
#line 8407 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 393 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = TM_ISO_LONG_S; }
#line 8413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 394 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_LONG_MS; }
#line 8419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 395 "nest/config.Y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = TM_ISO_LONG_US; }
#line 8425 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 406 "nest/config.Y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 8435 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 414 "nest/config.Y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 8441 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 415 "nest/config.Y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 8447 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 419 "nest/config.Y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 8453 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 420 "nest/config.Y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 8459 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 434 "nest/config.Y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 8465 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 436 "nest/config.Y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 8475 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 448 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 8481 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 449 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 8487 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 456 "nest/config.Y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 8496 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 467 "nest/config.Y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 8502 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 471 "nest/config.Y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 8512 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 485 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 8518 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 486 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8524 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 487 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 8530 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 492 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8536 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 496 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 8542 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 497 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 8548 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 498 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 8554 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 499 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 8560 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 500 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 8566 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 501 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 8572 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 507 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 8578 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 508 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8584 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 509 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 8590 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 514 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 8596 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 518 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 8602 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 519 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 8608 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 546 "nest/config.Y" /* yacc.c:1646  */
    { init_password_list(); init_password((yyvsp[0].t), strlen((yyvsp[0].t)), password_id++); }
#line 8614 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 547 "nest/config.Y" /* yacc.c:1646  */
    { init_password_list(); init_password((yyvsp[0].bs)->data, (yyvsp[0].bs)->length, password_id++); }
#line 8620 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 551 "nest/config.Y" /* yacc.c:1646  */
    { }
#line 8626 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 552 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 8632 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 553 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 8638 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 554 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 8644 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 555 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 8650 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 556 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 8656 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 557 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 8662 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 558 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) > 255) cf_error("Password ID must be in range 0-255"); }
#line 8668 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 559 "nest/config.Y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 8674 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 563 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 8680 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 564 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 8686 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 565 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 8692 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 566 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 8698 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 567 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 8704 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 568 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 8710 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 569 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 8716 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 570 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 8722 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 571 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 8728 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 572 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 8734 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 573 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_BLAKE2S_128; }
#line 8740 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 574 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_BLAKE2S_256; }
#line 8746 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 575 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_BLAKE2B_256; }
#line 8752 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 576 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ALG_BLAKE2B_512; }
#line 8758 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 580 "nest/config.Y" /* yacc.c:1646  */
    {
  password_validate_length(this_p_item);
}
#line 8766 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 588 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->min_rx_int = this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 8772 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 589 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->min_rx_int = (yyvsp[0].time); }
#line 8778 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 590 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 8784 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 591 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->idle_tx_int = (yyvsp[0].time); }
#line 8790 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 592 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->multiplier = (yyvsp[0].i); }
#line 8796 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 593 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->passive = (yyvsp[0].i); this_bfd_opts->passive_set = 1; }
#line 8802 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 594 "nest/config.Y" /* yacc.c:1646  */
    { this_bfd_opts->mode = BGP_BFD_GRACEFUL; }
#line 8808 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 610 "nest/config.Y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 8814 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 613 "nest/config.Y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 8820 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 616 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 8826 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 619 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 8832 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 622 "nest/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.s) = (yyvsp[0].s); }
#line 8838 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 623 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 8844 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 627 "nest/config.Y" /* yacc.c:1646  */
    { if_show(); }
#line 8850 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 630 "nest/config.Y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 8856 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 634 "nest/config.Y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 8862 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 637 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = new_config->fallback;
   }
#line 8873 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 643 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_EQUAL;
   }
#line 8884 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 649 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_FOR;
   }
#line 8895 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 655 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     if (!net_type_match((yyvsp[0].net_ptr), NB_IP)) cf_error("Only IP networks accepted for 'in' argument");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_IN;
   }
#line 8907 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 662 "nest/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[0].s), SYM_TABLE);
     (yyval.ra) = (yyvsp[-2].ra);
     rt_show_add_table((yyval.ra), (yyvsp[0].s)->table->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 8918 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 668 "nest/config.Y" /* yacc.c:1646  */
    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 8930 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 675 "nest/config.Y" /* yacc.c:1646  */
    {
     if (!(yyvsp[0].c)->in_table) cf_error("No import table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 8940 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 680 "nest/config.Y" /* yacc.c:1646  */
    {
     if (!(yyvsp[0].c)->out_table) cf_error("No export table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->out_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 8950 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 685 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 8960 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 690 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 8970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 695 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 8979 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 699 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 8988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 703 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 8997 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 707 "nest/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 717 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_channel = (yyvsp[0].c);
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 724 "nest/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9038 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 733 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 9047 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 737 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 9056 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 744 "nest/config.Y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 9065 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 751 "nest/config.Y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9074 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 755 "nest/config.Y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9083 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 759 "nest/config.Y" /* yacc.c:1646  */
    {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 9092 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 763 "nest/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network constant expected");
   }
#line 9108 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 779 "nest/config.Y" /* yacc.c:1646  */
    { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 9114 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 780 "nest/config.Y" /* yacc.c:1646  */
    { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 9120 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 783 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 9126 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 784 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 9132 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 785 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 9138 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 786 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORTED; }
#line 9144 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 791 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4"; }
#line 9150 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 792 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4-mc"; }
#line 9156 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 793 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv4-mpls"; }
#line 9162 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 794 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6"; }
#line 9168 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 795 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-mc"; }
#line 9174 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 796 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-mpls"; }
#line 9180 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 797 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "ipv6-sadr"; }
#line 9186 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 798 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4"; }
#line 9192 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 799 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4-mc"; }
#line 9198 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 800 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn4-mpls"; }
#line 9204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 801 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6"; }
#line 9210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 802 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6-mc"; }
#line 9216 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 803 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "vpn6-mpls"; }
#line 9222 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 804 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "roa4"; }
#line 9228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 805 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "roa6"; }
#line 9234 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 806 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "flow4"; }
#line 9240 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 807 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "flow6"; }
#line 9246 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 808 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "mpls"; }
#line 9252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 809 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "pri"; }
#line 9258 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 810 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.t) = "sec"; }
#line 9264 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 814 "nest/config.Y" /* yacc.c:1646  */
    {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     struct proto *p =  (yyvsp[-2].s)->proto->proto;
     if (!p) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.c) = proto_find_channel_by_name(p, (yyvsp[0].t));
     if (!(yyval.c)) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
   }
#line 9276 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 825 "nest/config.Y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 9282 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 828 "nest/config.Y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 9290 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 831 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 9296 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 832 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 9302 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 833 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 9308 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 834 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 9314 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 835 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 9320 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 836 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 9326 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 842 "nest/config.Y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 9332 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 844 "nest/config.Y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 9338 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 846 "nest/config.Y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 9344 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 848 "nest/config.Y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 9350 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 850 "nest/config.Y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 9356 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 852 "nest/config.Y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 9362 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 854 "nest/config.Y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 9368 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 856 "nest/config.Y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 9374 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 858 "nest/config.Y" /* yacc.c:1646  */
    { filters_dump_all(); cli_msg(0, ""); }
#line 9380 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 861 "nest/config.Y" /* yacc.c:1646  */
    { cmd_eval(f_linearize((yyvsp[-1].x))); }
#line 9386 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 864 "nest/config.Y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 9395 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 870 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 9401 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 871 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 9407 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 872 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 9413 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 876 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 9419 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 877 "nest/config.Y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 9428 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 884 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9434 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 886 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9440 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 888 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 9446 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 890 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 9452 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 892 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 9458 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 894 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 9464 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 898 "nest/config.Y" /* yacc.c:1646  */
    { /* Done in debug_args */  }
#line 9470 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 901 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_debug, 1, (yyvsp[0].i));  }
#line 9476 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 902 "nest/config.Y" /* yacc.c:1646  */
    { channel_cmd_debug((yyvsp[-1].c), (yyvsp[0].i)); }
#line 9482 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 907 "nest/config.Y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 9488 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 910 "nest/config.Y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 9494 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 913 "nest/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9500 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 914 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9506 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 915 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9512 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 919 "nest/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 9518 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 920 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 9524 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 921 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 9530 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 924 "nest/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9536 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 37 "proto/bfd/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
  BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
  BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
}
#line 9548 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 63 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_CFG->accept_ipv4 = 1;  BFD_CFG->accept_ipv6 = 0; }
#line 9554 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 64 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_CFG->accept_ipv4 = 0;  BFD_CFG->accept_ipv6 = 1; }
#line 9560 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 65 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_CFG->accept_direct = 1;  BFD_CFG->accept_multihop = 0; }
#line 9566 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 66 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_CFG->accept_direct = 0;  BFD_CFG->accept_multihop = 1; }
#line 9572 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 70 "proto/bfd/config.Y" /* yacc.c:1646  */
    {
     BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
     BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
   }
#line 9581 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 78 "proto/bfd/config.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 9598 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 92 "proto/bfd/config.Y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 9621 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 112 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9627 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 113 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 9633 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 114 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 9639 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 115 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 9645 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 116 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 9651 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 117 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 9657 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 118 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 9663 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 119 "proto/bfd/config.Y" /* yacc.c:1646  */
    {}
#line 9669 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 123 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 9675 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 124 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 9681 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 125 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 9687 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 126 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 9693 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 127 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 9699 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 128 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 9705 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 146 "proto/bfd/config.Y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 9711 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 150 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 9717 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 151 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 9723 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 152 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 9729 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 156 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 9735 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 157 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 9741 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 161 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 9747 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 162 "proto/bfd/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 9753 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 166 "proto/bfd/config.Y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 9773 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 185 "proto/bfd/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-1].s), &proto_bfd, p) bfd_show_sessions(p); }
#line 9779 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 35 "proto/babel/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 9789 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 45 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_CFG->randomize_router_id = (yyvsp[0].i); }
#line 9795 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 58 "proto/babel/config.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 9813 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 74 "proto/babel/config.Y" /* yacc.c:1646  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);

  BABEL_IFACE->passwords = get_passwords();

  if (!BABEL_IFACE->auth_type != !BABEL_IFACE->passwords)
    cf_error("Authentication and password options should be used together");

  if (BABEL_IFACE->passwords)
  {
    struct password_item *pass;
    uint len = 0, i = 0;

    WALK_LIST(pass, *BABEL_IFACE->passwords)
    {
      /* Set default crypto algorithm (HMAC-SHA256) */
      if (!pass->alg)
	pass->alg = ALG_HMAC_SHA256;

      if (!((pass->alg & ALG_HMAC) ||
	    (pass->alg == ALG_BLAKE2S_128) ||
	    (pass->alg == ALG_BLAKE2S_256) ||
	    (pass->alg == ALG_BLAKE2B_256) ||
	    (pass->alg == ALG_BLAKE2B_512)))
	cf_error("Only HMAC and Blake2 algorithms are supported");

      len += mac_type_length(pass->alg);
      i++;
    }

    BABEL_IFACE->mac_num_keys = i;
    BABEL_IFACE->mac_total_len = len;
  }

}
#line 9873 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 132 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9879 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 133 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 9885 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 134 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 9891 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 135 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 9897 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 136 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 9903 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 137 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 9909 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 138 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 9915 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 139 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 9921 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 140 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9927 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 141 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 9933 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 142 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 9939 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 143 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 9945 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 144 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 9951 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 145 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 9957 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 146 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->auth_type = BABEL_AUTH_NONE; }
#line 9963 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 147 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 0; }
#line 9969 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 148 "proto/babel/config.Y" /* yacc.c:1646  */
    { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 1; }
#line 9975 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 166 "proto/babel/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); }
#line 9981 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 171 "proto/babel/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_interfaces(p, (yyvsp[-1].t)); }
#line 9987 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 174 "proto/babel/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_neighbors(p, (yyvsp[-1].t)); }
#line 9993 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 177 "proto/babel/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_entries(p); }
#line 9999 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 180 "proto/babel/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p)  babel_show_routes(p); }
#line 10005 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 49 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->enable_hostname = 0;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->allow_as_sets = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
     BGP_CFG->dynamic_name = "dynbgp";
     BGP_CFG->check_link = -1;
   }
#line 10039 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 82 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10045 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 83 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[0].i); }
#line 10051 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 88 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10057 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 89 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 10063 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 90 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->peer_type = BGP_PT_INTERNAL; }
#line 10069 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 91 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->peer_type = BGP_PT_EXTERNAL; }
#line 10075 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 96 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 10081 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 97 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 10087 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 102 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 10093 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 106 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 10099 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 107 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 10105 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 108 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 10111 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 109 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 10117 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 110 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 10123 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 111 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 10129 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 112 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 10135 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 113 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 10141 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 114 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 10147 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 122 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10156 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 127 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10167 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 133 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     net_addr *n = cfg_alloc((yyvsp[-2].net).length);
     net_copy(n, &((yyvsp[-2].net)));
     BGP_CFG->remote_range = n;
   }
#line 10179 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 140 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 10185 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 141 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 10191 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 142 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 10197 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 143 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 10203 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 144 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 10209 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 145 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 10215 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 146 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 10221 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 147 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 10227 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 148 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 10233 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 149 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 10239 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 150 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 10245 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 151 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
     if (strchr((yyvsp[-1].t), '%')) cf_error("Forbidden character '%%' in dynamic name");
     if (strlen((yyvsp[-1].t)) > (SYM_MAX_LEN - 16)) cf_error("Dynamic name too long");
     BGP_CFG->dynamic_name = (yyvsp[-1].t);
   }
#line 10255 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 156 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->dynamic_name_digits = (yyvsp[-1].i); if ((yyvsp[-1].i)>10) cf_error("Dynamic name digits must be at most 10"); }
#line 10261 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 157 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 10267 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 158 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->free_bind = (yyvsp[-1].i); }
#line 10273 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 159 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 10279 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 160 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 10285 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 161 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 10291 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 162 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 10297 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 163 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 10303 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 164 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 10309 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 165 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 10315 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 166 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 10321 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 167 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 10327 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 168 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 10333 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 169 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 10339 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 170 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 10345 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 171 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 10351 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 172 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 10357 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 173 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 10363 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 174 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 10369 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 175 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 10375 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 176 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 10381 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 177 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 10387 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 178 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->enable_hostname = (yyvsp[-1].i); }
#line 10393 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 179 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 10399 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 180 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 10405 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 181 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 10411 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 182 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 10417 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 183 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 10423 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 184 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 10429 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 185 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 10435 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 186 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 10441 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 187 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->allow_as_sets = (yyvsp[-1].i); }
#line 10447 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 188 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 10453 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 189 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 10459 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 190 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 10465 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 191 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 10471 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 192 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 10477 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 193 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 10483 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 194 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 10489 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 195 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 10495 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 196 "proto/bgp/config.Y" /* yacc.c:1646  */
    { if ((yyvsp[-1].i)) init_bfd_opts(&BGP_CFG->bfd); else BGP_CFG->bfd = NULL; }
#line 10501 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 197 "proto/bgp/config.Y" /* yacc.c:1646  */
    { init_bfd_opts(&BGP_CFG->bfd); BGP_CFG->bfd->mode = BGP_BFD_GRACEFUL; }
#line 10507 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 198 "proto/bgp/config.Y" /* yacc.c:1646  */
    { open_bfd_opts(&BGP_CFG->bfd); }
#line 10513 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 198 "proto/bgp/config.Y" /* yacc.c:1646  */
    { close_bfd_opts(); }
#line 10519 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 199 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CFG->enforce_first_as = (yyvsp[-1].i); }
#line 10525 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 203 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4; }
#line 10531 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 204 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6; }
#line 10537 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 205 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 10543 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 206 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 10549 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 207 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 10555 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 208 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 10561 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 209 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 10567 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 210 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 10573 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 211 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 10579 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 212 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 10585 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 213 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_FLOW4; }
#line 10591 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 214 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i32) = BGP_AF_FLOW6; }
#line 10597 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 218 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
    BGP_CC->aigp = 0xff;	/* undefined */
  }
}
#line 10625 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 243 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 10631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 244 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NH_IBGP; }
#line 10637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 245 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.i) = NH_EBGP; }
#line 10643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 251 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 10649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 252 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->next_hop_self = (yyvsp[0].i); }
#line 10655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 253 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->next_hop_keep = (yyvsp[0].i); }
#line 10661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 254 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->mandatory = (yyvsp[0].i); }
#line 10667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 255 "proto/bgp/config.Y" /* yacc.c:1646  */
    { log(L_WARN "%s.%s: Missing lladdr option is deprecated and ignored, remove it", this_proto->name, this_channel->name); }
#line 10673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 256 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->gw_mode = GW_DIRECT; }
#line 10679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 257 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 10685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 258 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->secondary = (yyvsp[0].i); }
#line 10691 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 259 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
    BGP_CC->validate = (yyvsp[0].i);
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Validate option limited to flowspec channels");
   }
#line 10701 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 264 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->gr_able = (yyvsp[0].i); }
#line 10707 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 265 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->llgr_able = (yyvsp[0].i); }
#line 10713 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 266 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->llgr_time = (yyvsp[0].i); }
#line 10719 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 267 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 10725 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 268 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 10731 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 269 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 10737 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 270 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 10743 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 271 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->import_table = (yyvsp[0].i); }
#line 10749 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 272 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->export_table = (yyvsp[0].i); }
#line 10755 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 273 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->aigp = (yyvsp[0].i); BGP_CC->aigp_originate = 0; }
#line 10761 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 274 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->aigp = 1; BGP_CC->aigp_originate = 1; }
#line 10767 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 275 "proto/bgp/config.Y" /* yacc.c:1646  */
    { BGP_CC->cost = (yyvsp[0].i); if ((yyvsp[0].i) < 1) cf_error("Cost must be positive"); }
#line 10773 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 276 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 10789 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 287 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Base table option limited to flowspec channels");

    if (((BGP_CC->afi == BGP_AF_FLOW4) && ((yyvsp[0].r)->addr_type == NET_IP4)) ||
        ((BGP_CC->afi == BGP_AF_FLOW6) && ((yyvsp[0].r)->addr_type == NET_IP6)))
      BGP_CC->base_table = (yyvsp[0].r);
    else
      cf_error("Mismatched base table type");
   }
#line 10804 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 310 "proto/bgp/config.Y" /* yacc.c:1646  */
    {
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 10815 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 321 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN)); }
#line 10821 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 323 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH)); }
#line 10827 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 325 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP)); }
#line 10833 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 327 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC)); }
#line 10839 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 329 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF)); }
#line 10845 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 331 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); }
#line 10851 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 333 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR)); }
#line 10857 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 335 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY)); }
#line 10863 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 337 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID)); }
#line 10869 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 339 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST)); }
#line 10875 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 341 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY)); }
#line 10881 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 343 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AIGP)); }
#line 10887 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 345 "proto/bgp/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); }
#line 10893 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 29 "proto/mrt/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 10901 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 35 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->table_cf = (yyvsp[0].r); }
#line 10907 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 36 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 10913 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 37 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 10919 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 38 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 10925 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 39 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->filename = (yyvsp[0].t); }
#line 10931 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 40 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->period = (yyvsp[0].i); }
#line 10937 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 41 "proto/mrt/config.Y" /* yacc.c:1646  */
    { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 10943 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 50 "proto/mrt/config.Y" /* yacc.c:1646  */
    { mrt_check_config(this_proto); }
#line 10949 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 54 "proto/mrt/config.Y" /* yacc.c:1646  */
    { mrt_dump_cmd((yyvsp[-1].md)); }
#line 10955 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 57 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 10961 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 58 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 10967 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 59 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 10973 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 60 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 10979 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 61 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 10985 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 62 "proto/mrt/config.Y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 10991 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 211 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 10997 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 214 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 11003 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 215 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 11009 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 216 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 11015 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 220 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
  OSPF_CFG->gr_mode = OSPF_GR_AWARE;
  OSPF_CFG->gr_time = OSPF_DEFAULT_GR_TIME;
}
#line 11033 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 960:
#line 240 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 11039 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 961:
#line 241 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 11045 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 962:
#line 246 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 11057 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 965:
#line 258 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11063 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 966:
#line 259 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 11069 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 967:
#line 260 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 11075 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 968:
#line 261 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->vpn_pe = (yyvsp[0].i); }
#line 11081 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 262 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 11087 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 970:
#line 263 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->gr_mode = (yyvsp[0].i); }
#line 11093 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 971:
#line 264 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->gr_mode = OSPF_GR_AWARE; }
#line 11099 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 972:
#line 265 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->gr_time = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 1800)) cf_error("Graceful restart time must be in range 1-1800"); }
#line 11105 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 973:
#line 266 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 11111 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 974:
#line 267 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 11117 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 975:
#line 268 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 11123 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 976:
#line 269 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 11129 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 977:
#line 270 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11135 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 979:
#line 274 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 11153 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 980:
#line 289 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 11159 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 983:
#line 298 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 11165 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 984:
#line 299 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 11171 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 985:
#line 300 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 11177 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 986:
#line 301 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 11183 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 987:
#line 302 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11189 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 988:
#line 303 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 11195 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 989:
#line 304 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11201 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 990:
#line 305 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 11207 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 991:
#line 306 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 11213 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 992:
#line 307 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 11219 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 994:
#line 308 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 11225 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 320 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 11236 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 334 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 11242 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 335 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 11248 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 336 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 11254 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 340 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 11260 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 341 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 11266 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 350 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11272 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 351 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11278 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 352 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11284 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 353 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11290 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 354 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11296 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 355 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11302 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 356 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 11308 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 357 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11314 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 358 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11320 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 363 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 11340 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 381 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 11346 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 382 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11352 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 383 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 11358 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 384 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 11364 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 385 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 11370 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 386 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 11376 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 387 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 11382 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 388 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11388 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 389 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 11394 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 390 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11400 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 391 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 11406 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 392 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11412 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 393 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 11418 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 394 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11424 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 395 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 11430 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 396 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 11436 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 397 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 11442 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 398 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_address = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP address option requires OSPFv2"); }
#line 11448 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 399 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 11454 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 400 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 11460 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 401 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 11466 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 402 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 11472 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 403 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 11478 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 404 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 11484 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 405 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 11490 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 407 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 11496 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 408 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 11502 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 409 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 11508 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 410 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 11514 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 411 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 11520 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 412 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 11526 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 413 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 11532 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 414 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 11538 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 415 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 11544 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 416 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 11550 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 417 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 11556 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 418 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 11562 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 430 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 11572 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 439 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 11578 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 440 "proto/ospf/config.Y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 11584 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 449 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 11590 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 450 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 11596 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 454 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 11607 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 463 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->ptp_address = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 11632 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 487 "proto/ospf/config.Y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11638 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 491 "proto/ospf/config.Y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 11644 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 505 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 11650 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 508 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); }
#line 11656 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 509 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); }
#line 11662 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 510 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); }
#line 11668 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 511 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 11674 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 515 "proto/ospf/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-1].s), &proto_ospf, p) ospf_sh(p); }
#line 11680 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 518 "proto/ospf/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_neigh(p, (yyvsp[-1].t)); }
#line 11686 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 521 "proto/ospf/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_iface(p, (yyvsp[-1].t)); }
#line 11692 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 526 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 11698 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 529 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 11704 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 534 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 11710 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 537 "proto/ospf/config.Y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 11716 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 541 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
  if (!(yyvsp[-1].ld)->proto)
    (yyvsp[-1].ld)->proto = (struct ospf_proto *) proto_get_named(NULL, &proto_ospf);

  ospf_sh_lsadb((yyvsp[-1].ld));
}
#line 11727 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 549 "proto/ospf/config.Y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 11735 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 552 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 11741 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 553 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 11747 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 554 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 11753 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 555 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 11759 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 556 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 11765 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 557 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 11771 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 558 "proto/ospf/config.Y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 11777 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 559 "proto/ospf/config.Y" /* yacc.c:1646  */
    { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->proto = (struct ospf_proto *) proto_get_named((yyvsp[0].s), &proto_ospf); }
#line 11783 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 27 "proto/perf/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_perf, (yyvsp[-1].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->attrs_per_rte = 0;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
}
#line 11799 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 46 "proto/perf/config.Y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11805 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 47 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->from = (yyvsp[0].i); }
#line 11811 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 48 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->to = (yyvsp[0].i); }
#line 11817 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 49 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->repeat = (yyvsp[0].i); }
#line 11823 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 50 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->threshold_min = (yyvsp[0].time); }
#line 11829 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 51 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->threshold_max = (yyvsp[0].time); }
#line 11835 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 52 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->attrs_per_rte = (yyvsp[0].i); }
#line 11841 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 53 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->keep = (yyvsp[0].i); }
#line 11847 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 54 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->mode = PERF_MODE_IMPORT; }
#line 11853 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 55 "proto/perf/config.Y" /* yacc.c:1646  */
    { PERF_CFG->mode = PERF_MODE_EXPORT; }
#line 11859 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 23 "proto/pipe/config.Y" /* yacc.c:1646  */
    { this_channel = NULL; }
#line 11865 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 26 "proto/pipe/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 11873 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 30 "proto/pipe/config.Y" /* yacc.c:1646  */
    {
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 11886 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 43 "proto/pipe/config.Y" /* yacc.c:1646  */
    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 11892 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 47 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  this_proto->net_type = NET_IP6;

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 11906 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 61 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 11912 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 62 "proto/radv/config.Y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 11918 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 62 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 11924 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 63 "proto/radv/config.Y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 11930 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 63 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 11936 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 64 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_CFG->trigger = (yyvsp[0].net); }
#line 11942 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 65 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 11948 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 78 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 11974 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 101 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 11980 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 102 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 11986 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 103 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 11992 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 104 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->solicited_ra_unicast = (yyvsp[0].i); }
#line 11998 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 105 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 12004 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 106 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 12010 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 107 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 12016 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 108 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 12022 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 109 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 12028 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 110 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 12034 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 111 "proto/radv/config.Y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12044 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 116 "proto/radv/config.Y" /* yacc.c:1646  */
    {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12053 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 120 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 12059 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 121 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 12065 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 122 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 12071 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 123 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 12077 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 124 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 12083 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 125 "proto/radv/config.Y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 12089 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 125 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 12095 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 126 "proto/radv/config.Y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 12101 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 126 "proto/radv/config.Y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 12107 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 127 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 12113 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 128 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 12119 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 132 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 12125 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 133 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 12131 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 134 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 12137 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 137 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 12178 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 190 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 12192 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 201 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 12198 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 202 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 12204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 203 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 12210 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 204 "proto/radv/config.Y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12219 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 208 "proto/radv/config.Y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12228 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 215 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 12240 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 239 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 248 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12261 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 255 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 12267 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 259 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 12283 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 283 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 12298 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 295 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12307 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 302 "proto/radv/config.Y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 12313 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 306 "proto/radv/config.Y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 12329 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 330 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 12335 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 331 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 12341 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 335 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (uint) -1; }
#line 12347 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 336 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 12353 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 339 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 12359 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 340 "proto/radv/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 12365 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 49 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 12371 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 50 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 12377 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 54 "proto/rip/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 12393 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 69 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 12399 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 70 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 12405 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 71 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 12411 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 85 "proto/rip/config.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
  RIP_IFACE->rxmt_time = RIP_DEFAULT_RXMT_TIME;
}
#line 12439 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 110 "proto/rip/config.Y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 12472 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 140 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 12478 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 141 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 12484 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 142 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 12490 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 143 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 12496 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 144 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 12502 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 145 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 12508 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 146 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 12517 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 150 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 12523 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 151 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 12529 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 152 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 12535 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 153 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 12541 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 154 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->demand_circuit = (yyvsp[0].i); }
#line 12547 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 155 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 12553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 156 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 12559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 157 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 12565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 158 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->rxmt_time = (yyvsp[0].time); if ((yyvsp[0].time)<=0) cf_error("Retransmit time must be positive"); }
#line 12571 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 159 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 12577 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 160 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 12583 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 161 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 12589 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 162 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 12595 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 163 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 12601 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 164 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 12607 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 165 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 12613 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 166 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 12619 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 167 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 12625 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 168 "proto/rip/config.Y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 12631 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 169 "proto/rip/config.Y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 12637 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 173 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 12643 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 174 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 12649 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 175 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12655 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 176 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 12661 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 193 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); }
#line 12667 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 194 "proto/rip/config.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); }
#line 12673 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 199 "proto/rip/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_interfaces(p, (yyvsp[-1].t)); }
#line 12679 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 202 "proto/rip/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_neighbors(p, (yyvsp[-1].t)); }
#line 12685 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 43 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rpki, (yyvsp[-1].i));
  RPKI_CFG->retry_interval = RPKI_RETRY_INTERVAL;
  RPKI_CFG->refresh_interval = RPKI_REFRESH_INTERVAL;
  RPKI_CFG->expire_interval = RPKI_EXPIRE_INTERVAL;
}
#line 12696 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 50 "proto/rpki/config.Y" /* yacc.c:1646  */
    { rpki_check_config(RPKI_CFG); }
#line 12702 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 64 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
     if (rpki_check_refresh_interval((yyvsp[0].i)))
       cf_error(rpki_check_refresh_interval((yyvsp[0].i)));
     RPKI_CFG->refresh_interval = (yyvsp[0].i);
     RPKI_CFG->keep_refresh_interval = (yyvsp[-1].i);
   }
#line 12713 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 70 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
     if (rpki_check_retry_interval((yyvsp[0].i)))
       cf_error(rpki_check_retry_interval((yyvsp[0].i)));
     RPKI_CFG->retry_interval = (yyvsp[0].i);
     RPKI_CFG->keep_retry_interval = (yyvsp[-1].i);
   }
#line 12724 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 76 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
     if (rpki_check_expire_interval((yyvsp[0].i)))
       cf_error(rpki_check_expire_interval((yyvsp[0].i)));
     RPKI_CFG->expire_interval = (yyvsp[0].i);
     RPKI_CFG->keep_expire_interval = (yyvsp[-1].i);
   }
#line 12735 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 82 "proto/rpki/config.Y" /* yacc.c:1646  */
    { RPKI_CFG->ignore_max_length = (yyvsp[0].i); }
#line 12741 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 86 "proto/rpki/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 12747 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 87 "proto/rpki/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 12753 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 90 "proto/rpki/config.Y" /* yacc.c:1646  */
    { check_u16((yyvsp[0].i)); RPKI_CFG->port = (yyvsp[0].i); }
#line 12759 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 93 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
     rpki_check_unused_hostname();
     RPKI_CFG->hostname = (yyvsp[0].t);
   }
#line 12768 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 97 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
     rpki_check_unused_hostname();
     RPKI_CFG->ip = (yyvsp[0].a);
     /* Ensure hostname is filled */
     char *hostname = cfg_allocz(INET6_ADDRSTRLEN + 1);
     bsnprintf(hostname, INET6_ADDRSTRLEN+1, "%I", RPKI_CFG->ip);
     RPKI_CFG->hostname = hostname;
   }
#line 12781 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 113 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_tcp_config));
  RPKI_CFG->tr_config.type = RPKI_TR_TCP;
}
#line 12791 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 120 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
#if HAVE_LIBSSH
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_ssh_config));
  RPKI_CFG->tr_config.type = RPKI_TR_SSH;
#else
  cf_error("This build doesn't support SSH");
#endif
}
#line 12805 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 136 "proto/rpki/config.Y" /* yacc.c:1646  */
    { RPKI_TR_SSH_CFG->bird_private_key = (yyvsp[0].t); }
#line 12811 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 137 "proto/rpki/config.Y" /* yacc.c:1646  */
    { RPKI_TR_SSH_CFG->cache_public_key = (yyvsp[0].t); }
#line 12817 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 138 "proto/rpki/config.Y" /* yacc.c:1646  */
    { RPKI_TR_SSH_CFG->user = (yyvsp[0].t); }
#line 12823 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 142 "proto/rpki/config.Y" /* yacc.c:1646  */
    {
  if (RPKI_TR_SSH_CFG->user == NULL)
    cf_error("User must be set");
}
#line 12832 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 57 "proto/static/config.Y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 12841 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 65 "proto/static/config.Y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 12847 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 66 "proto/static/config.Y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 12853 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 67 "proto/static/config.Y" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 12866 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 75 "proto/static/config.Y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 12872 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 79 "proto/static/config.Y" /* yacc.c:1646  */
    {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 12882 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 84 "proto/static/config.Y" /* yacc.c:1646  */
    {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 12892 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 89 "proto/static/config.Y" /* yacc.c:1646  */
    {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 12900 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 92 "proto/static/config.Y" /* yacc.c:1646  */
    {
    this_snh->onlink = (yyvsp[0].i);
  }
#line 12908 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 95 "proto/static/config.Y" /* yacc.c:1646  */
    {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 12917 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 99 "proto/static/config.Y" /* yacc.c:1646  */
    {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
  }
#line 12925 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 109 "proto/static/config.Y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt_cmds = NULL;
     this_srt_last_cmd = NULL;
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 12939 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 122 "proto/static/config.Y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 12948 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 126 "proto/static/config.Y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 12958 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 131 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_NONE; }
#line 12964 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 132 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 12970 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 133 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 12976 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 134 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 12982 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 135 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 12988 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 136 "proto/static/config.Y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 12994 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 140 "proto/static/config.Y" /* yacc.c:1646  */
    {
     if (this_srt_last_cmd)
       this_srt_last_cmd->next = (yyvsp[0].x);
     else
       this_srt_cmds = (yyvsp[0].x);
     this_srt_last_cmd = (yyvsp[0].x);
   }
#line 13006 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 161 "proto/static/config.Y" /* yacc.c:1646  */
    { PROTO_WALK_CMD((yyvsp[-1].s), &proto_static, p) static_show(p); }
#line 13012 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 26 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 13018 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 27 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 13024 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 28 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { THIS_KRT->sys.netlink_rx_buffer = (yyvsp[0].i); }
#line 13030 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 31 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 13036 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 32 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 13042 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 33 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 13048 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 35 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 13054 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 36 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 13060 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 37 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 13066 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 38 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 13072 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 39 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 13078 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 40 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 13084 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 41 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 13090 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 42 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 13096 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 43 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 13102 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 44 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 13108 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 45 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 13114 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 46 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 13120 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 47 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 13126 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 51 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(2, T_BOOL, EA_KRT_LOCK); }
#line 13132 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 52 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_LOCK); }
#line 13138 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 53 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(4, T_BOOL, EA_KRT_LOCK); }
#line 13144 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 54 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(5, T_BOOL, EA_KRT_LOCK); }
#line 13150 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 55 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK); }
#line 13156 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 56 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(7, T_BOOL, EA_KRT_LOCK); }
#line 13162 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 57 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(8, T_BOOL, EA_KRT_LOCK); }
#line 13168 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 58 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(9, T_BOOL, EA_KRT_LOCK); }
#line 13174 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 59 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(10, T_BOOL, EA_KRT_LOCK); }
#line 13180 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 60 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(13, T_BOOL, EA_KRT_LOCK); }
#line 13186 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 62 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr_bit(0, T_BOOL, EA_KRT_FEATURES); }
#line 13192 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 63 "sysdep/linux/netlink.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(3, T_BOOL, EA_KRT_FEATURES); }
#line 13198 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 33 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { this_log = cfg_allocz(sizeof(struct log_config)); }
#line 13204 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 35 "sysdep/unix/config.Y" /* yacc.c:1646  */
    {
    this_log->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &this_log->n);
  }
#line 13213 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 42 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 13219 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 43 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 13225 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 48 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { this_log->limit = (yyvsp[-1].i); this_log->backup = (yyvsp[0].t); }
#line 13231 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 52 "sysdep/unix/config.Y" /* yacc.c:1646  */
    {
     if (!parse_and_exit)
     {
       this_log->rf = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[-1].t));
       this_log->fh = rf_file(this_log->rf);
     }
     this_log->pos = -1;
     this_log->filename = (yyvsp[-1].t);
   }
#line 13246 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 62 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { this_log->fh = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 13252 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 63 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { this_log->fh = stderr; }
#line 13258 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 67 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 13264 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 68 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 13270 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 72 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 13276 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 73 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 13282 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 77 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 13288 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 78 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 13294 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 79 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 13300 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 80 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 13306 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 81 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 13312 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 82 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 13318 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 83 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 13324 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 84 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 13330 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 85 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 13336 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 92 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 13342 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 93 "sysdep/unix/config.Y" /* yacc.c:1646  */
    {
     if (!parse_and_exit)
     {
       struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
       new_config->mrtdump_file = rf_fileno(f);
     }
   }
#line 13355 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 107 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 13361 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 108 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].time); }
#line 13367 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 109 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].time); }
#line 13373 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 110 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 13379 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 119 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 13385 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 122 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 13391 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 129 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 13397 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 132 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 13403 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 135 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_reconfig_status(); }
#line 13409 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 138 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 13415 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 141 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 13421 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 146 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { cmd_graceful_restart(); }
#line 13427 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 150 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 13433 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 155 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 13439 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 156 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 13445 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 157 "sysdep/unix/config.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 13451 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 43 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 13459 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 52 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 13465 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 53 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 13471 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 58 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 13477 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 59 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 13483 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 60 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 13492 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 64 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 13504 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 71 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 13510 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 72 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 13522 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 85 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 13528 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 94 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 13537 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 101 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 13547 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 108 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { kif_set_preferred((yyvsp[0].a)); }
#line 13553 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 125 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); }
#line 13559 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 126 "sysdep/unix/krt.Y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); }
#line 13565 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 13569 "obj/conf/cf-parse.tab.c" /* yacc.c:1646  */
        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyesa, &yyes, &yyes_capacity, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 50 "conf/gen_parser.m4" /* yacc.c:1906  */

#line 387 "conf/confbase.Y"
/* C Code from conf/confbase.Y */

#line 206 "conf/flowspec.Y"
/* C Code from conf/flowspec.Y */

#line 927 "nest/config.Y"
/* C Code from nest/config.Y */

#line 187 "proto/bfd/config.Y"
/* C Code from proto/bfd/config.Y */

#line 182 "proto/babel/config.Y"
/* C Code from proto/babel/config.Y */

#line 351 "proto/bgp/config.Y"
/* C Code from proto/bgp/config.Y */

#line 66 "proto/mrt/config.Y"
/* C Code from proto/mrt/config.Y */

#line 562 "proto/ospf/config.Y"
/* C Code from proto/ospf/config.Y */

#line 59 "proto/perf/config.Y"
/* C Code from proto/perf/config.Y */

#line 46 "proto/pipe/config.Y"
/* C Code from proto/pipe/config.Y */

#line 342 "proto/radv/config.Y"
/* C Code from proto/radv/config.Y */

#line 205 "proto/rip/config.Y"
/* C Code from proto/rip/config.Y */

#line 147 "proto/rpki/config.Y"
/* C Code from proto/rpki/config.Y */

#line 163 "proto/static/config.Y"
/* C Code from proto/static/config.Y */

#line 66 "sysdep/linux/netlink.Y"
/* C Code from sysdep/linux/netlink.Y */

#line 160 "sysdep/unix/config.Y"
/* C Code from sysdep/unix/config.Y */

#line 128 "sysdep/unix/krt.Y"
/* C Code from sysdep/unix/krt.Y */

